/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    File        :    router_dpr.c

    Date        :    04-12-1994
    Version     :    1.0

    Auteur      :    BEAURIN oliver

    Description :    Main routines for datapath router

\*********************************************************************/

/*---------------------------------------------------------\
                     includes
\---------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>

#include MUT_H
#include MLO_H
#include MPH_H

#include "dpr.h"
#include "router_dpr.h"
#include "router_load.h"

/*---------------------------------------------------------\
                     router
\---------------------------------------------------------*/
void router ( source, result, optim_op3 )
char *source;
char *result;
int   optim_op3;
{
	FIGURE         *ptfig_dpr;
	NUMTRACK       *ptlist_num;
	long            t1 = 0, t2 = 0;
	int             option_o = TRUE;
	int             option_h = FALSE;

    fprintf( stdout, " * Routing step.\n" );
    if( verbose_mode )
    {
        t1 = time (&t1);
    }
    ptfig_dpr = loaddprfig (source);
    if (optim_op3 == TRUE)
    {
        (void) optiplace (ptfig_dpr);
        if( verbose_mode )
        {
            fprintf( stdout, "   o Finishing data structure.\n" );
        }
    }
    dprlin (ptfig_dpr);
    placeconpere (ptfig_dpr);

    dprrout (ptfig_dpr, option_o);
    dprchannel (ptfig_dpr, &ptlist_num);
    dprsave (ptfig_dpr, result, ptlist_num, option_h);

    if( verbose_mode )
    {
        t2 = time (&t2);
        fprintf( stdout, "   o Total routing time: %ld seconds.\n", t2-t1 );
        fflush( stdout );
    }
    fprintf( stdout, " * Routing step done.\n" );

}
