/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    Fichier     :    strecher_support.h

    Date        :    12 octobre 1995
    Version     :    2.0

    Auteur      :    CHAPUT Jean-Paul
    Modifie par :    BEAURIN Oliver

\*********************************************************************/

#ifndef SUPPORT_H
#define SUPPORT_H

#define DEBUG(n,t)    {if((getenv("DEBUG_STRECHER"))&&(atoi(getenv("DEBUG_STRECHER"))>=n)) {printf( t );}}
#define DEBUG2(n,t,p) {if((getenv("DEBUG_STRECHER"))&&(atoi(getenv("DEBUG_STRECHER"))>=n)) {printf( t, p );}}

#define  lambda_modulo( value)                  \
             ( ((value)%SCALE_X) ? SCALE_X : 0 )
#define  lambda_floor(  value)  ( (value)-(value)%SCALE_X )
#define  lambda_ceil(   value)                           \
             ( (value)-(value)%SCALE_X                   \
                   +( ((value)%SCALE_X) ? SCALE_X : 0 ) )
#define  mc_frmult( value, numerat, denom)  \
             ( ((value)*(numerat))/(denom) )
#define  mc_lambdatosx(fvalue)        \
             ((long)( (fvalue)*((float)SCALE_X) ))
#define  mc_IsHor(TypeDir)            \
             ( (  (TypeDir ==  LEFT)  \
                ||(TypeDir == RIGHT)) ? 1 : 0 )
#define  mc_IsVer(TypeDir)            \
             ( (  (TypeDir ==    UP)  \
                ||(TypeDir ==  DOWN)) ? 1 : 0 )


#define  FALSE           0
#define   TRUE           1

#define  M_SUPP_TITLECMA             2
#define  M_SUPP_NAMECMA              3
#define  M_SUPP_TITLESTC             4
#define  M_SUPP_CUTPOS               5
#define  M_SUPP_NWELLSTC             6
#define  M_SUPP_TITLETRS             7
#define  M_SUPP_SAVEGAB              8
#define  M_SUPP_SAVECELL             9
#define  M_SUPP_LOADBLOCK           10
#define  M_SUPP_SEARCHCUT           11
#define  M_SUPP_CUTLINES            12
#define  M_SUPP_ALLOWEDCUT          13
#define  M_SUPP_ASKYCUT             14
#define  M_SUPP_ASKPITCHNB          15
#define  M_SUPP_GET_HR_PHFIG        16
#define  M_SUPP_EXTRACT_HR_ALLOWED  17
#define  M_SUPP_ALLOC_HR_DTDUPL     18
#define  M_SUPP_STRECH_HR_DTDUPL    19
#define  M_SUPP_EXTRACT_HR_CMA      20
#define  M_SUPP_ALLOC_HR_TALU       21
#define  M_SUPP_MODIFY_HR_TALU      22
#define  M_SUPP_ADD_HR_THROUGH      23
#define  M_SUPP_CLEAN_LN_THROUGH    24
#define  M_SUPP_SAVE_LN_DTDUPL      25

#define  F_SUPP_UCREAT      1L
#define  F_SUPP_UKEEP       2L

#define  C_SUPP_UCMA        256L
#define  C_SUPP_UTALU1      257L
#define  C_SUPP_UTALU2      258L
#define  C_SUPP_UMODLPOS    259L
#define  C_SUPP_ULASTPOS    260L
#define  C_SUPP_UALLOWED    261L
#define  C_SUPP_USUPPLY     262L

#define  PTYPE_LSEG           1L
#define  PTYPE_LREF           2L
#define  PTYPE_XSEGPOL        3L

#define  MAX_USER_TDUPL      32L
#define  MBK_SZ_NAME         65


extern long     SCALE_X;
extern long     SX_WIDTH_VSS, SX_WIDTH_VDD, SX_WIDTH_TALU1, SX_WIDTH_TALU2, SX_DIST_ALU1, SX_DIST_ALU2, SX_SIDE_VIA1, SX_SIDE_VIA2, SX_SIDE_DIFF, SX_PITCH_TALU2, SX_PITCH_TALU1, SX_XTRANS;


/* Initialisation des regles de dessin. */
extern void     set_vrd_rules();

/* Manipulation du layout symbolique. */
extern long     isconnect();
extern char    *getrefconname();

/* Manipulation des listes chainees des "ptfig". */
extern ptype_list *addoptype();
extern ptype_list *get_ls_data();
extern ptype_list *del_ls_data();
extern long     set_user_dup();
extern void     dupuser();
extern void     dupphfig();

/* Affichages des messages d'erreurs et d'avertissements. */
extern void     fc_printerror();
extern void     fc_printwarn();

#endif                          /* SUPPORT_H */
