/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    Fichier     :    strecher_vrdrules.h

    Date        :    12 octobre 1995
    Version     :    2.0

    Auteur      :    CHAPUT Jean-Paul
    Modifie par :    BEAURIN Oliver

\*********************************************************************/

#ifndef VRDRULES_H
#define VRDRULES_H

/* Parametres caracterisants la geometrie de la cellule standart
   et les regles de dessin ( a fournir en LAMBDAS ). */

#define        WIDTH_VDD             6.0
#define        WIDTH_VSS             8.0
#define        WIDTH_TALU1           1.0
#define        WIDTH_TALU2           2.0
#define        DIST_ALU1             2.5
#define        DIST_ALU2             2.0
#define        SIDE_VIA1             2.0
#define        SIDE_VIA2             3.0
#define        SIDE_DIFF             3.0
#define        PITCH_TALU2         ( SIDE_VIA2+DIST_ALU2 )
#define        XTRANS_MIN            3.0
#endif                          /* VRDRULES_H */
