/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*------------------------------------------------------------\
|                                                             |
| Tool    :                   DREAL                           |
|                                                             |
| File    :                  Colors.c                         |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                  28.03.95                         |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <Xm/Xm.h>
 
# include MUT_H
# include MPH_H
# include RDS_H
# include RPR_H
# include RDS_H
# include GSB_H
# include GMX_H
# include "GMX_color.h" 

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  GC   DrealLayerFillGC   [ RDS_ALL_LAYER ];
  GC   DrealLayerDrawGC   [ RDS_ALL_LAYER ];
  GC   DrealLayerAcceptGC [ RDS_ALL_LAYER ];
  GC   DrealAcceptDrawGC;
  GC   DrealBackgroundGC;
  GC   DrealGridGC;
  GC   DrealSmallTextGC;
  GC   DrealMediumTextGC;
  GC   DrealLargeTextGC;
  GC   DrealXorGC;

  XFontStruct *DrealLargeTextFont;
  XFontStruct *DrealMediumTextFont;
  XFontStruct *DrealSmallTextFont;

/*------------------------------------------------------------\
|                                                             |
|                      Layer Color Define                     |
|                                                             |
\------------------------------------------------------------*/

  static char DrealLayerPatternDefine[ RDS_ALL_LAYER ] =

  {
      0,  /* RDS_NWELL  */
      0,  /* RDS_PWELL  */
      0,  /* RDS_NIMP   */
      0,  /* RDS_PIMP   */
      0,  /* RDS_ACTIV  */
      1,  /* RDS_NDIF   */
      1,  /* RDS_PDIF   */
      1,  /* RDS_NTIE   */
      1,  /* RDS_PTIE   */
      3,  /* RDS_POLY   */
      3,  /* RDS_VPOLY  */
      2,  /* RDS_GATE   */
      3,  /* RDS_TPOLY  */
      3,  /* RDS_POLY2  */
      5,  /* RDS_CONT   */
      5,  /* RDS_TCONT  */
      5,  /* RDS_CONT2  */
      4,  /* RDS_ALU1   */
      4,  /* RDS_VALU1  */
      4,  /* RDS_TALU1  */
      5,  /* RDS_VIA1   */
      5,  /* RDS_TVIA1  */
      6,  /* RDS_ALU2   */
      6,  /* RDS_VALU2  */
      6,  /* RDS_TALU2  */
      5,  /* RDS_VIA2   */
      5,  /* RDS_TVIA2  */
      8,  /* RDS_ALU3   */
      8,  /* RDS_VALU3  */
      8,  /* RDS_TALU3  */
      5,  /* RDS_VIA3   */
      5,  /* RDS_TVIA3  */
      9,  /* RDS_ALU4   */
      7,  /* RDS_CPAS   */
      7,  /* RDS_REF    */
      0,  /* RDS_USER0  */
      0,  /* RDS_USER1  */
      0,  /* RDS_USER2  */
      0   /* RDS_ABOX   */
  };

  static char DrealPatternBits[ DREAL_MAX_PATTERN ][ DREAL_PATTERN_SQUARE ] =

  {                             /* FOR SUBST */
    { 
      0x7f, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xf7, 0xff, 0xff,
      0xff, 0xff, 0xff, 0xff, 0x7f, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
      0xf7, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
    }
    ,                           /* FOR DIF   */
    { 
      0x77, 0x77, 0xbb, 0xbb, 0xdd, 0xdd, 0xee, 0xee, 0x77, 0x77, 0xbb, 0xbb,
      0xdd, 0xdd, 0xee, 0xee, 0x77, 0x77, 0xbb, 0xbb, 0xdd, 0xdd, 0xee, 0xee,
      0x77, 0x77, 0xbb, 0xbb, 0xdd, 0xdd, 0xee, 0xee
    }
    ,                           /* FOR GATE  */
    {
      0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55,
      0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55,
      0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55
    }
    ,                           /* FOR POLY  */
    { 
      0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa,
      0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa,
      0x55, 0x55, 0xaa, 0xaa, 0x55, 0x55, 0xaa, 0xaa
    }
    ,                           /* FOR ALU1  */
    { 
      0x88, 0x88, 0x44, 0x44, 0x22, 0x22, 0x11, 0x11, 0x88, 0x88, 0x44, 0x44,
      0x22, 0x22, 0x11, 0x11, 0x88, 0x88, 0x44, 0x44, 0x22, 0x22, 0x11, 0x11,
      0x88, 0x88, 0x44, 0x44, 0x22, 0x22, 0x11, 0x11
    }
    ,                           /* FOR CONT  */
    { 
      0x55, 0x55, 0xff, 0xff, 0x55, 0x55, 0xff, 0xff, 0x55, 0x55, 0xff, 0xff,
      0x55, 0x55, 0xff, 0xff, 0x55, 0x55, 0xff, 0xff, 0x55, 0x55, 0xff, 0xff,
      0x55, 0x55, 0xff, 0xff, 0x55, 0x55, 0xff, 0xff
    }
    ,                           /* FOR ALU2  */
    { 
      0x11, 0x11, 0x00, 0x00, 0x44, 0x44, 0x00, 0x00, 0x11, 0x11, 0x00, 0x00,
      0x44, 0x44, 0x00, 0x00, 0x11, 0x11, 0x00, 0x00, 0x44, 0x44, 0x00, 0x00,
      0x11, 0x11, 0x00, 0x00, 0x44, 0x44, 0x00, 0x00
    }
    ,                           /* FOR REF   */
    { 
      0xaa, 0xaa, 0x11, 0x11, 0xaa, 0xaa, 0x44, 0x44, 0xaa, 0xaa, 0x11, 0x11,
      0xaa, 0xaa, 0x44, 0x44, 0xaa, 0xaa, 0x11, 0x11, 0xaa, 0xaa, 0x44, 0x44,
      0xaa, 0xaa, 0x11, 0x11, 0xaa, 0xaa, 0x44, 0x44
    }
    ,                           /* FOR ALU3  */
    {
      0x44, 0x44, 0x00, 0x00, 0x11, 0x11, 0x00, 0x00, 0x44, 0x44, 0x00, 0x00,
      0x11, 0x11, 0x00, 0x00, 0x44, 0x44, 0x00, 0x00, 0x11, 0x11, 0x00, 0x00,
      0x44, 0x44, 0x00, 0x00, 0x11, 0x11, 0x00, 0x00
    } 
    ,                           /* FOR ALU4  */
    { 
      0x00, 0x00, 0x22, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22,
      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x00, 0x00, 0x00, 0x00,
      0x00, 0x00, 0x22, 0x22, 0x00, 0x00, 0x00, 0x00
    }
  };

  static Pixmap DrealPattern[ DREAL_MAX_PATTERN ];

  static char  *DrealColorName[ 5 ] =

  {
    DREAL_BLACK_COLOR,
    DREAL_WHITE_COLOR,
    DREAL_TEXT_COLOR ,
    DREAL_ACCEPT_COLOR,
    DREAL_CURSOR_COLOR
  };

  static int DrealColor[ DREAL_MAX_COLOR ];

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                     DrealInitializeColors                   |
|                                                             |
\------------------------------------------------------------*/

void DrealInitializeColors()

{
  XColor   ForgetIt;
  XColor   GetIt;
  Window   Root;
  int      Counter;
  Colormap ColorMap;
  char     Error;
  char    *ColorName;

  rdsbegin();

  if ( DREAL_CURSOR_COLOR_NAME != (char *)NULL )
  {
    DrealColorName[ 4 ] = DREAL_CURSOR_COLOR_NAME;
  }

  ColorMap  = DefaultColormapOfScreen ( XtScreen ( DrealGraphicWindow ) );
  Error     = False;

  for ( Counter = 0; Counter < DREAL_MAX_COLOR; Counter++ )
  {
    if ( Counter >= 5 )
    {
      ColorName = DREAL_RDS_LAYER_NAME_TABLE[ Counter - 5 ][ 1 ];
    }
    else
    {
      ColorName = DrealColorName[ Counter ];
    }

    if ( ColorName != (char *)NULL )
    {
      if ( ! XAllocNamedColor( DrealGraphicDisplay,
                               ColorMap, ColorName, 
                              &GetIt, &ForgetIt ) ) 
      {
        fprintf ( stderr, "\nGmx101: Color name '%s' is not in X11 database !\n",
                          ColorName );

        Error = True;
      }

      DrealColor[ Counter ] = GetIt.pixel;
    }
    else 
    {
      DrealColor[ Counter ] = DrealColor[ 0 ];
    }
  }

  if ( Error == True ) exit( 1 );

  Root = RootWindowOfScreen ( XtScreen ( DrealGraphicWindow ) );

  for ( Counter = 0; Counter < DREAL_MAX_PATTERN; Counter++ )
  {
    DrealPattern[ Counter ]  =

      XCreateBitmapFromData( DrealGraphicDisplay,
                             Root,
                             DrealPatternBits[ Counter ],
                             DREAL_PATTERN_WIDTH,
                             DREAL_PATTERN_HEIGHT );
  }

  rdsend();
}

/*------------------------------------------------------------\
|                                                             |
|                 DrealInitializeGraphicContext               |
|                                                             |
\------------------------------------------------------------*/

void DrealInitializeGraphicContext()

{
  XGCValues GraphicValue;
  int       Counter;
  Window    Root;
  char      Pattern;

  rdsbegin();

  DrealLargeTextFont = XLoadQueryFont( DrealGraphicDisplay,
                                       DREAL_LARGE_TEXT_FONT_NAME );

  DrealMediumTextFont = XLoadQueryFont( DrealGraphicDisplay,
                                        DREAL_MEDIUM_TEXT_FONT_NAME );

  DrealSmallTextFont = XLoadQueryFont( DrealGraphicDisplay,
                                       DREAL_SMALL_TEXT_FONT_NAME );

  GraphicValue.foreground = DrealColor[ 0 ];  /* Black */
  GraphicValue.background = DrealColor[ 0 ];
  GraphicValue.plane_mask = AllPlanes;

  Root = RootWindowOfScreen ( XtScreen ( DrealGraphicWindow ) ),

  DrealBackgroundGC = XCreateGC ( DrealGraphicDisplay,
                                  Root,
                                  ( GCForeground |
                                    GCBackground |
                                    GCPlaneMask ),
                                    &GraphicValue );

  GraphicValue.foreground = DrealColor[ 1 ];  /* White */

  DrealGridGC = XCreateGC ( DrealGraphicDisplay,
                            Root,
                            ( GCForeground |
                              GCBackground |
                              GCPlaneMask ),
                              &GraphicValue );

  GraphicValue.foreground = DrealColor[ 3 ];
 
  DrealAcceptDrawGC = XCreateGC ( DrealGraphicDisplay,
                                 Root,
                                 ( GCForeground |
                                   GCBackground |
                                   GCPlaneMask ),
                                  &GraphicValue );

  GraphicValue.foreground = DrealColor[ 2 ];  /* Text  */

  DrealSmallTextGC = XCreateGC ( DrealGraphicDisplay,
                                 Root,
                                 ( GCForeground |
                                   GCBackground |
                                   GCPlaneMask ),
                                   &GraphicValue );

  DrealMediumTextGC = XCreateGC ( DrealGraphicDisplay,
                                  Root,
                                  ( GCForeground |
                                    GCBackground |
                                    GCPlaneMask ),
                                   &GraphicValue );

  DrealLargeTextGC = XCreateGC ( DrealGraphicDisplay,
                                 Root,
                                 ( GCForeground |
                                   GCBackground |
                                   GCPlaneMask ),
                                  &GraphicValue );

  XSetFont( DrealGraphicDisplay,
            DrealSmallTextGC, DrealSmallTextFont->fid );

  XSetFont( DrealGraphicDisplay,
            DrealMediumTextGC, DrealMediumTextFont->fid );

  XSetFont( DrealGraphicDisplay,
            DrealLargeTextGC, DrealLargeTextFont->fid );

  GraphicValue.background = DrealColor[ 4 ];  /* Xor Color */
  GraphicValue.foreground = DrealColor[ 4 ];  /* Xor Color */
  GraphicValue.function   = GXxor;

  DrealXorGC = XCreateGC ( DrealGraphicDisplay,
                           Root,
                           ( GCForeground |
                             GCBackground |
                             GCFunction   |
                             GCPlaneMask ),
                             &GraphicValue );

  GraphicValue.background = DrealColor[ 0 ];  /* Black */
  GraphicValue.foreground = DrealColor[ 1 ];  /* White */

  for ( Counter = 0; Counter < RDS_ALL_LAYER; Counter++ )
  {
    if ( DREAL_RDS_LAYER_NAME_TABLE[ Counter ][ 0 ] != (char *)NULL )
    {
      Pattern = DrealLayerPatternDefine[ Counter ];
  
      GraphicValue.stipple    = DrealPattern[ Pattern ];
      GraphicValue.fill_style = FillStippled;
      GraphicValue.foreground = DrealColor[ 3 ];
  
      DrealLayerAcceptGC[ Counter ] =
  
           XCreateGC ( DrealGraphicDisplay,
                                  Root,
                                  ( GCStipple    |
                                    GCForeground |
                                    GCBackground |
                                    GCFillStyle  |
                                    GCPlaneMask  ),
                                  &GraphicValue  );
  
      GraphicValue.foreground = DrealColor[ Counter + 5 ];
  
      DrealLayerFillGC[ Counter ] = 
  
           XCreateGC ( DrealGraphicDisplay,
                                  Root,
                                  ( GCStipple    | 
                                    GCForeground |
                                    GCBackground |
                                    GCFillStyle  | 
                                    GCPlaneMask  ),
                                  &GraphicValue  );
  
      DrealLayerDrawGC[ Counter ] = 
  
           XCreateGC ( DrealGraphicDisplay,
                                  Root,
                                  ( GCForeground |
                                    GCBackground |
                                    GCPlaneMask  ),
                                  &GraphicValue  );
  
    }
  }

  rdsend();
} 
