/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*------------------------------------------------------------\
|                                                             |
| Tool    :                    DRUC                           |
|                                                             |
| File    :                  DEFINCLU.C                       |
|                                                             |
| Authors :                Renaud Patrick                     |
|                                                             |
| Date    :                   26/07/94                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include MPH_H
#include MUT_H
#include RDS_H
#include RUT_H
#include RTL_H
#include RWI_H
#include RFM_H
#include RPR_H

#include "drucutil.h"
#include "vmctools.h"
#include "deftools.h"
#include "definclu.h"
/*------------------------------------------------------------\
|                                                             |
|                       DefInclu Fonctions                    |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         DrucDefineInclusion                 |
| Definit un layer temporaire caracterise par l'operateur     |
| contenu dans l'instruction ayant les deux layers source     |
| comme operandes                                             |
| range le resultat dans le tableau des layers userdefini par |
| l'instruction                                               |
\------------------------------------------------------------*/

void DrucDefineInclusion ( DrucFigureRds,
                           DrucRdsWindow,
                           DrucInstructionCourante
                         )
     rdsfig_list               *DrucFigureRds;
     rdswindow                 *DrucRdsWindow;
     DrucTypeStructInstruction *DrucInstructionCourante;

{

         rdsrec_list     *TmpRectangleSource;
         rdsrecwin_list  *TmpWindowSource2;
register int              TabIndex2;
register rdswinrec_list  *TabRectangleSource2 = NULL;

  for ( TmpRectangleSource  = DrucFigureRds->LAYERTAB [ DrucInstructionCourante->LAYER_1 ];
        TmpRectangleSource != (rdsrec_list *)NULL;
        TmpRectangleSource  = TmpRectangleSource->NEXT
      )
  {
   /*\
    *  recuperer toutes les fenetres liees au rectangle, marquer le rectangle visite
   \*/
    TmpWindowSource2 = DrucChercheWindow ( TmpRectangleSource
                                         );
    /*\
     * parcours de chaque fenetre
    \*/
    while ( TmpWindowSource2 != (rdsrecwin_list *)NULL
          )
    {
      TabRectangleSource2 = ( TmpWindowSource2->WINDOW )->LAYERTAB
                                 [ DrucInstructionCourante->LAYER_2 ];
      /*\
       * parcours des tableaux de la fenetre du layer 1
      \*/
      while ( TabRectangleSource2 != (rdswinrec_list *)NULL
            )
      {
        /*\
         * parcourir tous les rectangles du layer 1
        \*/
        TabIndex2 = 0;

        while ( TabIndex2 < RWI_MAX_REC
              )
        {
          if ( MACRO_RECT_SOURCE2 [ TabIndex2 ] != ( rdsrec_list *)NULL )
          {
            DrucInclusionRectangle ( DrucFigureRds,
                                     DrucRdsWindow,
                                     DrucInstructionCourante,
                                     TmpRectangleSource,
                                     MACRO_RECT_SOURCE2 [ TabIndex2 ]
                                   );
          }

          TabIndex2 ++;
        } /* while les rectangles d'un tableau du layer 2 */
        TabRectangleSource2 = TabRectangleSource2->NEXT;
      } /* while les tableaux du layer 2 */
      TmpWindowSource2 = TmpWindowSource2->NEXT;
    } /* while les fenetres du layer 2 */
  } /* for des rectangles du layer 1 */
}
