/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*------------------------------------------------------------\
|                                                             |
| Tool    :                    DRUC                           |
|                                                             |
| File    :                  DRUCGRAL_TEST.C                  |
|                                                             |
| Authors :                Renaud Patrick                     |
|                                                             |
| Date    :                   11/01/94                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include MPH_H
#include MUT_H
#include RDS_H
#include RUT_H
#include RTL_H
#include RWI_H
#include RFM_H
#include RPR_H

#include "drucutil.h"
#include "vmctools.h"
#include "vmcerror.h"
#include "druchier.h"
#include "vmcasmld.h"
#include "vmcaract.h"
#include "defdefin.h"
#include "vmcrelat.h"
#include "drucmin.h"
#include "vmcunify.h"
#include "drucring.h"

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

extern rdsfig_list   *DrucFigureRdsErreur;

/*------------------------------------------------------------\
|                                                             |
|                             Main                            |
|                                                             |
\------------------------------------------------------------*/
void main (argc , argv )
     int   argc;
     char *argv[];
{
phfig_list                *DrucFigureMbk;
rdsfig_list               *DrucFigureRds;
rdswindow                 *DrucRdsWindow;
char                      *Name;
char                      *DrucFigureName;
char                      *DrucErrorName           = (char *)NULL;
char                      *DrucCouronneRdsName;
char                      *DrucNetworkName;
DrucTypeStructInstruction *DrucTabInstruction      = ( DrucTypeStructInstruction *)NULL;
int                        DrucNombreInstructions;
int                        IndexLayer;
int                        Resultat;

/*\
 *  lecture des parametres d'entree
\*/
  if ( argc != 2 
     )
  {
    printf         ( "Usage : %s figure_name (without extention)\n",argv [0]
                   );
    exit           ( 1
                   );
  }

/*\
 *  affichage de la banniere standard
\*/
  alliancebanner     ( "DRCGraL", 
                        VERSION, 
                       "Design Rule Checker", 
                       "1993", 
                        ALLIANCE_VERSION
                     );
  DrucStatInit       ( DRUC_FLATTEN,
                       DRUC_SILENT,
                       DRUC_SILENT,
                       DRUC_NO_ERROR_FILE
                     );

  Name               = argv [ 1 ];

  DrucFigureName     = namealloc ( Name 
                                );

  Name               = malloc ( strlen ( DrucFigureName )    +
                                strlen ( DRUC_ERROR_EXTEND) +
                                1
                              );

  strcpy             ( Name ,
                       DrucFigureName
                     );
  strcat             ( Name,
                       DRUC_ERROR_EXTEND
                     );

  DrucErrorName      = namealloc ( Name 
                                 );
  
  free               ( Name
                     );
  mbkenv             (
                     );
  rdsenv             (
                     );
  loadrdsparam       (
                     );
  DrucFigureMbk      = getphfig ( DrucFigureName,
                                'A'
                                );

  DrucViewString     ( "Flatten DRC on: "
                     );
  DrucViewString     ( DrucFigureName
                     );
  DrucViewString     ( "\n"
                     );
  rflattenphfig      ( DrucFigureMbk,
                       YES,
                       NO
                     );
  DrucFigureRds      = figmbkrds ( DrucFigureMbk,
                               MACRO_PLUS_TAILLE,
                               0
                             );

  DrucViewString      ( "Delete MBK figure : "
                      );
  DrucViewString      ( DrucFigureName
                      );
  DrucViewString      ( "\n"
                      );

  delphfig            ( DrucFigureName
                      );

  DrucViewString      ( "Load Flatten Rules : "
                      );
  DrucViewString      ( RDS_TECHNO_NAME
                      );
  DrucViewString      ( "\n"
                      );

  DrucOpenErrorFile   ( DrucErrorName,
                        "w"
                      );
  DrucFigureRdsErreur = drucrdsfig ( DrucFigureRds,
                                     DrucErrorName
                                   );

  DrucStatInit     ( DRUC_FLATTEN,
                     DRUC_VERBOSE,
                     DRUC_NO_ERROR_FILE
                   );
  viewrdsfig       ( DrucFigureRdsErreur
                   );
  DrucViewString   ( "\n"
                   );
  DrucViewRuleComment (
                      );
  DrucViewString   ( "\nnombre d'erreurs rencontrees = valeur de sortie: "
                   );
  DrucViewNumber   ( DrucStructStat.ERROR_NUMBER
                   );
  DrucViewString   ( "\n"
                   );
  exit             ( DrucStructStat.ERROR_NUMBER 
                   );
}



