/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*------------------------------------------------------------\
|                                                             |
| Tool    :                     DRUC                          |
|                                                             |
| File    :                  DRUCHIER.H                       |
|                                                             |
| Authors :                Patrick Renaud                     |
|                                                             |
| Date    :                   11/01/94                        |
|                                                             |
| Modifications:  voir fin de fichier                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                  DrucHier    Types                          |
|                                                             |
\------------------------------------------------------------*/
typedef struct struct_trans_equiv
               {
                 int LAYER_INDEX;
                 int LAYER_TRANSPARENCE;
               }DrucTypeStructTransEquiv;

typedef struct struct_virtuel_equiv
               {
                 int LAYER_INDEX;
                 int LAYER_VIRTUEL;
               }DrucTypeStructVirtuEquiv;

/*------------------------------------------------------------\
|                                                             |
|                  DrucHier    Defines                        |
|                                                             |
\------------------------------------------------------------*/
#define DRUC_MAX_VIRTUELS                                    1
#define DRUC_MAX_TRANSPARENCES                               4
#define DRUC_BBOX                                    RDS_USER2
/*------------------------------------------------------------\
|                                                             |
|                  DrucHier    Variables                      |
|                                                             |
\------------------------------------------------------------*/
extern DrucTypeStructTransEquiv         TabTransEquivalence [];
extern DrucTypeStructVirtuEquiv         TabVirtuEquivalence [];

/*------------------------------------------------------------\
|                                                             |
|                  DrucHier    Modifications                  |
|                                                             |
| Patrick 31/03/94:                                           |
|   ligne 36                                                  |
|   ajouter extern au tableau DrucTypeStructTransEquiv        |
|                                                             |
\------------------------------------------------------------*/
