/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*------------------------------------------------------------\
|                                                             |
| Tool    :                    DRUC                           |
|                                                             |
| File    :                  DRUCMIN.C                        |
|                                                             |
| Authors :                Renaud Patrick                     |
|                                                             |
| Date    :                   03/07/95                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include MPH_H
#include MUT_H
#include RDS_H
#include RUT_H
#include RTL_H
#include RWI_H
#include RFM_H
#include RPR_H

#include "drucutil.h"
#include "vmctools.h"
#include "vmcerror.h"
#include "vmcasmld.h"
#include "vmcaract.h"
#include "defdefin.h"
#include "vmcrelat.h"
#include "drucmin.h"

/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Fonctions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         DrucMin                             |
|                                                             |
\------------------------------------------------------------*/

void DrucMin ( DrucFigureRds,
               DrucRdsWindow,
               DrucTabInstruction ,
               DrucNombreInstructions
             )
     rdsfig_list               *DrucFigureRds;
     rdswindow                 *DrucRdsWindow;
     DrucTypeStructInstruction *DrucTabInstruction;
     int                        DrucNombreInstructions;

{

int             InstructionCourante;

DrucViewString ( "instructionCourante : 000"
               );

/*\
 * cette sauvegarde est pour cacher des pb de compilation de graal
 * enlever quand graal link correctement
 * saverdsfig ( DrucFigureRds
 *            );
\*/

  for ( InstructionCourante = 0;
        InstructionCourante != DrucNombreInstructions;
        InstructionCourante = InstructionCourante + 1
      )
  {

    DrucViewString       ( "\b\b\b"
                         );
    DrucViewNumber       ( InstructionCourante
                         );

/*\
  DrucViewInstruction ( DrucTabInstruction [InstructionCourante]
                      );
\*/

    if ( MACRO_REGLE_COURANTE.LAYER_1 == DRUC_UNDEFINED_LAYER 
       )
    {
/*\
 * DrucViewString ("\ninstruction non verifiee\n)");
\*/
      continue;
    }

    switch ( MACRO_REGLE_COURANTE.INSTRUCTION 
           )
    {
    case  DRUC_ASM_BEGIN_REGLE :
      {
        switch ( MACRO_REGLE_COURANTE.OP_COMPOSE 
               )
        {
        case DRUC_INSTR_RELATION :
          {
            DrucRelation (   DrucFigureRds,
                             DrucRdsWindow,
                           & MACRO_REGLE_COURANTE
                         );
            break;
          }
        case DRUC_INSTR_CARACTERISE :
          {

            DrucCaracterise (   DrucFigureRds,
                              & MACRO_REGLE_COURANTE
                            );
            break;
          }
        }
        break;
      }
    case  DRUC_ASM_BEGIN_DEFINE :
      {
        DrucDefine (   DrucFigureRds,
                       DrucRdsWindow ,
                     & MACRO_REGLE_COURANTE
                   );
        break;
      }
    case  DRUC_ASM_BEGIN_UNDEFINE:
      {
        DrucUndefine (   DrucFigureRds,
                         DrucRdsWindow,
                       & MACRO_REGLE_COURANTE
                     );
        break;
      }
    }/* switch */
  }/* for InstructionCourante */

DrucViewString ( "\n"
               );

/*\
saverdsfig (DrucFigureRds);
\*/
}/* DrucVerif */
