/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */



/* $Id: FpGenMBK.h,v 1.10 1997/10/30 13:27:48 fitpath Exp fitpath $ */
/*          Alliance CAD System 3.2b                               */
/*             FpGen Package 1.10                                 */
/*                                                                */
/*  Copyright(c) 93-97, MASI, CAO-VLSI Team                       */
/*                                                                */
/*  Author      :          Jean-Paul CHAPUT                       */
/*  E-mail      :      cao-vlsi@masi.ibp.fr                       */
/* ************************************************************** */
/*  Header      :      "FpGenMBK.h"                               */


# ifndef  __FpGenMBK__
#   define  __FpGenMBK__
/* Definition of error constants of module. */
#   define        E_FgnMBK_DEFLOWidthMax                 2
#   define        E_FgnMBK_DEFLOWidthEven                3
#   define        E_FgnMBK_DEFLOLsbPos                   4
#   define        E_FgnMBK_DEFLOCall                     5
#   define        E_FgnMBK_DEFLOBadType                  6

#   define        E_FgnMBK_SAVLOCall                    20
#   define        E_FgnMBK_SAVLOMissVDD                 21
#   define        E_FgnMBK_SAVLOMissVSS                 22

#   define        E_FgnMBK_LOCONBadSide                 40
#   define        E_FgnMBK_LOCONPOWERDuplicate          41
#   define        E_FgnMBK_LOCONPOWERBadNamePower       42

#   define        E_FgnMBK_CONMODEUnknow                60

#   define        E_FgnMBK_GenericMFIdent               80
#   define        E_FgnMBK_GenericMFMissName            81
#   define        E_FgnMBK_GenericMFWidth               82
#   define        E_FgnMBK_GenericMFSlice               83
#   define        E_FgnMBK_GenericMFDrive               84
#   define        E_FgnMBK_GenericMFWords               85

#   define        E_FgnMBK_SharedMissDefLo             100
#   define        E_FgnMBK_SharedBusName               101

#   define        E_FgnMBK_NameToSigCtrlData           120
#   define        E_FgnMBK_NameToSigCtrlCtrl           121

#   define        E_FgnMBK_MatchInterfNoMoreCon        140
#   define        E_FgnMBK_MatchInterfNoMoreSig        141

#   define        E_FgnMBK_ImportGlueCPC               160
#   define        E_FgnMBK_ImportGluePlaceFunc         161


/* Definition of warning constants of module. */
#   define        W_FgnMBK_DEFLOMbkSepar                 2
#   define        W_FgnMBK_DEFLOMbkInOutPH               3


/* Definition of normal constants of module. */
#   define        C_FgnMBK_FuncNameMaxLen          256

#   define        C_FgnMBK_RFGMinWords             2
#   define        C_FgnMBK_RFGMaxWords             256

#   define        C_FgnMBK_TypeSigCTRL             2
#   define        C_FgnMBK_TypeSigDATA             3

#   define        C_FgnMBK_FunctionInv             0
#   define        C_FgnMBK_FunctionBuff            1
#   define        C_FgnMBK_FunctionNand2           2
#   define        C_FgnMBK_FunctionNand3           3
#   define        C_FgnMBK_FunctionAnd2            4
#   define        C_FgnMBK_FunctionAnd3            5
#   define        C_FgnMBK_FunctionNor2            6
#   define        C_FgnMBK_FunctionNor3            7
#   define        C_FgnMBK_FunctionOr2             8
#   define        C_FgnMBK_FunctionOr3             9
#   define        C_FgnMBK_FunctionXnor2          10
#   define        C_FgnMBK_FunctionXor2           11
#   define        C_FgnMBK_FunctionNand2mask      12
#   define        C_FgnMBK_FunctionNor2mask       13
#   define        C_FgnMBK_FunctionXnor2mask      14
#   define        C_FgnMBK_FunctionConst          15
#   define        C_FgnMBK_FunctionNbuse          16
#   define        C_FgnMBK_FunctionBuse           17
#   define        C_FgnMBK_FunctionNmux2cs        18
#   define        C_FgnMBK_FunctionMux2cs         19
#   define        C_FgnMBK_FunctionMux3cd         20
#   define        C_FgnMBK_FunctionMux3cs         21
#   define        C_FgnMBK_FunctionMux4cs         22
#   define        C_FgnMBK_FunctionMux5cs         23
#   define        C_FgnMBK_FunctionMux6cs         24
#   define        C_FgnMBK_FunctionNul            25
#   define        C_FgnMBK_FunctionAdd2s          26
#   define        C_FgnMBK_FunctionAdd2f          27
#   define        C_FgnMBK_FunctionAdsb2f         28
#   define        C_FgnMBK_FunctionShift          29
#   define        C_FgnMBK_FunctionNpl1           30
#   define        C_FgnMBK_FunctionPl1            31
#   define        C_FgnMBK_FunctionPmsnw          32
#   define        C_FgnMBK_FunctionPmsnwq         33
#   define        C_FgnMBK_FunctionPms            34
#   define        C_FgnMBK_FunctionPmsq           35
#   define        C_FgnMBK_FunctionPmst           36
#   define        C_FgnMBK_FunctionPmstq          37
#   define        C_FgnMBK_FunctionPdffnw         38
#   define        C_FgnMBK_FunctionPdffnwq        39
#   define        C_FgnMBK_FunctionPdff           40
#   define        C_FgnMBK_FunctionPdffr          41
#   define        C_FgnMBK_FunctionPdffq          42
#   define        C_FgnMBK_FunctionPdfft          43
#   define        C_FgnMBK_FunctionPdffrt         44
#   define        C_FgnMBK_FunctionPdfftq         45
#   define        C_FgnMBK_FunctionRfg1cc         46
#   define        C_FgnMBK_FunctionRfg2cc         47
#   define        C_FgnMBK_FunctionRfg1fc         48
#   define        C_FgnMBK_FunctionRfg2fc         49
#   define        C_FgnMBK_FunctionRfg1c0         50
#   define        C_FgnMBK_FunctionRfg2c0         51
#   define        C_FgnMBK_FunctionRfg1f0         52
#   define        C_FgnMBK_FunctionRfg2f0         53
#   define        C_FgnMBK_FunctionMult           54
#   define        C_FgnMBK_FunctionMultp          55
#   define        C_FgnMBK_FunctionNB             56


/* Declaration of interface functions of module. */
extern void  FgnMBK_Init        __FP(( void ));
extern void  FgnMBK_DefLoFig    __FP(( void ));
extern void  FgnMBK_SavLoFig    __FP(( void ));
extern long  FgnMBK_LoConPower  __FP(( char *aConName ));
extern void  FgnMBK_Import      __FP(( char *ModelName,
                                       char *InstName,
                                    va_list  aStdArgs ));
extern void  FgnMBK_Flatten     __FP(( void ));
extern void  FgnMBK_GenericMF   __FP(( long  aIdentMF,
                                       char *InstName,
                                    va_list  aStdArgs ));
extern void  FgnMBK_xvLoIns     __FP(( char *aModelName,
                                       char *aInstcName,
                                 chain_list *aChainImplConn,
                                    va_list  aStdArgs      ));
extern void  FgnMBK_ErrorHeader __FP(( char *aFuncName ));
extern void  FgnMBK_ErrorPrintF __FP(( char *aFormat, ... ));
extern void  FgnMBK_TraceHeader __FP(( void ));
extern void  FgnMBK_TracePrintF __FP(( char *aFormat, ... ));
extern void  FgnMBK_TraceFlush  __FP(( void ));
extern void  FgnMBK_ErrorTrap   __FP(( int aSig ));


/* Declaration of external variables of module. */


/* Declarations of external structures of module. */
/* Structure keeping together all global variables. */
typedef struct {
		  long  ModuleId;  /* FpGenMBK & FpGenMGN module identifier. */
	losig_list *SigVss;    /* Implicite signal "Vss".                */
	losig_list *SigVdd;    /* Implicite signal "Vdd".                */
	locon_list *ConVss;    /* Implicite terminal "Vss".              */
	locon_list *ConVdd;    /* Implicite terminal "Vdd".              */
	      long  ConMode;   /* Management mode of CTRL terminals.     */
		  long  Msb0;      /* Index associated to MSB.               */
		  long  WidthDP;   /* Current Data-Path maximal width.       */ 
		  char *CurrFunc;  /* Name of current function.              */
	lofig_list *CurrLofig; /* Current data-path logical figure.      */
	      long  CallDefLo; /* Numbers of calls to "DP_DEFLOFIG".     */
	      long  CallSavLo; /* Numbers of calls to "DP_SAVLOFIG".     */
          long  TraceMode; /* Store the state of the trace mode.     */
          long  TraceMark; /* Mark for the PrintF functions.         */
          char *TraceStr;  /* String containing the trace history.   */
    lofig_list *OLD_LOFIG; /* Backup of the GenLib current LOFIG.    */
          char *OLD_WORKL; /* Backup of the MBK working directory.   */
          char *FPGEN_LIB; /* FpGen working directoty.               */
          char *NameCATAL; /* Name of the FpGen CATAL file.          */
          FILE *FileCATAL; /* FpGen CATAL file handler.              */
	} FpgenVGlob_t;

extern FpgenVGlob_t  fpgen_Glob;

# endif
