/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : Extracteur de vue comportementale                           */
/*    Fichier : main.c                                                      */
/*                                                                          */
/*    (c) copyright 1991 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*                                                                          */
/****************************************************************************/
#include MUT_H
#include MLO_H
#include LOG_H
#include BEH_H
#include "abstract.h"


	/* ********* MAIN ********* */
main(argc, argv)
int argc;
char *argv[];
{
befig_list *befig, *beh;
lofig_list *lofig;
loins_list *inst;
locon_list *con;
int trace = 0;
char *ABSTRACT_VERSION = "1.1";
char *outputFile;

char *option; /* pointer to loist of options on command line */





alliancebanner("FlatBeh", ABSTRACT_VERSION, "a netlist abstractor", "1997",
               ALLIANCE_VERSION);

if ((argc < 2) || (argc > 3))
   {
   printf("\nflatbeh %s\n", ABSTRACT_VERSION);
   printf("\nUsage\t: flatbeh input_file [output_file]\n\n");
   printf("\t  input_file  = circuit at gate level\n");
   printf("\t  output_file = circuit at logic level (default name = input_file + abs)\n\n");
   exit(1);
   }

mbkenv();

if (getenv("MBK_TRACE"))
   trace = atoi(getenv("MBK_TRACE"));

if (argc == 2)
   {
   outputFile = mbkalloc(strlen(argv[1]) + 4);
    
   sprintf(outputFile, "%sabs", argv[1]);
   }
else
   outputFile = argv[2];


printf("     =========================  Environnement  =========================\n");
printf("     MBK_WORK_LIB        = %s\n", WORK_LIB);
printf("     MBK_CATA_LIB        = %s\n", getenv("MBK_CATA_LIB"));
printf("     MBK_CATAL_NAME      = %s\n", getenv("MBK_CATAL_NAME"));
if (trace > 0)
printf("     MBK_TRACE           = %d\n", trace);
printf("     ============================== Files ==============================\n");
printf("     Netlist file        = %s.%s\n", argv[1], IN_LO);
printf("     Output  file        = %s.vbe\n", outputFile);
printf("     ===================================================================\n");
printf("\n");

	/*  mise a plat de la figure */
lofig = getlofig(argv[1], 'A');
printf ("Loading '%s/%s.%s'\n", WORK_LIB, lofig->NAME, IN_LO);
befig = laxExtract(lofig, trace);
if (befig)
   {
   befig->NAME = outputFile;

/* if (trace) displayBehMap(befig, 1); */

   vhdlsavebefig(befig, 1);

   exit(0);

   }
}
