/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : MBKSPICE v6.14                                              */
/*    Fichier : msl614.h                                                    */
/*                                                                          */
/*    (c) copyright 1996 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail cao-vlsi@masi.ibp.fr                                 */
/*                                                                          */
/*                                                                          */
/****************************************************************************/

#define MAXNAME  100                  /* max. length of signal name */

/* legal return values for extension function */

#define MSL_EXTDONE     0
#define MSL_EXTUNKNOWN  1

/* legal values for SPITRANS */

#define SPIMOS  'M'
#define SPIASGA 'A'

/* for USER field of transistors */

#define MSL_TRANSNAME 130            /* transistor name */

extern char         SPITRANS;        /* transistor technology */

extern int          msl_line;        /* current line number */
extern int          msl_father;      /* TRUE if current SUBCKT is main SUBCKT */
extern int          msl_figloaded;   /* TRUE if inside a SUBCKT */
extern char        *msl_figname;     /* name of main SUBCKT */
extern lofig_list  *msl_ptfig;       /* lofig of current SUBCKT */
extern char         msl_subckt[];    /* name of current SUBCKT */

void spiceloadlofig();
void spicesavelofig();

void mslAddExtension();              /* add function called during parsing */
void mslRmvExtension();              /* remove this function */

void mslAddCompletion();             /* add function called after parsing */
void mslRmvCompletion();             /* remove this function */
