/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#include "msl_headers.h"

char            SPITRANS = SPIMOS;

chain_list     *already_driven = NULL;
FILE           *outfile;

void 
spicesavelofig(lofig)
    lofig_list     *lofig;
{
    char            outfile_name[80];

/* position de l'environnement */
    spigetenv();

    strcpy(outfile_name, lofig->NAME);
    strcat(outfile_name, ".");
    strcat(outfile_name, OUT_LO);
    outfile = (FILE *) mbkfopen(lofig->NAME, OUT_LO, WRITE_TEXT);
    if (outfile == NULL) {
        fprintf(stderr, "*** mbk error *** can't open file %s\n", outfile_name);
        EXIT(-1);
    }

    fprintf(outfile, "****spice description of %s\n", lofig->NAME);
    fprintf(outfile, "****driver version 614\n\n\n");


    spi_drive_dic(outfile, lofig);
    spi_drive_mod(lofig);
    freechain(already_driven);
    already_driven = (chain_list *) NULL;
}

void
spi_drive_dic(pt_out, ptlofig)
    lofig_list     *ptlofig;
    FILE           *pt_out;
{
    losig_list     *pt_aux = (losig_list *) NULL;

    for (pt_aux = ptlofig->LOSIG; pt_aux != NULL; pt_aux = pt_aux->NEXT) {
        chain_list     *chain;

        if (pt_aux->TYPE == 'E') {
            locon_list     *locon;

            for (locon = ptlofig->LOCON; locon->SIG != pt_aux; locon = locon->NEXT);
            fprintf(pt_out, "* net %d = %s\n", pt_aux->INDEX, spi_busname(locon->NAME));
        }
        else
            for (chain = pt_aux->NAMECHAIN; chain != NULL; chain = chain->NEXT)
                if ((strcmp((char *) chain->DATA, "") != 0) && (strncmp((char *) chain->DATA, "mbk", 3) != 0))
                    fprintf(pt_out, "* net %d = %s\n", pt_aux->INDEX, spi_busname((char *) chain->DATA));
    }
}

void 
spi_drive_mod(lofig)
    lofig_list     *lofig;
{
    chain_list     *pt_aux = (chain_list *) NULL;
    char            drived_cell();
    void            drive_basic_cells();

    drive_basic_cells(lofig);
    for (pt_aux = lofig->MODELCHAIN; pt_aux != NULL; pt_aux = pt_aux->NEXT) {
        lofig_list     *pt_aux1 = (lofig_list *) NULL;

        if (!drived_cell(already_driven, namealloc((char *) pt_aux->DATA))) {
            pt_aux1 = getlofig(pt_aux->DATA, 'A');
            if (pt_aux1 == NULL) {
                fprintf(stdout, "*******MBK ERROR : FIGURE %s DOESN'T EXIST******\n", pt_aux->DATA);
                exit(1);
            }
            spi_drive_mod(pt_aux1);
        }
    }
    spi_drive_subckt(lofig);
}
