/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#include "msl_headers.h"

char           *tab_err[NB_ERR] =
{
    "Dico dax not finished",
    "Dico vti not finished",
    "Missing end of subckt",
    "Missing start of subckt",
    "Transistor out of a subckt !!!",
    "Instance out of a subckt !!!",
    "Capacity out of a subckt !!!",
    "Missing name of subckt",
    "Bad subckt name",
    "Subckt name must begin by a letter",
    "Bad dico number",
    "Bad dico definition",
    "Bad mbk name, first caractere must be a letter",
    "Name too big, 100 caracteres maxi",
    "Bad definition of capacity, missing one or more parameters",
    "Bad value, missing digit",
    "Bad unity, good unity : M, U, N, P, F",
    "Bad instance definition, missing one or more parameters",
    "Bad transistor definition",
    "Bad transistor definition, missing drain, source, grid, bulk and type",
    "Bad transistor definition, missing source, grid, bulk and type",
    "Bad transistor definition, missing grid, bulk and type",
    "Bad transistor definition, missing bulk and type",
    "Bad transistor definition, missing type",
    "Bad transistor definition, on the fields W and L",
    "Bad transistor definition, on the field AS or AD",
    "Bad transistor definition, on the field PS or PD",
    "Bad transistor definition, on the field NRS or NRD",
    "Two different definition of dico in the same file",
    "Possible incoherency, figure already saved in memory",
    "Bad transistor type in variables MBK_SPI_TN and MBK_SPI_TP",
    "Root figure missing or not the last",
    "Bad dico index in memory",
    "Bad node, value 0 impossible",
    "Figure cancelled",
    "Bad ASGA (MESFET) declaration"
};


/*****************************************************************************/
/*                                                                           */
/*                                   ERREUR                                  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/* Displays the appropriate error message and exits                          */
/*                                                                           */
/* INPUT  : the mbkspice error code                                          */
/* OUTPUT : none                                                             */
/*                                                                           */
/*****************************************************************************/

void 
mslError(num_err)
    int             num_err;
{

    fprintf(stderr, "\n******** Parser spice error ********\n");
    fprintf(stderr, "line %d : %s\n", msl_line, tab_err[num_err]);
    fflush(stderr);
    exit(-1);
}

/*****************************************************************************/
/*                                                                           */
/*                                   WARNING                                 */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/* Displays the appropriate warning message                                  */
/*                                                                           */
/* INPUT  : the mbkspice warning code                                        */
/* OUTPUT : none                                                             */
/*                                                                           */
/*****************************************************************************/

void 
mslWarning(num_warning)
    int             num_warning;
{

    fprintf(stderr, "\n******** Parser spice warning ********\n");
    fprintf(stderr, "line %d : %s\n", msl_line, tab_err[num_warning]);
}

