/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 

/* ###--------------------------------------------------------------### */
/*									*/
/* file		: phl106.h						*/
/* date		: Apr 22 1996						*/
/* version	: v106							*/
/* authors	: Pirouz BAZARGAN SABET					*/
/* description	: header for PHL library				*/
/*									*/
/* ###--------------------------------------------------------------### */

#ifndef PAT_PHLDEF
#define PAT_PHLDEF

	/* ###------------------------------------------------------### */
	/*    data structures						*/
	/* ###------------------------------------------------------### */

struct pause				/* structures' usage		*/
  {
  unsigned int PASEQ    ;		/* # of sequence of patterns	*/
  unsigned int PAGRP    ;		/* # of input-output arraies	*/
  unsigned int PAIOL    ;		/* # of input-outputs		*/
  unsigned int PACOM    ;		/* # of comments		*/
  unsigned int PAPAT    ;		/* # of patterns		*/
  unsigned int PAEVT    ;		/* # of events			*/
  unsigned int PAINI    ;		/* # of register's init.	*/
  unsigned int PAINS    ;		/* # of inspected instances	*/
  unsigned int CHARACTER;		/* # of characters (in strings)	*/
  };

	/* ###------------------------------------------------------### */
	/*    high-level functions					*/
	/* ###------------------------------------------------------### */

extern void          pat_debug    ();	/* pat structure displayer	*/
extern void          pat_getusage ();	/* get structures' usage	*/

#endif
