/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/*------------------------------------------------------------\
|                                                             |
| Tool    :                     RDS                           |
|                                                             |
| File    :                   rdsfree.c                       |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   27.06.95                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <malloc.h>
# include <memory.h>
# include <string.h>

# include MUT_H
# include RDS_H

# include "rdsalloc.h"
# include "rdsfree.h"
# include "rdserror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Rds Free                           |
|                                                             |
\------------------------------------------------------------*/

void  rdsfree( Pointer, Size )

      char         *Pointer;
      unsigned int  Size;
{
  unsigned int Index;

  Index = ( Size + 3 ) >> 2;

  if ( ( Size  == 0              ) ||
       ( Index > 255             ) )
  {
    free( Pointer );
  }
  else
  {
    *((char **)Pointer) = RdsHeapHeadArray[ Index ];

    RdsHeapHeadArray[ Index ] = Pointer;
  }
}

/*------------------------------------------------------------\
|                                                             |
|                      Rds Free Figure                        |
|                                                             |
\------------------------------------------------------------*/

void freerdsfig( Figure )

     rdsfig_list *Figure;
{
  rdsfreeblock( (char *)Figure->LAYERTAB );
  rdsfreeblock( (char *)Figure->FLAGTAB  );
  rdsfreeblock( (char *)Figure->BBOXTAB  );
  rdsfreeblock( (char *)Figure           );
}

/*------------------------------------------------------------\
|                                                             |
|                      Rds Free Instance                      |
|                                                             |
\------------------------------------------------------------*/

void freerdsins( Instance )

     rdsins_list *Instance;
{
  rdsfreeblock( (char *)Instance->LAYERTAB );
  rdsfreeblock( (char *)Instance->COURONNE );
  rdsfreeblock( (char *)Instance           );
}

/*------------------------------------------------------------\
|                                                             |
|                      Rds Free Rectangle                     |
|                                                             |
\------------------------------------------------------------*/

void freerdsrec( Rectangle, Size )

     rdsrec_list  *Rectangle;
     unsigned int  Size;
{
  rdsfreeheap( (char *)Rectangle, sizeof( rdsrec_list ) + Size);
}
