/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/*------------------------------------------------------------\
|                                                             |
| Tool    :                     RDS                           |
|                                                             |
| File    :                   Rfm 208                         |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   01.08.93                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/

# ifndef RFM_208
# define RFM_208

/*------------------------------------------------------------\
|                                                             |
|                       Special Macros                        |
|                                                             |
\------------------------------------------------------------*/

# define RfmRoundHigh(X)                                \
                                                        \
    (((X)>=0) ? ((((X) + ( RDS_PHYSICAL_GRID >> 1 ))    \
                       / RDS_PHYSICAL_GRID ) *          \
                         RDS_PHYSICAL_GRID )            \
              :  (((X) / RDS_PHYSICAL_GRID ) *          \
                         RDS_PHYSICAL_GRID )            )

# define RfmRoundLow(X)                                 \
                                                        \
    (((X)>=0) ? (((X) / RDS_PHYSICAL_GRID ) *           \
                        RDS_PHYSICAL_GRID )             \
              : ((((X) - ( RDS_PHYSICAL_GRID >> 1 ))    \
                       /  RDS_PHYSICAL_GRID ) *         \
                          RDS_PHYSICAL_GRID )           )

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern rdsrec_list *segmbkrds();
  extern rdsrec_list *viambkrds();
  extern rdsrec_list *refmbkrds();
  extern rdsrec_list *conmbkrds();
  extern rdsrec_list *aboxmbkrds();

  extern rdsrec_list *insconmbkrds();
  extern rdsrec_list *insviambkrds();
  extern rdsrec_list *insrefmbkrds();
  extern rdsrec_list *inssegmbkrds();

  extern rdsins_list *insmbkrds();
  extern rdsfig_list *figmbkrds();
  extern rdsfig_list *modelmbkrds();

  extern void         viewrfmrec();
  extern void         viewrfmseg();
  extern void         viewrfmvia();
  extern void         viewrfmref();
  extern void         viewrfmcon();
  extern void         viewrfmins();
  extern void         viewrfmfig();
 
  extern void         roundrdsrec();

# endif
