/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/*------------------------------------------------------------\
|                                                             |
| Tool    :                     RDS                           |
|                                                             |
| File    :                  rprerror.h                       |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   27.06.95                        |
|                                                             |
\------------------------------------------------------------*/

# ifndef RPR_ERROR_H
# define RPR_ERROR_H

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                       Rpr Error Constants                   |
|                                                             |
\------------------------------------------------------------*/

# define RPR_DEFINE_MISSING  0 
# define RPR_TABLE_MISSING   1 
# define RPR_LINE_EXPECTED   2
# define RPR_UNKNOWN_DEFINE  3 
# define RPR_NOT_DEFINED     4 
# define RPR_MULTIPLE_GRID   5 
# define RPR_TOO_SMAL        6
# define RPR_MISSING_VALUE   7
# define RPR_MISSING_NAME    8
# define RPR_ILLEGAL_FLOAT   9
# define RPR_UNEXPECTED_LINE 10
# define RPR_UNEXPECTED_EOF  11
# define RPR_TOO_MANY_WORDS  12
# define RPR_MISSING_TABLE   13
# define RPR_OPEN_FILE       14
# define RPR_MISSING_POST    15
# define RPR_NEGATIVE_VALUE  16
# define RPR_SYNTAX_ERROR    17

/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Macros                           |
|                                                             |
\------------------------------------------------------------*/

# define rprerror( E, V, D ) (rpr_error( (E), (V), (D), __FILE__, __LINE__ ))

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/

  extern void rpr_error();

# endif
