/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/*------------------------------------------------------------\
|                                                             |
| Tool    :                     RDS                           |
|                                                             |
| File    :                   rtlenv.c                        |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   27.06.95                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdlib.h>

# include MPH_H
# include MUT_H
# include RDS_H
# include RUT_H
# include RPR_H
# include RTL_H

# include "rtlenv.h"
# include "rtlerror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

  char *RDS_IN;
  char *RDS_OUT;
  char *RDS_TECHNO_NAME;

  long  RDS_WINDOW_AREA = 0;

  char *RDS_CIF_FORMAT = (char *)NULL;
  char *RDS_GDS_FORMAT = (char *)NULL;

/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            rdsenv                           |
|                                                             |
\------------------------------------------------------------*/

void rdsenv()
{
  char *String;
  char  Buffer[ 512 ];

  RDS_TECHNO_NAME = getenv( "RDS_TECHNO_NAME");

  if ( RDS_TECHNO_NAME == (char *)NULL )
  {
    String = getenv( "ALLIANCE_TOP" );
    if ( String == (char *)NULL ) String = ALLIANCE_TOP;

    sprintf( Buffer, "%s/%s", String, RTL_DEFAULT_TECHNO );
    RDS_TECHNO_NAME = mbkstrdup( Buffer );
  }

  RDS_IN = namealloc( getenv( "RDS_IN") );

  if ( RDS_IN == (char *)NULL )
  {
    RDS_IN = namealloc( RTL_DEFAULT_IN );
  }
 
  RDS_OUT = namealloc( getenv( "RDS_OUT") );

  if ( RDS_OUT == (char *)NULL )
  {
    RDS_OUT = namealloc( RTL_DEFAULT_OUT );
  }

  String = getenv( "RDS_WINDOW_AREA") ;

  if ( String != (char *)NULL )
  {
    RDS_WINDOW_AREA = atol( String );
  }

  if ( RDS_WINDOW_AREA == 0 )
  {
    RDS_WINDOW_AREA = RTL_DEFAULT_AREA;
  }

  if( RDS_WINDOW_AREA < 0 )
  {
    RDS_WINDOW_AREA = 0;
  }

  RDS_GDS_FORMAT = namealloc( "gds" );
  RDS_CIF_FORMAT = namealloc( "cif" );
}
