/* 
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This library is free software; you  can redistribute it and/or modify it
 * under the terms  of the GNU Library General Public  License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/*------------------------------------------------------------\
|                                                             |
| Tool    :                     RDS                           |
|                                                             |
| File    :                  rwialloc.c                       |
|                                                             |
| Authors :                Jacomme Ludovic                    |
|                                                             |
| Date    :                   27.06.95                        |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <string.h>
# include <math.h>

# include MUT_H
# include RDS_H
# include RTL_H
# include RWI_H

# include "rwialloc.h"
# include "rwierror.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                        Alloc Functions                      |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                      Alloc Rds Win Rec                      |
|                                                             |
\------------------------------------------------------------*/

rdswinrec_list *allocrdswinrec()
 
{
  return( (rdswinrec_list *)(rdsallocheap( sizeof(rdswinrec_list) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                      Alloc Rds Rec Win                      |
|                                                             |
\------------------------------------------------------------*/

rdsrecwin_list *allocrdsrecwin()
 
{
  return((rdsrecwin_list *)(rdsallocheap( sizeof(rdsrecwin_list) ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Alloc Rds Window                     |
|                                                             |
\------------------------------------------------------------*/

rdswin_list *allocrdswin( Number )

  unsigned long Number;
{
  return((rdswin_list *)(rdsallocblock( sizeof(rdswin_list) * Number ) ) );
}

/*------------------------------------------------------------\
|                                                             |
|                        Alloc Rds Window                     |
|                                                             |
\------------------------------------------------------------*/

rdswin_list *allocrdswinlayer( RdsWin )

  rdswin_list *RdsWin;
{
  if ( RdsWin->LAYERTAB == (rdswinrec_list **)NULL )
  {
    RdsWin->LAYERTAB = (rdswinrec_list **)rdsallocblock( sizeof(rdswinrec_list *) * RWI_MAX_LAYER );
  }

  return( RdsWin );
}

/*------------------------------------------------------------\
|                                                             |
|                       Alloc Rds Window                      |
|                                                             |
\------------------------------------------------------------*/

rdswindow *allocrdswindow() 

{
  return((rdswindow *)(rdsallocblock(sizeof(rdswindow) ) ) );
}
