/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 *
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 *
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 *
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Tool    : Logic Synthesis
 * Date    : 1996,97
 * Author  : Czo <Olivier.Sirol@lip6.fr> 
 */



 /* $Id: but_error.h,v 1.1 1997/09/19 15:18:02 sirol Exp sirol $ */


#ifndef FPT_ERROR_H
#define FPT_ERROR_H

/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                           Constants                           ##
 * ##                                                               ##
 * ####===========================================================####
 */

/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                             Macros                            ##
 * ##                                                               ##
 * ####===========================================================####
 */

#define displayfpterror                         \
                                                 \
    FptDisplayDebugSource( __FILE__, __LINE__ ), \
    FptDisplayError


#define displayfptwarning                       \
                                                 \
    FptDisplayDebugSource( __FILE__, __LINE__ ), \
    FptDisplayWarning


#define displayfptdebug                   \
                                           \
    FptDisplayDebug

#define displayfptverbose                 \
                                           \
    FptDisplayVerbose

#define allocated_sprintf                 \
                                           \
    FptSprintf




#define displayfptnode(TEXT)                                               \
   if (getfptdebugflag(void))                                                  \
     {                                                                     \
       garbagebddsystem( (bddsystem *)0 );                                 \
       printf("######## %s : %ld\n",(TEXT), BddLocalSystem->NUMBER_NODE);  \
     }




/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                             Types                             ##
 * ##                                                               ##
 * ####===========================================================####
 */

/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                           Variables                           ##
 * ##                                                               ##
 * ####===========================================================####
 */

/*
 * ####===========================================================####
 * ##                                                               ##
 * ##                           Functions                           ##
 * ##                                                               ##
 * ####===========================================================####
 */



/*================================================================####
 * from error.c
 *     
 */

#ifdef __STDC__
#define __PROT(x) x
#else
#define __PROT(x) ()
#endif
extern void setfptverboseflag __PROT ((void));
extern void clearfptverboseflag __PROT ((void));
extern void setfptdebugflag __PROT ((void));
extern void clearfptdebugflag __PROT ((void));
extern int getfptverboseflag __PROT ((void));
extern int getfptdebugflag __PROT ((void));
extern int getfptwarnings __PROT ((void));
extern void FptDisplayDebugSource __PROT ((char *File, int Line));
extern void FptDisplayDebug __PROT (());
extern void FptDisplayVerbose __PROT (());
extern void FptDisplayWarning __PROT (());
extern void FptDisplayError __PROT (());
extern char *FptSprintf __PROT (());

#endif
