/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 *
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 *
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 *
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Tool    : Logic Synthesis - CMOS Cells Compiler
 * Date    : 1991,92
 * Author  : Nathalie Dictus
 * Modified by Czo <Olivier.Sirol@lip6.fr> 1996,97
 */




#ident  "$Id: c4_genlib.c,v 1.1 1997/09/19 15:18:02 sirol Exp sirol $"

#include <stdio.h>
#include <stdlib.h>

#include MUT_H
#include BEH_H
#include BVL_H
#include MLO_H
#include MPH_H
#include LOG_H
#include ICN_H
#include IAC_H
#include ICU_H
#include MGN_H

#include "lax_param.h"
#include "sl_local.h"
#include "c4_local.h"

/******************************************************************************
 ******************************************************************************
 *** Les fonctions _p sont generees a la base automatiquement par LAYOUT/l2c***
 ******************************************************************************
 ******************************************************************************/
extern struct IconGate *genIcon ();

/******************************************************************************
 ***  Version 1.0b02                                            14/06/1991  ***
 ******************************************************************************

 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                            c.c.c.c tools                               ***
 ***                    Complex Cmos Cells Compiler                         ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 ******************************************************************************
 ***                        GENLIB GENERATOR MODULE                         ***
 ******************************************************************************/

/*----------------------------------------------------------------------------
  -------- very low-level func -----------------------------------[genFiles]--
  ----------------------------------------------------------------------------
  SYNTAX : befig_list * genBehave(char *, chain_list*, char)
  ----------------------------------------------------------------------------
  EXEMPLE : genBehave(fName, expr, polar)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
  ----------------------------------------------------------------------------*/

befig_list *
genBehave (fName, expr, polarity, area)
     char *fName;
     chain_list *expr;
     char polarity;
     int area;
{
  lores_list *ptres, *res;
  lores_list *caracLofig ();
  begen_list *beh_addbegen ();
  int *pval;

  befig_list *bhCell;
  register short i = 0;
  befig_list *beh_addbefig ();
  berin_list *beh_addberin ();
  beout_list *beh_addbeout ();
  bepor_list *beh_addbepor ();
  int numberI;

  bhCell = beh_addbefig (NULL, fName);

  numberI = numberAtomExpr (expr);
  bhCell->BEPOR = beh_addbepor (bhCell->BEPOR, "vss", 'I', 'B');
  bhCell->BEPOR = beh_addbepor (bhCell->BEPOR, "vdd", 'I', 'B');
  if (polarity == NEG)
    {
      bhCell->BEOUT = beh_addbeout (bhCell->BEOUT, N_OUT_SYMB,
				    notExpr (expr));
      bhCell->BEPOR = beh_addbepor (bhCell->BEPOR, N_OUT_SYMB, 'O', 'B');
    }
  else
    {
      bhCell->BEOUT = beh_addbeout (bhCell->BEOUT, OUT_SYMB, expr);
      bhCell->BEPOR = beh_addbepor (bhCell->BEPOR, OUT_SYMB, 'O', 'B');
    }
  for (i = 0; i < numberI; i++)
    {
      bhCell->BERIN = beh_addberin (bhCell->BERIN,
				    NAME ("%s%d", IN_SYMB, numberI - i - 1));
      bhCell->BEPOR = beh_addbepor (bhCell->BEPOR,
			 NAME ("%s%d", IN_SYMB, numberI - i - 1), 'I', 'B');
    }
  bhCell->BEPOR = (bepor_list *) reverse ((chain_list *) bhCell->BEPOR);


  /* appel a la caracterisation */
  res = caracLofig (fName, 0, 1000);

  /* ajout des generics */
  bhCell->BEGEN = NULL;


  pval = (int *) mbkalloc (sizeof (int));
  *pval = area * 252;
  bhCell->BEGEN = (void *) beh_addbegen (bhCell->BEGEN, namealloc ("area"),
				      namealloc ("natural"), (void *) pval);

  for (ptres = res; ptres; ptres = ptres->NEXT)
    {
      char *name = ptres->NAME;

      pval = (int *) mbkalloc (sizeof (int));
      *pval = ptres->CAPA;
      bhCell->BEGEN = (void *) beh_addbegen (bhCell->BEGEN, genNAME ("cin_%s", name),
				      namealloc ("natural"), (void *) pval);

      pval = (int *) mbkalloc (sizeof (int));
      *pval = ptres->RUP;
      bhCell->BEGEN = (void *) beh_addbegen (bhCell->BEGEN, genNAME ("rup_%s", name),
				      namealloc ("natural"), (void *) pval);

      pval = (int *) mbkalloc (sizeof (int));
      *pval = ptres->RDOWN;
      bhCell->BEGEN = (void *) beh_addbegen (bhCell->BEGEN, genNAME ("rdown_%s", name),
				      namealloc ("natural"), (void *) pval);

      if (fName[0] != 'n')
	{
	  /* cellule positive */
	  pval = (int *) mbkalloc (sizeof (int));
	  *pval = ptres->TPHL;
	  bhCell->BEGEN = (void *) beh_addbegen (bhCell->BEGEN, genNAME ("tphh_%s", name),
				      namealloc ("natural"), (void *) pval);

	  pval = (int *) mbkalloc (sizeof (int));
	  *pval = ptres->TPLH;
	  bhCell->BEGEN = (void *) beh_addbegen (bhCell->BEGEN, genNAME ("tpll_%s", name),
				      namealloc ("natural"), (void *) pval);
	}
      else
	{
	  /* cellule negative */
	  pval = (int *) mbkalloc (sizeof (int));
	  *pval = ptres->TPLH;
	  bhCell->BEGEN = (void *) beh_addbegen (bhCell->BEGEN, genNAME ("tplh_%s", name),
				      namealloc ("natural"), (void *) pval);

	  pval = (int *) mbkalloc (sizeof (int));
	  *pval = ptres->TPHL;
	  bhCell->BEGEN = (void *) beh_addbegen (bhCell->BEGEN, genNAME ("tphl_%s", name),
				      namealloc ("natural"), (void *) pval);
	}
    }

  decompileVHDL (bhCell, NULL, 0);
  return (bhCell);
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *bd1_p(char *, char *, char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = bd1_p("", "s", "i0", "l0")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
bd1_p (ms, out, i1, i2)
     char *ms;
     char *out;
     char *i1, *i2;
{
  (void) delphfig (ms);
  DEF_PHFIG (ms);
  DEF_AB (5, 3, 77, 45);
  PHCON (ALU2, 2, i1, SOUTH, 8, 3);
  PHCON (ALU2, 2, i1, NORTH, 8, 45);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU2, 2, out, SOUTH, 74, 3);
  PHCON (ALU2, 2, out, NORTH, 74, 45);
  PHCON (ALU2, 2, i2, SOUTH, 32, 3);
  PHCON (ALU2, 2, i2, NORTH, 32, 45);
  PHCON (ALU1, 8, "vss", EAST, 77, 5);
  PHCON (ALU1, 8, "vdd", EAST, 77, 43);
  PHSEG (PTRANS, 1, "", 11, 27, 11, 42);
  PHSEG (NTRANS, 1, "", 11, 7, 11, 16);
  PHSEG (PDIF, 3, "", 14, 29, 14, 40);
  PHSEG (NDIF, 3, "", 14, 9, 14, 14);
  PHSEG (PTRANS, 4, "", 18, 36, 23, 36);
  PHSEG (PDIF, 3, "", 19, 41, 21, 41);
  PHSEG (TALU2, 2, "", 26, 3, 26, 45);
  PHSEG (PDIF, 3, "", 8, 29, 8, 40);
  PHSEG (NDIF, 3, "", 20, 4, 20, 14);
  PHSEG (TALU2, 2, "", 20, 3, 20, 45);
  PHSEG (PDIF, 3, "", 50, 29, 50, 40);
  PHSEG (PDIF, 3, "", 44, 29, 44, 40);
  PHSEG (NDIF, 3, "", 44, 9, 44, 14);
  PHSEG (ALU2, 2, "", 32, 3, 32, 45);
  PHSEG (PTRANS, 1, "", 71, 25, 71, 51);
  PHSEG (PTRANS, 1, "", 65, 28, 65, 36);
  PHSEG (NTRANS, 1, "", 71, 5, 71, 20);
  PHSEG (NTRANS, 1, "", 65, 11, 65, 19);
  PHSEG (ALU2, 2, "", 74, 3, 74, 45);
  PHSEG (PDIF, 3, "", 74, 27, 74, 49);
  PHSEG (PDIF, 3, "", 68, 30, 68, 49);
  PHSEG (NDIF, 3, "", 74, 7, 74, 18);
  PHSEG (PDIF, 3, "", 62, 30, 62, 34);
  PHSEG (NDIF, 3, "", 62, 13, 62, 17);
  PHSEG (NTIE, 3, "", 62, 40, 62, 45);
  PHSEG (PTRANS, 4, "", 54, 37, 59, 37);
  PHSEG (PDIF, 3, "", 55, 42, 57, 42);
  PHSEG (TALU2, 2, "", 68, 3, 68, 45);
  PHSEG (TALU2, 2, "", 62, 3, 62, 45);
  PHSEG (ALU1, 2, "", 74, 28, 74, 34);
  PHSEG (ALU1, 1, "", 74, 16, 74, 28);
  PHSEG (ALU1, 2, "", 74, 13, 74, 16);
  PHSEG (NDIF, 3, "", 68, 5, 68, 18);
  PHSEG (TALU2, 2, "", 44, 3, 44, 45);
  PHSEG (TALU2, 2, "", 50, 3, 50, 45);
  PHSEG (NDIF, 3, "", 56, 5, 56, 14);
  PHSEG (TALU2, 2, "", 56, 3, 56, 45);
  PHSEG (TALU2, 2, "", 38, 3, 38, 45);
  PHSEG (NTRANS, 1, "", 35, 6, 35, 18);
  PHSEG (NDIF, 3, "", 38, 8, 38, 16);
  PHSEG (NDIF, 3, "", 32, 4, 32, 16);
  PHSEG (PTRANS, 1, "", 35, 28, 35, 49);
  PHSEG (PDIF, 3, "", 32, 30, 32, 47);
  PHSEG (PDIF, 3, "", 38, 30, 38, 47);
  PHSEG (NTRANS, 1, "", 17, 7, 17, 16);
  PHSEG (NDIF, 3, "", 26, 12, 26, 15);
  PHSEG (NTRANS, 1, "", 29, 10, 29, 18);
  PHSEG (PTRANS, 1, "", 29, 32, 29, 40);
  PHSEG (PDIF, 3, "", 26, 34, 26, 38);
  PHSEG (TALU2, 2, "", 14, 3, 14, 45);
  PHSEG (ALU1, 1, "", 62, 28, 69, 28);
  PHSEG (ALU1, 1, "", 62, 28, 62, 32);
  PHSEG (ALU1, 1, "", 60, 28, 62, 28);
  PHSEG (ALU1, 1, "", 60, 27, 60, 28);
  PHSEG (ALU1, 1, "", 69, 17, 69, 28);
  PHSEG (ALU1, 1, "", 62, 17, 69, 17);
  PHSEG (ALU1, 1, "", 62, 16, 62, 17);
  PHSEG (POLY, 1, "", 71, 20, 71, 25);
  PHSEG (POLY, 1, "", 65, 25, 71, 25);
  PHSEG (POLY, 1, "", 65, 25, 65, 28);
  PHSEG (POLY, 1, "", 65, 21, 65, 25);
  PHSEG (POLY, 1, "", 65, 19, 65, 21);
  PHSEG (POLY, 1, "", 64, 21, 65, 21);
  PHSEG (NTRANS, 7, "", 62, 3, 62, 9);
  PHSEG (NTRANS, 1, "", 53, 7, 53, 16);
  PHSEG (ALU1, 1, "dff_s", 56, 21, 56, 32);
  PHSEG (ALU1, 1, "dff_s", 56, 13, 56, 21);
  PHSEG (ALU1, 1, "dff_s", 56, 21, 64, 21);
  PHSEG (NTRANS, 1, "", 47, 7, 47, 16);
  PHSEG (PTRANS, 1, "", 47, 27, 47, 42);
  PHSEG (NDIF, 2, "", 50, 9, 50, 14);
  PHSEG (ALU1, 1, "", 50, 30, 52, 30);
  PHSEG (ALU1, 1, "", 52, 14, 52, 30);
  PHSEG (ALU1, 1, "", 50, 14, 52, 14);
  PHSEG (ALU1, 1, "", 50, 13, 50, 14);
  PHSEG (ALU1, 1, "", 50, 30, 50, 31);
  PHSEG (ALU1, 2, "", 50, 31, 50, 35);
  PHSEG (ALU1, 1, "", 48, 18, 48, 26);
  PHSEG (ALU2, 2, i1, 8, 3, 8, 45);
  PHSEG (PTIE, 2, "", 8, 4, 14, 4);
  PHSEG (NTRANS, 7, "", 26, 2, 26, 8);
  PHSEG (NDIF, 3, "", 8, 9, 8, 14);
  PHSEG (PDIF, 3, "", 19, 31, 21, 31);
  PHSEG (POLY, 1, "", 29, 18, 29, 32);
  PHSEG (NWELL, 72, "", 41, 26, 41, 52);
  PHSEG (ALU1, 2, "", 14, 31, 14, 35);
  PHSEG (ALU1, 1, "", 14, 14, 14, 30);
  PHSEG (ALU1, 1, "", 25, 35, 26, 35);
  PHSEG (ALU1, 2, "", 25, 31, 25, 35);
  PHSEG (POLY, 1, "", 23, 31, 23, 36);
  PHSEG (POLY, 1, "", 23, 31, 26, 31);
  PHSEG (POLY, 1, "", 26, 18, 26, 31);
  PHSEG (POLY, 1, "", 23, 18, 26, 18);
  PHSEG (POLY, 1, "", 23, 8, 23, 18);
  PHSEG (POLY, 1, "", 23, 8, 26, 8);
  PHSEG (ALU1, 1, "dff_m", 20, 13, 20, 17);
  PHSEG (ALU1, 1, "dff_m", 18, 17, 20, 17);
  PHSEG (ALU1, 1, "dff_m", 18, 17, 18, 27);
  PHSEG (ALU1, 1, "dff_m", 18, 27, 20, 27);
  PHSEG (ALU1, 1, "dff_m", 20, 27, 20, 31);
  PHSEG (ALU1, 1, "dff_m", 20, 27, 30, 27);
  PHSEG (POLY, 1, "", 17, 23, 22, 23);
  PHSEG (POLY, 1, "", 17, 16, 17, 23);
  PHSEG (ALU1, 1, "", 9, 19, 10, 19);
  PHSEG (ALU1, 1, "", 9, 19, 9, 23);
  PHSEG (ALU1, 1, "", 8, 23, 9, 23);
  PHSEG (ALU1, 1, "", 25, 14, 25, 18);
  PHSEG (ALU1, 1, "", 24, 18, 25, 18);
  PHSEG (ALU1, 1, "", 25, 18, 39, 18);
  PHSEG (ALU1, 1, "", 39, 18, 39, 26);
  PHSEG (ALU1, 1, "", 39, 26, 40, 26);
  PHSEG (ALU1, 1, "", 25, 14, 26, 14);
  PHSEG (PTIE, 2, "", 38, 3, 44, 3);
  PHSEG (PTIE, 3, "", 44, 3, 44, 4);
  PHSEG (PTIE, 2, "", 44, 4, 50, 4);
  PHSEG (NTIE, 2, "", 44, 45, 50, 45);
  PHSEG (POLY, 1, "", 47, 16, 47, 18);
  PHSEG (POLY, 1, "", 47, 18, 48, 18);
  PHSEG (POLY, 1, "", 11, 19, 11, 27);
  PHSEG (POLY, 1, "", 11, 16, 11, 19);
  PHSEG (POLY, 1, "", 10, 19, 11, 19);
  PHSEG (NTIE, 2, "", 8, 45, 14, 45);
  PHSEG (ALU1, 2, "vdd", 68, 43, 68, 46);
  PHSEG (ALU1, 2, "vdd", 68, 32, 68, 43);
  PHSEG (ALU1, 8, "vdd", 68, 43, 77, 43);
  PHSEG (ALU1, 8, "vdd", 62, 43, 68, 43);
  PHSEG (ALU1, 2, "vdd", 62, 40, 62, 43);
  PHSEG (ALU1, 2, "vdd", 62, 43, 62, 45);
  PHSEG (ALU1, 8, "vdd", 56, 43, 62, 43);
  PHSEG (ALU1, 2, "vdd", 56, 42, 56, 43);
  PHSEG (ALU1, 8, "vdd", 50, 43, 56, 43);
  PHSEG (ALU1, 2, "vdd", 50, 43, 50, 45);
  PHSEG (ALU1, 8, "vdd", 44, 43, 50, 43);
  PHSEG (ALU1, 2, "vdd", 44, 35, 44, 43);
  PHSEG (ALU1, 2, "vdd", 44, 43, 44, 45);
  PHSEG (ALU1, 8, "vdd", 32, 43, 44, 43);
  PHSEG (ALU1, 2, "vdd", 32, 32, 32, 43);
  PHSEG (ALU1, 8, "vdd", 20, 43, 32, 43);
  PHSEG (ALU1, 2, "vdd", 20, 41, 20, 43);
  PHSEG (ALU1, 8, "vdd", 14, 43, 20, 43);
  PHSEG (ALU1, 2, "vdd", 14, 43, 14, 45);
  PHSEG (ALU1, 8, "vdd", 8, 43, 14, 43);
  PHSEG (ALU1, 8, "vdd", 5, 43, 8, 43);
  PHSEG (ALU1, 2, "vdd", 8, 33, 8, 43);
  PHSEG (ALU1, 2, "vdd", 8, 43, 8, 45);
  PHSEG (ALU1, 2, "vss", 8, 4, 8, 5);
  PHSEG (ALU1, 2, "vss", 8, 5, 8, 13);
  PHSEG (ALU1, 8, "vss", 5, 5, 8, 5);
  PHSEG (ALU1, 8, "vss", 8, 5, 14, 5);
  PHSEG (ALU1, 2, "vss", 14, 4, 14, 5);
  PHSEG (ALU1, 8, "vss", 14, 5, 32, 5);
  PHSEG (ALU1, 2, "vss", 32, 5, 32, 14);
  PHSEG (ALU1, 8, "vss", 32, 5, 38, 5);
  PHSEG (ALU1, 2, "vss", 38, 3, 38, 5);
  PHSEG (ALU1, 8, "vss", 38, 5, 44, 5);
  PHSEG (ALU1, 8, "vss", 44, 5, 50, 5);
  PHSEG (ALU1, 2, "vss", 50, 4, 50, 5);
  PHSEG (ALU1, 8, "vss", 50, 5, 68, 5);
  PHSEG (ALU1, 2, "vss", 68, 5, 68, 13);
  PHSEG (ALU1, 8, "vss", 68, 5, 74, 5);
  PHSEG (ALU1, 2, "vss", 74, 2, 74, 5);
  PHSEG (ALU1, 8, "vss", 74, 5, 77, 5);
  PHSEG (ALU1, 2, "vss", 44, 5, 44, 10);
  PHSEG (ALU1, 2, "vss", 44, 4, 44, 5);
  PHSEG (POLY, 1, "", 59, 9, 59, 27);
  PHSEG (POLY, 1, "", 59, 27, 60, 27);
  PHSEG (POLY, 1, "", 59, 27, 59, 37);
  PHSEG (POLY, 1, "", 59, 9, 62, 9);
  PHSEG (POLY, 1, "", 44, 19, 44, 22);
  PHSEG (POLY, 1, "", 44, 22, 53, 22);
  PHSEG (POLY, 1, "", 53, 16, 53, 22);
  PHSEG (POLY, 1, "", 43, 19, 44, 19);
  PHSEG (POLY, 1, "", 48, 26, 48, 27);
  PHSEG (POLY, 1, "", 40, 27, 48, 27);
  PHSEG (POLY, 1, "", 40, 26, 40, 27);
  PHSEG (POLY, 1, "", 35, 18, 35, 28);
  PHSEG (ALU1, 1, "", 32, 22, 32, 23);
  PHSEG (ALU1, 1, "", 22, 23, 32, 23);
  PHSEG (ALU1, 1, "", 32, 23, 34, 23);
  PHSEG (ALU1, 1, "", 34, 23, 34, 26);
  PHSEG (ALU1, 1, "", 34, 26, 35, 26);
  PHSEG (ALU1, 1, "", 43, 19, 44, 19);
  PHSEG (ALU1, 1, "", 44, 19, 44, 30);
  PHSEG (ALU1, 1, "", 38, 30, 44, 30);
  PHSEG (ALU1, 1, "", 44, 14, 44, 19);
  PHSEG (ALU1, 1, "", 38, 14, 44, 14);
  PHSEG (ALU1, 1, "", 38, 13, 38, 14);
  PHSEG (ALU1, 1, "", 38, 30, 38, 31);
  PHSEG (ALU1, 2, "", 38, 31, 38, 35);
  PHVIA (CONT_BODY_N, 44, 45);
  PHVIA (CONT_POLY, 24, 18);
  PHVIA (CONT_POLY, 30, 27);
  PHVIA (CONT_DIF_P, 32, 36);
  PHVIA (CONT_DIF_P, 14, 35);
  PHVIA (CONT_POLY, 22, 23);
  PHVIA (CONT_VIA, 32, 22);
  PHVIA (CONT_POLY, 35, 26);
  PHVIA (CONT_DIF_N, 20, 13);
  PHVIA (CONT_POLY, 25, 31);
  PHVIA (CONT_POLY, 40, 26);
  PHVIA (CONT_POLY, 43, 19);
  PHVIA (CONT_VIA, 74, 31);
  PHVIA (CONT_BODY_N, 62, 40);
  PHVIA (CONT_BODY_N, 62, 45);
  PHVIA (CONT_BODY_N, 50, 45);
  PHVIA (CONT_BODY_N, 26, 43);
  PHVIA (CONT_BODY_P, 74, 2);
  PHVIA (CONT_BODY_P, 50, 4);
  PHVIA (CONT_BODY_P, 44, 4);
  PHVIA (CONT_BODY_P, 38, 3);
  PHVIA (CONT_BODY_P, 14, 4);
  PHVIA (CONT_BODY_P, 8, 4);
  PHVIA (CONT_POLY, 10, 19);
  PHVIA (CONT_BODY_N, 8, 45);
  PHVIA (CONT_DIF_P, 8, 33);
  PHVIA (CONT_VIA, 8, 23);
  PHVIA (CONT_DIF_P, 20, 31);
  PHVIA (CONT_DIF_P, 20, 41);
  PHVIA (CONT_DIF_P, 14, 31);
  PHVIA (CONT_DIF_N, 32, 5);
  PHVIA (CONT_DIF_N, 8, 13);
  PHVIA (CONT_DIF_N, 14, 13);
  PHVIA (CONT_BODY_N, 14, 45);
  PHVIA (CONT_DIF_P, 26, 35);
  PHVIA (CONT_DIF_P, 8, 38);
  PHVIA (CONT_DIF_N, 26, 14);
  PHVIA (CONT_DIF_N, 38, 13);
  PHVIA (CONT_DIF_N, 32, 14);
  PHVIA (CONT_DIF_P, 32, 40);
  PHVIA (CONT_DIF_P, 32, 32);
  PHVIA (CONT_DIF_P, 38, 31);
  PHVIA (CONT_DIF_P, 38, 35);
  PHVIA (CONT_POLY, 64, 21);
  PHVIA (CONT_POLY, 48, 18);
  PHVIA (CONT_DIF_P, 44, 39);
  PHVIA (CONT_DIF_P, 44, 35);
  PHVIA (CONT_DIF_P, 50, 35);
  PHVIA (CONT_DIF_P, 50, 31);
  PHVIA (CONT_DIF_N, 44, 10);
  PHVIA (CONT_DIF_N, 50, 13);
  PHVIA (CONT_DIF_N, 74, 17);
  PHVIA (CONT_DIF_P, 74, 28);
  PHVIA (CONT_DIF_N, 68, 7);
  PHVIA (CONT_DIF_P, 68, 46);
  PHVIA (CONT_DIF_P, 62, 32);
  PHVIA (CONT_POLY, 60, 27);
  PHVIA (CONT_POLY, 48, 26);
  PHVIA (CONT_DIF_P, 56, 32);
  PHVIA (CONT_DIF_P, 56, 42);
  PHVIA (CONT_DIF_P, 68, 32);
  PHVIA (CONT_DIF_P, 68, 37);
  PHVIA (CONT_DIF_P, 68, 41);
  PHVIA (CONT_DIF_P, 74, 34);
  PHVIA (CONT_DIF_N, 56, 13);
  PHVIA (CONT_DIF_N, 62, 16);
  PHVIA (CONT_DIF_N, 68, 13);
  PHVIA (CONT_DIF_N, 74, 13);
  SAVE_PHFIG ();
  return ms;
}

char *
bd1n_p (msn, out, i1, i2)
     char *msn;
     char *out;
     char *i1, *i2;
{
  (void) delphfig (msn);
  DEF_PHFIG (msn);
  DEF_AB (5, 3, 77, 45);
  PHCON (ALU2, 2, i1, SOUTH, 8, 3);
  PHCON (ALU2, 2, i2, NORTH, 8, 45);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU2, 2, out, SOUTH, 74, 3);
  PHCON (ALU2, 2, out, NORTH, 74, 45);
  PHCON (ALU2, 2, i2, SOUTH, 32, 3);
  PHCON (ALU2, 2, i2, NORTH, 32, 45);
  PHCON (ALU1, 8, "vss", EAST, 77, 5);
  PHCON (ALU1, 8, "vdd", EAST, 77, 43);
  PHSEG (PTRANS, 1, "", 11, 27, 11, 42);
  PHSEG (NTRANS, 1, "", 11, 7, 11, 16);
  PHSEG (PDIF, 3, "", 14, 29, 14, 40);
  PHSEG (NDIF, 3, "", 14, 9, 14, 14);
  PHSEG (PTRANS, 4, "", 18, 36, 23, 36);
  PHSEG (PDIF, 3, "", 19, 41, 21, 41);
  PHSEG (TALU2, 2, "", 26, 3, 26, 45);
  PHSEG (PDIF, 3, "", 8, 29, 8, 40);
  PHSEG (NDIF, 3, "", 20, 4, 20, 14);
  PHSEG (TALU2, 2, "", 20, 3, 20, 45);
  PHSEG (PDIF, 3, "", 50, 29, 50, 40);
  PHSEG (PDIF, 3, "", 44, 29, 44, 40);
  PHSEG (NDIF, 3, "", 44, 9, 44, 14);
  PHSEG (ALU2, 2, "", 32, 3, 32, 45);
  PHSEG (PTRANS, 1, "", 71, 25, 71, 51);
  PHSEG (PTRANS, 1, "", 65, 28, 65, 36);
  PHSEG (NTRANS, 1, "", 71, 5, 71, 20);
  PHSEG (NTRANS, 1, "", 65, 11, 65, 19);
  PHSEG (ALU2, 2, "", 74, 3, 74, 45);
  PHSEG (PDIF, 3, "", 74, 27, 74, 49);
  PHSEG (PDIF, 3, "", 68, 30, 68, 49);
  PHSEG (NDIF, 3, "", 74, 7, 74, 18);
  PHSEG (PDIF, 3, "", 62, 30, 62, 34);
  PHSEG (NDIF, 3, "", 62, 13, 62, 17);
  PHSEG (NTIE, 3, "", 62, 40, 62, 45);
  PHSEG (PTRANS, 4, "", 54, 37, 59, 37);
  PHSEG (PDIF, 3, "", 55, 42, 57, 42);
  PHSEG (TALU2, 2, "", 68, 3, 68, 45);
  PHSEG (TALU2, 2, "", 62, 3, 62, 45);
  PHSEG (ALU1, 2, "", 74, 28, 74, 34);
  PHSEG (ALU1, 1, "", 74, 16, 74, 28);
  PHSEG (ALU1, 2, "", 74, 13, 74, 16);
  PHSEG (NDIF, 3, "", 68, 5, 68, 18);
  PHSEG (TALU2, 2, "", 44, 3, 44, 45);
  PHSEG (TALU2, 2, "", 50, 3, 50, 45);
  PHSEG (NDIF, 3, "", 56, 5, 56, 14);
  PHSEG (TALU2, 2, "", 56, 3, 56, 45);
  PHSEG (TALU2, 2, "", 38, 3, 38, 45);
  PHSEG (NTRANS, 1, "", 35, 6, 35, 18);
  PHSEG (NDIF, 3, "", 38, 8, 38, 16);
  PHSEG (NDIF, 3, "", 32, 4, 32, 16);
  PHSEG (PTRANS, 1, "", 35, 28, 35, 49);
  PHSEG (PDIF, 3, "", 32, 30, 32, 47);
  PHSEG (PDIF, 3, "", 38, 30, 38, 47);
  PHSEG (NTRANS, 1, "", 17, 7, 17, 16);
  PHSEG (NDIF, 3, "", 26, 12, 26, 15);
  PHSEG (NTRANS, 1, "", 29, 10, 29, 18);
  PHSEG (PTRANS, 1, "", 29, 32, 29, 40);
  PHSEG (PDIF, 3, "", 26, 34, 26, 38);
  PHSEG (TALU2, 2, "", 14, 3, 14, 45);
  PHSEG (NTRANS, 7, "", 62, 3, 62, 9);
  PHSEG (NTRANS, 1, "", 53, 7, 53, 16);
  PHSEG (ALU1, 1, "dff_s", 56, 21, 56, 32);
  PHSEG (ALU1, 1, "dff_s", 56, 13, 56, 21);
  PHSEG (ALU1, 1, "dff_s", 56, 21, 64, 21);
  PHSEG (NTRANS, 1, "", 47, 7, 47, 16);
  PHSEG (PTRANS, 1, "", 47, 27, 47, 42);
  PHSEG (NDIF, 2, "", 50, 9, 50, 14);
  PHSEG (ALU1, 1, "", 50, 30, 52, 30);
  PHSEG (ALU1, 1, "", 52, 14, 52, 30);
  PHSEG (ALU1, 1, "", 50, 14, 52, 14);
  PHSEG (ALU1, 1, "", 50, 13, 50, 14);
  PHSEG (ALU1, 1, "", 50, 30, 50, 31);
  PHSEG (ALU1, 2, "", 50, 31, 50, 35);
  PHSEG (ALU1, 1, "", 48, 18, 48, 26);
  PHSEG (ALU2, 2, i1, 8, 3, 8, 45);
  PHSEG (PTIE, 2, "", 8, 4, 14, 4);
  PHSEG (NTRANS, 7, "", 26, 2, 26, 8);
  PHSEG (NDIF, 3, "", 8, 9, 8, 14);
  PHSEG (PDIF, 3, "", 19, 31, 21, 31);
  PHSEG (POLY, 1, "", 29, 18, 29, 32);
  PHSEG (POLY, 1, "", 35, 18, 35, 28);
  PHSEG (NWELL, 72, "", 41, 26, 41, 52);
  PHSEG (ALU1, 2, "", 14, 31, 14, 35);
  PHSEG (ALU1, 1, "", 14, 14, 14, 30);
  PHSEG (ALU1, 1, "", 25, 35, 26, 35);
  PHSEG (ALU1, 2, "", 25, 31, 25, 35);
  PHSEG (POLY, 1, "", 23, 31, 23, 36);
  PHSEG (POLY, 1, "", 23, 31, 26, 31);
  PHSEG (POLY, 1, "", 26, 18, 26, 31);
  PHSEG (POLY, 1, "", 23, 18, 26, 18);
  PHSEG (POLY, 1, "", 23, 8, 23, 18);
  PHSEG (POLY, 1, "", 23, 8, 26, 8);
  PHSEG (ALU1, 1, "dff_m", 20, 13, 20, 17);
  PHSEG (ALU1, 1, "dff_m", 18, 17, 20, 17);
  PHSEG (ALU1, 1, "dff_m", 18, 17, 18, 27);
  PHSEG (ALU1, 1, "dff_m", 18, 27, 20, 27);
  PHSEG (ALU1, 1, "dff_m", 20, 27, 20, 31);
  PHSEG (ALU1, 1, "dff_m", 20, 27, 30, 27);
  PHSEG (POLY, 1, "", 17, 23, 22, 23);
  PHSEG (POLY, 1, "", 17, 16, 17, 23);
  PHSEG (ALU1, 1, "", 9, 19, 10, 19);
  PHSEG (ALU1, 1, "", 9, 19, 9, 23);
  PHSEG (ALU1, 1, "", 8, 23, 9, 23);
  PHSEG (ALU1, 1, "", 25, 14, 25, 18);
  PHSEG (ALU1, 1, "", 24, 18, 25, 18);
  PHSEG (ALU1, 1, "", 25, 18, 39, 18);
  PHSEG (ALU1, 1, "", 39, 18, 39, 26);
  PHSEG (ALU1, 1, "", 39, 26, 40, 26);
  PHSEG (ALU1, 1, "", 25, 14, 26, 14);
  PHSEG (PTIE, 2, "", 38, 3, 44, 3);
  PHSEG (PTIE, 3, "", 44, 3, 44, 4);
  PHSEG (PTIE, 2, "", 44, 4, 50, 4);
  PHSEG (NTIE, 2, "", 44, 45, 50, 45);
  PHSEG (POLY, 1, "", 47, 16, 47, 18);
  PHSEG (POLY, 1, "", 47, 18, 48, 18);
  PHSEG (POLY, 1, "", 11, 19, 11, 27);
  PHSEG (POLY, 1, "", 11, 16, 11, 19);
  PHSEG (POLY, 1, "", 10, 19, 11, 19);
  PHSEG (NTIE, 2, "", 8, 45, 14, 45);
  PHSEG (ALU1, 2, "vdd", 68, 43, 68, 46);
  PHSEG (ALU1, 2, "vdd", 68, 32, 68, 43);
  PHSEG (ALU1, 8, "vdd", 68, 43, 77, 43);
  PHSEG (ALU1, 8, "vdd", 62, 43, 68, 43);
  PHSEG (ALU1, 2, "vdd", 62, 40, 62, 43);
  PHSEG (ALU1, 2, "vdd", 62, 43, 62, 45);
  PHSEG (ALU1, 8, "vdd", 56, 43, 62, 43);
  PHSEG (ALU1, 2, "vdd", 56, 42, 56, 43);
  PHSEG (ALU1, 8, "vdd", 50, 43, 56, 43);
  PHSEG (ALU1, 2, "vdd", 50, 43, 50, 45);
  PHSEG (ALU1, 8, "vdd", 44, 43, 50, 43);
  PHSEG (ALU1, 2, "vdd", 44, 35, 44, 43);
  PHSEG (ALU1, 2, "vdd", 44, 43, 44, 45);
  PHSEG (ALU1, 8, "vdd", 32, 43, 44, 43);
  PHSEG (ALU1, 2, "vdd", 32, 32, 32, 43);
  PHSEG (ALU1, 8, "vdd", 20, 43, 32, 43);
  PHSEG (ALU1, 2, "vdd", 20, 41, 20, 43);
  PHSEG (ALU1, 8, "vdd", 14, 43, 20, 43);
  PHSEG (ALU1, 2, "vdd", 14, 43, 14, 45);
  PHSEG (ALU1, 8, "vdd", 8, 43, 14, 43);
  PHSEG (ALU1, 8, "vdd", 5, 43, 8, 43);
  PHSEG (ALU1, 2, "vdd", 8, 33, 8, 43);
  PHSEG (ALU1, 2, "vdd", 8, 43, 8, 45);
  PHSEG (ALU1, 2, "vss", 8, 4, 8, 5);
  PHSEG (ALU1, 2, "vss", 8, 5, 8, 13);
  PHSEG (ALU1, 8, "vss", 5, 5, 8, 5);
  PHSEG (ALU1, 8, "vss", 8, 5, 14, 5);
  PHSEG (ALU1, 2, "vss", 14, 4, 14, 5);
  PHSEG (ALU1, 8, "vss", 14, 5, 32, 5);
  PHSEG (ALU1, 2, "vss", 32, 5, 32, 14);
  PHSEG (ALU1, 8, "vss", 32, 5, 38, 5);
  PHSEG (ALU1, 2, "vss", 38, 3, 38, 5);
  PHSEG (ALU1, 8, "vss", 38, 5, 44, 5);
  PHSEG (ALU1, 8, "vss", 44, 5, 50, 5);
  PHSEG (ALU1, 2, "vss", 50, 4, 50, 5);
  PHSEG (ALU1, 8, "vss", 50, 5, 68, 5);
  PHSEG (ALU1, 2, "vss", 68, 5, 68, 13);
  PHSEG (ALU1, 8, "vss", 68, 5, 74, 5);
  PHSEG (ALU1, 2, "vss", 74, 2, 74, 5);
  PHSEG (ALU1, 8, "vss", 74, 5, 77, 5);
  PHSEG (ALU1, 2, "vss", 44, 5, 44, 10);
  PHSEG (ALU1, 2, "vss", 44, 4, 44, 5);
  PHSEG (POLY, 1, "", 59, 9, 59, 27);
  PHSEG (POLY, 1, "", 59, 27, 60, 27);
  PHSEG (POLY, 1, "", 59, 27, 59, 37);
  PHSEG (POLY, 1, "", 59, 9, 62, 9);
  PHSEG (POLY, 1, "", 64, 21, 65, 21);
  PHSEG (POLY, 1, "", 65, 19, 65, 21);
  PHSEG (POLY, 1, "", 65, 21, 65, 28);
  PHSEG (ALU1, 1, "", 60, 27, 60, 28);
  PHSEG (ALU1, 1, "", 60, 28, 62, 28);
  PHSEG (ALU1, 1, "", 62, 28, 62, 32);
  PHSEG (ALU1, 1, "", 62, 28, 69, 28);
  PHSEG (ALU1, 1, "", 69, 23, 69, 28);
  PHSEG (ALU1, 1, "", 69, 17, 69, 23);
  PHSEG (ALU1, 1, "", 62, 17, 69, 17);
  PHSEG (ALU1, 1, "", 62, 16, 62, 17);
  PHSEG (ALU1, 1, "", 69, 23, 70, 23);
  PHSEG (POLY, 1, "", 71, 23, 71, 25);
  PHSEG (POLY, 1, "", 71, 20, 71, 23);
  PHSEG (POLY, 1, "", 70, 23, 71, 23);
  PHSEG (POLY, 1, "", 44, 19, 44, 22);
  PHSEG (POLY, 1, "", 44, 22, 53, 22);
  PHSEG (POLY, 1, "", 53, 16, 53, 22);
  PHSEG (POLY, 1, "", 43, 19, 44, 19);
  PHSEG (POLY, 1, "", 48, 26, 48, 27);
  PHSEG (POLY, 1, "", 40, 27, 48, 27);
  PHSEG (POLY, 1, "", 40, 26, 40, 27);
  PHSEG (ALU1, 1, "", 43, 19, 44, 19);
  PHSEG (ALU1, 1, "", 44, 19, 44, 30);
  PHSEG (ALU1, 1, "", 38, 30, 44, 30);
  PHSEG (ALU1, 1, "", 44, 14, 44, 19);
  PHSEG (ALU1, 1, "", 38, 14, 44, 14);
  PHSEG (ALU1, 1, "", 38, 13, 38, 14);
  PHSEG (ALU1, 1, "", 38, 30, 38, 31);
  PHSEG (ALU1, 2, "", 38, 31, 38, 35);
  PHSEG (ALU1, 1, "", 32, 22, 32, 23);
  PHSEG (ALU1, 1, "", 22, 23, 32, 23);
  PHSEG (ALU1, 1, "", 32, 23, 34, 23);
  PHSEG (ALU1, 1, "", 34, 23, 34, 26);
  PHSEG (ALU1, 1, "", 34, 26, 35, 26);
  PHVIA (CONT_POLY, 70, 23);
  PHVIA (CONT_BODY_N, 44, 45);
  PHVIA (CONT_POLY, 24, 18);
  PHVIA (CONT_POLY, 30, 27);
  PHVIA (CONT_DIF_P, 32, 36);
  PHVIA (CONT_DIF_P, 14, 35);
  PHVIA (CONT_POLY, 22, 23);
  PHVIA (CONT_VIA, 32, 22);
  PHVIA (CONT_POLY, 35, 26);
  PHVIA (CONT_DIF_N, 20, 13);
  PHVIA (CONT_POLY, 25, 31);
  PHVIA (CONT_POLY, 40, 26);
  PHVIA (CONT_POLY, 43, 19);
  PHVIA (CONT_VIA, 74, 31);
  PHVIA (CONT_BODY_N, 62, 40);
  PHVIA (CONT_BODY_N, 62, 45);
  PHVIA (CONT_BODY_N, 50, 45);
  PHVIA (CONT_BODY_N, 26, 43);
  PHVIA (CONT_BODY_P, 74, 2);
  PHVIA (CONT_BODY_P, 50, 4);
  PHVIA (CONT_BODY_P, 44, 4);
  PHVIA (CONT_BODY_P, 38, 3);
  PHVIA (CONT_BODY_P, 14, 4);
  PHVIA (CONT_BODY_P, 8, 4);
  PHVIA (CONT_POLY, 10, 19);
  PHVIA (CONT_BODY_N, 8, 45);
  PHVIA (CONT_DIF_P, 8, 33);
  PHVIA (CONT_VIA, 8, 23);
  PHVIA (CONT_DIF_P, 20, 31);
  PHVIA (CONT_DIF_P, 20, 41);
  PHVIA (CONT_DIF_P, 14, 31);
  PHVIA (CONT_DIF_N, 32, 5);
  PHVIA (CONT_DIF_N, 8, 13);
  PHVIA (CONT_DIF_N, 14, 13);
  PHVIA (CONT_BODY_N, 14, 45);
  PHVIA (CONT_DIF_P, 26, 35);
  PHVIA (CONT_DIF_P, 8, 38);
  PHVIA (CONT_DIF_N, 26, 14);
  PHVIA (CONT_DIF_N, 38, 13);
  PHVIA (CONT_DIF_N, 32, 14);
  PHVIA (CONT_DIF_P, 32, 40);
  PHVIA (CONT_DIF_P, 32, 32);
  PHVIA (CONT_DIF_P, 38, 31);
  PHVIA (CONT_DIF_P, 38, 35);
  PHVIA (CONT_POLY, 64, 21);
  PHVIA (CONT_POLY, 48, 18);
  PHVIA (CONT_DIF_P, 44, 39);
  PHVIA (CONT_DIF_P, 44, 35);
  PHVIA (CONT_DIF_P, 50, 35);
  PHVIA (CONT_DIF_P, 50, 31);
  PHVIA (CONT_DIF_N, 44, 10);
  PHVIA (CONT_DIF_N, 50, 13);
  PHVIA (CONT_DIF_N, 74, 17);
  PHVIA (CONT_DIF_P, 74, 28);
  PHVIA (CONT_DIF_N, 68, 7);
  PHVIA (CONT_DIF_P, 68, 46);
  PHVIA (CONT_DIF_P, 62, 32);
  PHVIA (CONT_POLY, 60, 27);
  PHVIA (CONT_POLY, 48, 26);
  PHVIA (CONT_DIF_P, 56, 32);
  PHVIA (CONT_DIF_P, 56, 42);
  PHVIA (CONT_DIF_P, 68, 32);
  PHVIA (CONT_DIF_P, 68, 37);
  PHVIA (CONT_DIF_P, 68, 41);
  PHVIA (CONT_DIF_P, 74, 34);
  PHVIA (CONT_DIF_N, 56, 13);
  PHVIA (CONT_DIF_N, 62, 16);
  PHVIA (CONT_DIF_N, 68, 13);
  PHVIA (CONT_DIF_N, 74, 13);
  SAVE_PHFIG ();
  return msn;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *n1_p(char *, char *, char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = n1_p("", "s", "i0")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
n1_p (n1, out, in)
     char *n1;
     char *out;
     char *in;
{
  (void) delphfig (n1);
  DEF_PHFIG (n1);
  DEF_AB (5, 3, 17, 45);
  PHCON (ALU2, 2, out, NORTH, 8, 45);
  PHCON (ALU2, 2, in, SOUTH, 14, 3);
  PHCON (ALU1, 8, "vdd", EAST, 17, 43);
  PHCON (ALU1, 8, "vss", EAST, 17, 5);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU2, 2, in, NORTH, 14, 45);
  PHCON (ALU2, 2, out, SOUTH, 8, 3);
  PHSEG (ALU1, 8, "vdd", 5, 43, 17, 43);
  PHSEG (ALU1, 8, "vss", 5, 5, 17, 5);
  PHSEG (ALU1, 2, "", 8, 16, 8, 34);
  PHSEG (POLY, 2, "", 11, 23, 13, 23);
  PHSEG (POLY, 1, "", 11, 20, 11, 25);
  PHSEG (ALU1, 2, "", 13, 23, 14, 23);
  PHSEG (ALU1, 1, "", 14, 23, 14, 28);
  PHSEG (NDIF, 3, "", 8, 13, 8, 18);
  PHSEG (PTIE, 2, "", 8, 3, 14, 3);
  PHSEG (NTIE, 2, "", 8, 45, 14, 45);
  PHSEG (NWELL, 26, "", 5, 39, 17, 39);
  PHSEG (PDIF, 3, "", 8, 27, 8, 38);
  PHSEG (PDIF, 3, "", 14, 27, 14, 39);
  PHSEG (NDIF, 3, "", 14, 13, 14, 18);
  PHSEG (NTRANS, 1, "", 11, 11, 11, 20);
  PHSEG (PTRANS, 1, "", 11, 25, 11, 40);
  PHSEG (ALU2, 2, in, 14, 3, 14, 45);
  PHSEG (ALU2, 2, out, 8, 3, 8, 45);
  PHSEG (ALU1, 1, "vdd", 14, 43, 14, 45);
  PHSEG (ALU1, 1, "vdd", 8, 45, 14, 45);
  PHSEG (ALU1, 2, "vdd", 14, 33, 14, 43);
  PHSEG (ALU1, 2, "vss", 8, 3, 14, 3);
  PHSEG (ALU1, 2, "vss", 14, 3, 14, 16);
  PHVIA (CONT_DIF_N, 14, 16);
  PHVIA (CONT_DIF_N, 8, 16);
  PHVIA (CONT_DIF_P, 8, 28);
  PHVIA (CONT_DIF_P, 8, 34);
  PHVIA (CONT_DIF_P, 14, 33);
  PHVIA (CONT_DIF_P, 14, 39);
  PHVIA (CONT_VIA, 8, 21);
  PHVIA (CONT_VIA, 14, 28);
  PHVIA (CONT_POLY, 13, 23);
  PHVIA (CONT_BODY_P, 14, 3);
  PHVIA (CONT_BODY_N, 8, 45);
  PHVIA (CONT_BODY_N, 14, 45);
  PHVIA (CONT_BODY_P, 8, 3);
  SAVE_PHFIG ();
  return n1;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *b1_p(char *, char *, char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = b1_p("", "s", "i0")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
b1_p (b1, out, in)
     char *b1;
     char *out;
     char *in;
{
  (void) delphfig (b1);
  DEF_PHFIG (b1);
  DEF_AB (5, 3, 29, 45);
  PHCON (ALU2, 2, "t", SOUTH, 20, 3);
  PHCON (ALU2, 2, "t", NORTH, 20, 45);
  PHCON (ALU2, 2, "i", SOUTH, 14, 3);
  PHCON (ALU2, 2, "i", NORTH, 14, 45);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHCON (ALU1, 8, "vss", EAST, 29, 5);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU1, 8, "vdd", EAST, 29, 43);
  PHSEG (ALU1, 2, "", 17, 20, 17, 22);
  PHSEG (ALU1, 1, "", 16, 20, 17, 20);
  PHSEG (ALU1, 1, "", 16, 19, 16, 20);
  PHSEG (ALU1, 1, "", 8, 19, 16, 19);
  PHSEG (PTRANS, 1, "", 17, 25, 17, 51);
  PHSEG (NDIF, 3, "", 14, 7, 14, 18);
  PHSEG (PDIF, 3, "", 20, 27, 20, 49);
  PHSEG (ALU2, 2, "", 20, 3, 20, 45);
  PHSEG (ALU2, 2, "", 14, 3, 14, 45);
  PHSEG (PDIF, 3, "", 8, 27, 8, 41);
  PHSEG (PDIF, 3, "", 14, 27, 14, 49);
  PHSEG (PTRANS, 1, "", 23, 25, 23, 51);
  PHSEG (NTRANS, 1, "", 17, 5, 17, 20);
  PHSEG (NTRANS, 1, "", 23, 5, 23, 20);
  PHSEG (PDIF, 3, "", 26, 27, 26, 49);
  PHSEG (NWELL, 26, "", 5, 39, 29, 39);
  PHSEG (NDIF, 3, "", 20, 7, 20, 18);
  PHSEG (NDIF, 3, "", 26, 7, 26, 18);
  PHSEG (NDIF, 3, "", 8, 10, 8, 18);
  PHSEG (TALU2, 2, "", 8, 3, 8, 45);
  PHSEG (TALU2, 2, "", 26, 3, 26, 45);
  PHSEG (POLY, 1, "", 17, 20, 17, 25);
  PHSEG (POLY, 1, "", 17, 21, 23, 21);
  PHSEG (POLY, 1, "", 23, 20, 23, 25);
  PHSEG (ALU1, 2, "vdd", 26, 30, 26, 43);
  PHSEG (ALU1, 1, "vdd", 26, 43, 26, 45);
  PHSEG (ALU1, 1, "", 21, 14, 21, 27);
  PHSEG (ALU1, 2, "", 8, 13, 8, 19);
  PHSEG (ALU1, 2, "", 8, 29, 8, 35);
  PHSEG (ALU1, 1, "", 8, 19, 8, 29);
  PHSEG (ALU1, 1, "", 12, 25, 13, 25);
  PHSEG (ALU1, 1, "", 13, 25, 13, 28);
  PHSEG (ALU1, 1, "", 13, 28, 14, 28);
  PHSEG (ALU1, 1, "", 12, 24, 12, 25);
  PHSEG (PTRANS, 1, "", 11, 25, 11, 43);
  PHSEG (NTRANS, 1, "", 11, 8, 11, 20);
  PHSEG (POLY, 1, "", 11, 20, 11, 25);
  PHSEG (POLY, 1, "", 11, 24, 12, 24);
  PHSEG (ALU1, 8, "vdd", 5, 43, 29, 43);
  PHSEG (ALU1, 1, "vdd", 8, 43, 8, 46);
  PHSEG (ALU1, 2, "vdd", 14, 33, 14, 45);
  PHSEG (ALU1, 2, "vss", 14, 5, 14, 14);
  PHSEG (ALU1, 8, "vss", 5, 5, 29, 5);
  PHSEG (ALU1, 1, "vss", 8, 3, 8, 5);
  PHSEG (ALU1, 2, "vss", 26, 5, 26, 17);
  PHSEG (ALU1, 1, "", 20, 14, 21, 14);
  PHSEG (ALU1, 1, "", 20, 13, 20, 14);
  PHSEG (ALU1, 2, "", 20, 27, 21, 27);
  PHSEG (ALU1, 2, "", 20, 27, 20, 34);
  PHVIA (CONT_DIF_P, 20, 30);
  PHVIA (CONT_POLY, 12, 24);
  PHVIA (CONT_DIF_P, 26, 30);
  PHVIA (CONT_DIF_P, 26, 36);
  PHVIA (CONT_DIF_P, 26, 41);
  PHVIA (CONT_DIF_P, 26, 45);
  PHVIA (CONT_DIF_N, 26, 8);
  PHVIA (CONT_DIF_N, 26, 13);
  PHVIA (CONT_DIF_N, 26, 17);
  PHVIA (CONT_VIA, 14, 28);
  PHVIA (CONT_BODY_N, 8, 46);
  PHVIA (CONT_BODY_P, 8, 3);
  PHVIA (CONT_DIF_P, 8, 35);
  PHVIA (CONT_DIF_P, 14, 33);
  PHVIA (CONT_DIF_P, 8, 29);
  PHVIA (CONT_DIF_N, 8, 17);
  PHVIA (CONT_DIF_N, 8, 13);
  PHVIA (CONT_DIF_N, 14, 8);
  PHVIA (CONT_DIF_P, 14, 45);
  PHVIA (CONT_VIA, 20, 27);
  PHVIA (CONT_POLY, 17, 22);
  PHVIA (CONT_DIF_P, 20, 34);
  PHVIA (CONT_DIF_P, 14, 39);
  PHVIA (CONT_DIF_N, 20, 13);
  PHVIA (CONT_DIF_N, 14, 14);
  SAVE_PHFIG ();
  return b1;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *n1p_p(char *, char *, char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = n1_p("", "s", "i0")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
n1p_p (n1p, out, in)
     char *n1p;
     char *out;
     char *in;
{
  (void) delphfig (n1p);
  DEF_PHFIG (n1p);
  DEF_AB (5, 3, 23, 45);
  PHCON (ALU1, 8, "vdd", EAST, 23, 43);
  PHCON (ALU1, 8, "vss", EAST, 23, 5);
  PHCON (ALU2, 2, out, NORTH, 8, 45);
  PHCON (ALU2, 2, in, NORTH, 14, 45);
  PHCON (ALU2, 2, out, SOUTH, 8, 3);
  PHCON (ALU2, 2, in, SOUTH, 14, 3);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHSEG (ALU1, 1, "", 8, 17, 8, 29);
  PHSEG (ALU1, 2, "", 8, 29, 8, 34);
  PHSEG (ALU1, 8, "vss", 5, 5, 23, 5);
  PHSEG (ALU1, 2, "vdd", 14, 33, 14, 45);
  PHSEG (ALU1, 8, "vdd", 5, 43, 23, 43);
  PHSEG (TALU2, 2, "", 20, 3, 20, 45);
  PHSEG (ALU1, 1, "", 13, 22, 14, 22);
  PHSEG (ALU1, 1, "", 14, 22, 14, 28);
  PHSEG (ALU2, 2, in, 14, 3, 14, 45);
  PHSEG (NDIF, 3, "", 14, 7, 14, 18);
  PHSEG (POLY, 2, "", 11, 22, 13, 22);
  PHSEG (POLY, 1, "", 11, 20, 11, 25);
  PHSEG (PDIF, 3, "", 8, 27, 8, 49);
  PHSEG (PTIE, 3, "", 20, 5, 20, 16);
  PHSEG (ALU2, 2, out, 8, 3, 8, 45);
  PHSEG (PDIF, 3, "", 14, 27, 14, 49);
  PHSEG (NDIF, 3, "", 8, 7, 8, 18);
  PHSEG (NTRANS, 1, "", 11, 5, 11, 20);
  PHSEG (PTRANS, 1, "", 11, 25, 11, 51);
  PHSEG (NWELL, 26, "", 5, 39, 23, 39);
  PHSEG (NTIE, 3, "", 20, 29, 20, 45);
  PHSEG (ALU1, 2, "", 8, 13, 8, 17);
  PHSEG (ALU1, 2, "vss", 14, 5, 14, 17);
  PHSEG (ALU1, 2, "vdd", 20, 28, 20, 45);
  PHSEG (ALU1, 2, "vss", 20, 3, 20, 17);
  PHVIA (CONT_BODY_N, 20, 28);
  PHVIA (CONT_BODY_P, 20, 8);
  PHVIA (CONT_DIF_N, 14, 13);
  PHVIA (CONT_DIF_N, 8, 13);
  PHVIA (CONT_BODY_N, 20, 45);
  PHVIA (CONT_BODY_N, 20, 39);
  PHVIA (CONT_BODY_N, 20, 33);
  PHVIA (CONT_BODY_P, 20, 3);
  PHVIA (CONT_BODY_P, 20, 13);
  PHVIA (CONT_BODY_P, 20, 17);
  PHVIA (CONT_DIF_N, 8, 17);
  PHVIA (CONT_DIF_N, 14, 17);
  PHVIA (CONT_DIF_P, 14, 39);
  PHVIA (CONT_DIF_P, 14, 33);
  PHVIA (CONT_DIF_P, 8, 34);
  PHVIA (CONT_DIF_P, 8, 28);
  PHVIA (CONT_POLY, 13, 22);
  PHVIA (CONT_VIA, 8, 22);
  PHVIA (CONT_VIA, 14, 28);
  PHVIA (CONT_DIF_P, 14, 45);
  PHVIA (CONT_DIF_N, 14, 8);
  SAVE_PHFIG ();
  return n1p;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *nt1_p(char *, int, int, char *, char *,char *, char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = nt1_p("", 1, 1, "s", "i", "v0", "v1")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
bus_p (bus, out, in1, in2)
     char *bus;
     char *out;
     char *in1, *in2;
{
  (void) delphfig (bus);
  DEF_PHFIG (bus);
  DEF_AB (5, 6, 53, 48);
  PHCON (ALU1, 8, "vdd", WEST, 5, 46);
  PHCON (ALU1, 8, "vdd", EAST, 53, 46);
  PHCON (ALU1, 8, "vss", WEST, 5, 8);
  PHCON (ALU1, 8, "vss", EAST, 53, 8);
  PHCON (ALU2, 2, in1, NORTH, 38, 48);
  PHCON (ALU2, 2, in1, SOUTH, 38, 6);
  PHCON (ALU2, 2, out, NORTH, 44, 48);
  PHCON (ALU2, 2, out, SOUTH, 44, 6);
  PHCON (ALU2, 2, in2, NORTH, 26, 48);
  PHCON (ALU2, 2, in2, SOUTH, 26, 6);
  PHSEG (ALU1, 8, "", 5, 8, 53, 8);
  PHSEG (ALU1, 8, "", 5, 46, 53, 46);
  PHSEG (PTRANS, 1, "", 11, 28, 11, 45);
  PHSEG (PTRANS, 1, "", 23, 28, 23, 45);
  PHSEG (PTRANS, 1, "", 29, 28, 29, 45);
  PHSEG (PTRANS, 1, "", 35, 28, 35, 45);
  PHSEG (NWELL, 26, "", 5, 42, 53, 42);
  PHSEG (POLY, 1, "", 39, 28, 47, 28);
  PHSEG (POLY, 1, "", 41, 22, 49, 22);
  PHSEG (POLY, 1, "", 35, 22, 35, 28);
  PHSEG (POLY, 1, "", 23, 28, 29, 28);
  PHSEG (POLY, 1, "", 23, 22, 23, 28);
  PHSEG (POLY, 1, "", 11, 22, 23, 22);
  PHSEG (ALU1, 1, "", 8, 15, 49, 15);
  PHSEG (ALU1, 1, "", 14, 37, 39, 37);
  PHSEG (ALU1, 1, "", 14, 19, 14, 37);
  PHSEG (ALU1, 1, "", 8, 15, 8, 37);
  PHSEG (ALU1, 1, "", 20, 19, 20, 33);
  PHSEG (POLY, 1, "", 11, 26, 11, 28);
  PHSEG (POLY, 1, "", 11, 26, 19, 26);
  PHSEG (ALU1, 1, "", 20, 23, 29, 23);
  PHSEG (ALU1, 2, "", 44, 19, 44, 37);
  PHSEG (NDIF, 3, "", 38, 6, 38, 20);
  PHSEG (NDIF, 3, "", 44, 9, 44, 19);
  PHSEG (NDIF, 3, "", 32, 14, 32, 20);
  PHSEG (NDIF, 3, "", 50, 6, 50, 20);
  PHSEG (ALU1, 1, "", 49, 15, 49, 23);
  PHSEG (ALU1, 1, "", 39, 27, 39, 37);
  PHSEG (PDIF, 3, "", 44, 30, 44, 52);
  PHSEG (PDIF, 3, "", 38, 30, 38, 52);
  PHSEG (PDIF, 2, "", 32, 30, 32, 43);
  PHSEG (PDIF, 2, "", 26, 30, 26, 43);
  PHSEG (PDIF, 3, "", 20, 30, 20, 43);
  PHSEG (PDIF, 3, "", 14, 30, 14, 43);
  PHSEG (PDIF, 3, "", 8, 30, 8, 43);
  PHSEG (PDIF, 3, "", 50, 30, 50, 52);
  PHSEG (NDIF, 3, "", 26, 6, 26, 20);
  PHSEG (NDIF, 3, "", 20, 14, 20, 20);
  PHSEG (NDIF, 3, "", 14, 14, 14, 19);
  PHSEG (NDIF, 3, "", 8, 14, 8, 20);
  PHSEG (ALU1, 1, "", 34, 22, 38, 22);
  PHSEG (ALU1, 2, "", 38, 19, 38, 22);
  PHSEG (ALU1, 2, "", 25, 27, 25, 33);
  PHSEG (ALU1, 2, "", 26, 41, 26, 46);
  PHSEG (ALU1, 2, "", 38, 41, 38, 46);
  PHSEG (ALU1, 2, "", 50, 32, 50, 46);
  PHSEG (ALU2, 2, "", 44, 6, 44, 48);
  PHSEG (ALU2, 2, "", 38, 6, 38, 48);
  PHSEG (ALU2, 2, "", 26, 6, 26, 48);
  PHSEG (TALU2, 2, "", 50, 6, 50, 48);
  PHSEG (TALU2, 2, "", 32, 6, 32, 48);
  PHSEG (TALU2, 2, "", 20, 6, 20, 48);
  PHSEG (TALU2, 2, "", 14, 6, 14, 48);
  PHSEG (TALU2, 2, "", 8, 6, 8, 48);
  PHSEG (ALU1, 2, "", 34, 22, 34, 25);
  PHSEG (PTRANS, 1, "", 47, 28, 47, 54);
  PHSEG (PTRANS, 1, "", 41, 28, 41, 54);
  PHSEG (NTRANS, 1, "", 47, 7, 47, 22);
  PHSEG (NTRANS, 1, "", 41, 7, 41, 22);
  PHSEG (NTRANS, 1, "", 29, 12, 29, 22);
  PHSEG (NTRANS, 1, "", 23, 12, 23, 22);
  PHSEG (NTRANS, 1, "", 11, 12, 11, 22);
  PHSEG (NTRANS, 1, "", 35, 12, 35, 22);
  PHVIA (CONT_DIF_P, 20, 33);
  PHVIA (CONT_DIF_P, 44, 32);
  PHVIA (CONT_DIF_P, 14, 37);
  PHVIA (CONT_DIF_P, 32, 37);
  PHVIA (CONT_DIF_N, 20, 19);
  PHVIA (CONT_DIF_N, 44, 19);
  PHVIA (CONT_DIF_N, 32, 16);
  PHVIA (CONT_DIF_N, 8, 19);
  PHVIA (CONT_DIF_N, 14, 19);
  PHVIA (CONT_DIF_P, 8, 37);
  PHVIA (CONT_POLY, 19, 26);
  PHVIA (CONT_POLY, 29, 23);
  PHVIA (CONT_POLY, 24, 27);
  PHVIA (CONT_VIA, 26, 33);
  PHVIA (CONT_POLY, 49, 23);
  PHVIA (CONT_DIF_N, 50, 11);
  PHVIA (CONT_DIF_N, 38, 11);
  PHVIA (CONT_DIF_N, 26, 11);
  PHVIA (CONT_BODY_P, 32, 6);
  PHVIA (CONT_BODY_P, 8, 6);
  PHVIA (CONT_POLY, 34, 25);
  PHVIA (CONT_POLY, 39, 27);
  PHVIA (CONT_DIF_P, 50, 41);
  PHVIA (CONT_DIF_P, 38, 41);
  PHVIA (CONT_DIF_P, 26, 41);
  PHVIA (CONT_VIA, 38, 19);
  PHVIA (CONT_VIA, 44, 37);
  PHVIA (CONT_BODY_N, 32, 48);
  PHVIA (CONT_BODY_N, 8, 48);
  PHVIA (CONT_BODY_N, 14, 48);
  PHVIA (CONT_BODY_N, 20, 48);
  PHVIA (CONT_BODY_P, 14, 6);
  PHVIA (CONT_BODY_P, 20, 6);
  PHVIA (CONT_DIF_P, 38, 48);
  PHVIA (CONT_DIF_P, 50, 48);
  PHVIA (CONT_DIF_P, 50, 32);
  PHVIA (CONT_DIF_N, 26, 6);
  PHVIA (CONT_DIF_N, 38, 6);
  PHVIA (CONT_DIF_N, 50, 6);
  SAVE_PHFIG ();
  return bus;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *l1_p(char *, int, int, char *, char *, char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = l1_p("", 1, 1, "s" "i", "l")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
l1_p (l1, out, i1, i2)
     char *l1;
     char *out;
     char *i1, *i2;
{
  (void) delphfig (l1);
  DEF_PHFIG (l1);
  DEF_AB (5, 4, 35, 46);
  PHCON (ALU2, 2, out, SOUTH, 8, 4);
  PHCON (ALU1, 8, "vss", EAST, 35, 6);
  PHCON (ALU1, 8, "vss", WEST, 5, 6);
  PHCON (ALU1, 8, "vdd", WEST, 5, 44);
  PHCON (ALU1, 8, "vdd", EAST, 35, 44);
  PHCON (ALU2, 2, i2, SOUTH, 32, 4);
  PHCON (ALU2, 2, i2, NORTH, 32, 46);
  PHCON (ALU2, 2, i1, SOUTH, 26, 4);
  PHCON (ALU2, 2, i1, NORTH, 26, 46);
  PHCON (ALU2, 2, out, NORTH, 8, 46);
  PHSEG (POLY, 1, "", 23, 8, 26, 8);
  PHSEG (POLY, 1, "", 23, 8, 23, 39);
  PHSEG (ALU1, 1, "", 20, 18, 20, 19);
  PHSEG (ALU1, 1, "", 14, 19, 20, 19);
  PHSEG (ALU1, 1, "mpx_s", 26, 24, 26, 34);
  PHSEG (ALU1, 1, "mpx_s", 18, 24, 32, 24);
  PHSEG (NWELL, 26, "", 5, 40, 35, 40);
  PHSEG (PTRANS, 1, "", 11, 26, 11, 52);
  PHSEG (PTRANS, 1, "", 17, 26, 17, 34);
  PHSEG (NTRANS, 1, "", 11, 6, 11, 21);
  PHSEG (NTRANS, 1, "", 17, 13, 17, 21);
  PHSEG (NTRANS, 1, "", 29, 12, 29, 21);
  PHSEG (ALU2, 2, "", 32, 4, 32, 46);
  PHSEG (ALU2, 2, "", 26, 4, 26, 46);
  PHSEG (ALU2, 2, "", 8, 4, 8, 46);
  PHSEG (PDIF, 3, "", 8, 28, 8, 50);
  PHSEG (PDIF, 3, "", 14, 28, 14, 50);
  PHSEG (NDIF, 3, "", 8, 8, 8, 19);
  PHSEG (PDIF, 3, "", 20, 29, 20, 32);
  PHSEG (NDIF, 3, "", 20, 15, 20, 19);
  PHSEG (POLY, 1, "", 11, 21, 11, 26);
  PHSEG (POLY, 2, "", 11, 23, 13, 23);
  PHSEG (ALU1, 1, "", 32, 29, 32, 34);
  PHSEG (ALU1, 2, "", 30, 29, 32, 29);
  PHSEG (PTIE, 2, "", 8, 3, 14, 3);
  PHSEG (POLY, 1, "", 29, 21, 29, 29);
  PHSEG (POLY, 1, "", 29, 29, 30, 29);
  PHSEG (NTIE, 3, "", 20, 41, 20, 46);
  PHSEG (ALU1, 1, "", 14, 28, 20, 28);
  PHSEG (ALU1, 1, "", 20, 28, 20, 35);
  PHSEG (ALU1, 1, "", 20, 35, 21, 35);
  PHSEG (ALU1, 1, "", 14, 19, 14, 28);
  PHSEG (ALU1, 1, "", 13, 23, 14, 23);
  PHSEG (NTRANS, 7, "", 26, 2, 26, 8);
  PHSEG (NDIF, 3, "", 19, 5, 21, 5);
  PHSEG (PTRANS, 4, "", 23, 39, 28, 39);
  PHSEG (PDIF, 3, "", 25, 44, 26, 44);
  PHSEG (PDIF, 3, "", 26, 43, 26, 45);
  PHSEG (PDIF, 3, "", 26, 33, 26, 35);
  PHSEG (NDIF, 3, "", 32, 4, 32, 19);
  PHSEG (ALU1, 2, "", 26, 15, 26, 18);
  PHSEG (NDIF, 3, "", 26, 14, 26, 19);
  PHSEG (NTIE, 3, "", 32, 41, 32, 46);
  PHSEG (TALU2, 2, "", 14, 3, 14, 46);
  PHSEG (TALU2, 2, "", 20, 4, 20, 46);
  PHSEG (POLY, 2, "", 21, 35, 23, 35);
  PHSEG (POLY, 1, "", 17, 21, 17, 26);
  PHSEG (POLY, 1, "", 17, 23, 18, 23);
  PHSEG (ALU1, 2, "", 8, 29, 8, 35);
  PHSEG (ALU1, 1, "", 8, 17, 8, 29);
  PHSEG (ALU1, 2, "", 8, 14, 8, 17);
  PHSEG (NDIF, 3, "", 14, 8, 14, 19);
  PHSEG (ALU1, 2, "vss", 14, 6, 14, 14);
  PHSEG (ALU1, 2, "vdd", 14, 33, 14, 44);
  PHSEG (ALU1, 1, "vdd", 14, 44, 14, 47);
  PHSEG (ALU1, 1, "mpx_s", 18, 23, 18, 24);
  PHSEG (ALU1, 1, "mpx_s", 32, 18, 32, 24);
  PHSEG (ALU1, 2, "vdd", 32, 41, 32, 46);
  PHSEG (ALU1, 1, "vss", 8, 3, 8, 6);
  PHSEG (ALU1, 8, "vss", 5, 6, 35, 6);
  PHSEG (ALU1, 1, "vss", 20, 5, 20, 6);
  PHSEG (ALU1, 1, "vss", 8, 3, 14, 3);
  PHSEG (ALU1, 8, "vdd", 5, 44, 35, 44);
  PHSEG (ALU1, 1, "vdd", 20, 41, 20, 46);
  PHVIA (CONT_DIF_N, 8, 18);
  PHVIA (CONT_DIF_P, 8, 29);
  PHVIA (CONT_BODY_P, 8, 3);
  PHVIA (CONT_BODY_N, 20, 41);
  PHVIA (CONT_BODY_N, 32, 41);
  PHVIA (CONT_DIF_N, 14, 9);
  PHVIA (CONT_DIF_P, 14, 47);
  PHVIA (CONT_DIF_P, 20, 29);
  PHVIA (CONT_POLY, 21, 35);
  PHVIA (CONT_VIA, 26, 18);
  PHVIA (CONT_VIA, 8, 32);
  PHVIA (CONT_VIA, 32, 34);
  PHVIA (CONT_POLY, 30, 29);
  PHVIA (CONT_POLY, 18, 23);
  PHVIA (CONT_POLY, 13, 23);
  PHVIA (CONT_DIF_P, 26, 34);
  PHVIA (CONT_DIF_P, 26, 44);
  PHVIA (CONT_DIF_P, 14, 33);
  PHVIA (CONT_DIF_P, 14, 38);
  PHVIA (CONT_DIF_P, 14, 42);
  PHVIA (CONT_DIF_P, 8, 35);
  PHVIA (CONT_DIF_N, 20, 5);
  PHVIA (CONT_DIF_N, 32, 18);
  PHVIA (CONT_DIF_N, 26, 15);
  PHVIA (CONT_DIF_N, 20, 18);
  PHVIA (CONT_DIF_N, 14, 14);
  PHVIA (CONT_DIF_N, 8, 14);
  PHVIA (CONT_BODY_P, 14, 3);
  PHVIA (CONT_BODY_N, 32, 46);
  PHVIA (CONT_BODY_N, 20, 46);
  SAVE_PHFIG ();
  return l1;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *l1n_p(char *, int, int, char *, char *,char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = l1_np("", 1, 1, "out", "i", "l")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
l1n_p (l1n, out, i1, i2)
     char *l1n;
     char *out;
     char *i1, *i2;
{
  (void) delphfig (l1n);
  DEF_PHFIG (l1n);
  DEF_AB (5, 3, 35, 45);
  PHCON (ALU1, 8, "vss", EAST, 35, 5);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU1, 8, "vdd", EAST, 35, 43);
  PHCON (ALU2, 2, i2, SOUTH, 32, 3);
  PHCON (ALU2, 2, i2, NORTH, 32, 45);
  PHCON (ALU2, 2, i1, SOUTH, 26, 3);
  PHCON (ALU2, 2, i1, NORTH, 26, 45);
  PHCON (ALU2, 2, out, SOUTH, 8, 3);
  PHCON (ALU2, 2, out, NORTH, 8, 45);
  PHSEG (ALU1, 2, "vdd", 14, 31, 14, 43);
  PHSEG (POLY, 1, "", 32, 27, 32, 28);
  PHSEG (POLY, 1, "", 29, 20, 29, 27);
  PHSEG (POLY, 1, "", 29, 27, 32, 27);
  PHSEG (ALU1, 8, "", 5, 5, 35, 5);
  PHSEG (POLY, 1, "", 23, 7, 26, 7);
  PHSEG (POLY, 1, "", 23, 7, 23, 37);
  PHSEG (ALU1, 1, "", 32, 28, 32, 33);
  PHSEG (ALU1, 1, "mpx_s", 26, 22, 26, 32);
  PHSEG (ALU1, 1, "mpx_s", 18, 22, 32, 22);
  PHSEG (ALU1, 1, "mpx_s", 32, 15, 32, 22);
  PHSEG (NWELL, 26, "", 5, 39, 35, 39);
  PHSEG (PTRANS, 1, "", 11, 25, 11, 40);
  PHSEG (PTRANS, 1, "", 17, 25, 17, 31);
  PHSEG (PTRANS, 4, "", 23, 37, 28, 37);
  PHSEG (NTRANS, 1, "", 11, 6, 11, 20);
  PHSEG (NTRANS, 1, "", 17, 14, 17, 20);
  PHSEG (NTRANS, 1, "", 29, 11, 29, 20);
  PHSEG (NDIF, 3, "", 32, 4, 32, 18);
  PHSEG (ALU2, 2, "", 32, 3, 32, 45);
  PHSEG (NDIF, 3, "", 14, 13, 14, 18);
  PHSEG (NDIF, 3, "", 26, 13, 26, 18);
  PHSEG (PDIF, 3, "", 8, 27, 8, 38);
  PHSEG (PDIF, 3, "", 14, 27, 14, 32);
  PHSEG (NDIF, 3, "", 8, 8, 8, 18);
  PHSEG (PTIE, 2, "", 8, 3, 14, 3);
  PHSEG (NDIF, 3, "", 20, 16, 20, 18);
  PHSEG (ALU2, 2, "", 26, 3, 26, 45);
  PHSEG (ALU2, 2, out, 8, 3, 8, 45);
  PHSEG (PDIF, 3, "", 25, 42, 27, 42);
  PHSEG (PDIF, 3, "", 25, 32, 27, 32);
  PHSEG (PDIF, 3, "", 20, 27, 20, 29);
  PHSEG (NTRANS, 7, "", 26, 2, 26, 7);
  PHSEG (TALU2, 2, "", 14, 3, 14, 45);
  PHSEG (TALU2, 2, "", 20, 3, 20, 45);
  PHSEG (NDIF, 2, "", 20, 4, 20, 5);
  PHSEG (POLY, 1, "", 11, 20, 11, 25);
  PHSEG (POLY, 1, "", 11, 22, 18, 22);
  PHSEG (POLY, 1, "", 17, 20, 17, 25);
  PHSEG (ALU1, 2, "", 26, 14, 26, 17);
  PHSEG (ALU1, 1, "", 8, 14, 8, 29);
  PHSEG (ALU1, 2, "", 8, 29, 8, 34);
  PHSEG (ALU1, 1, "", 14, 18, 20, 18);
  PHSEG (ALU1, 1, "", 14, 18, 14, 27);
  PHSEG (ALU1, 1, "", 14, 27, 20, 27);
  PHSEG (ALU1, 1, "", 20, 27, 20, 34);
  PHSEG (ALU1, 1, "", 20, 34, 21, 34);
  PHSEG (ALU1, 1, "", 20, 17, 20, 18);
  PHSEG (POLY, 2, "", 21, 34, 23, 34);
  PHSEG (NTIE, 2, "", 8, 45, 20, 45);
  PHSEG (ALU1, 1, "vdd", 8, 45, 20, 45);
  PHSEG (ALU1, 1, "vdd", 14, 43, 14, 45);
  PHSEG (ALU1, 1, "", 8, 3, 14, 3);
  PHSEG (ALU1, 1, "", 14, 3, 14, 5);
  PHSEG (ALU1, 2, "", 14, 5, 14, 14);
  PHSEG (ALU1, 1, "vdd", 32, 43, 32, 45);
  PHSEG (ALU1, 8, "vdd", 5, 43, 35, 43);
  PHSEG (ALU1, 1, "vdd", 26, 42, 26, 43);
  PHVIA (CONT_BODY_N, 20, 45);
  PHVIA (CONT_BODY_N, 14, 45);
  PHVIA (CONT_BODY_N, 8, 45);
  PHVIA (CONT_DIF_N, 20, 5);
  PHVIA (CONT_DIF_P, 8, 34);
  PHVIA (CONT_DIF_N, 26, 14);
  PHVIA (CONT_DIF_P, 20, 28);
  PHVIA (CONT_POLY, 21, 34);
  PHVIA (CONT_VIA, 26, 17);
  PHVIA (CONT_VIA, 8, 31);
  PHVIA (CONT_VIA, 32, 33);
  PHVIA (CONT_POLY, 32, 28);
  PHVIA (CONT_POLY, 18, 22);
  PHVIA (CONT_DIF_P, 26, 32);
  PHVIA (CONT_DIF_P, 26, 42);
  PHVIA (CONT_DIF_P, 14, 31);
  PHVIA (CONT_DIF_P, 8, 28);
  PHVIA (CONT_DIF_N, 32, 15);
  PHVIA (CONT_DIF_N, 20, 17);
  PHVIA (CONT_DIF_N, 14, 14);
  PHVIA (CONT_DIF_N, 8, 14);
  PHVIA (CONT_BODY_P, 14, 3);
  PHVIA (CONT_BODY_P, 8, 3);
  PHVIA (CONT_BODY_N, 32, 45);
  SAVE_PHFIG ();
  return l1n;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *l2_p(char *, int, int, char *,char *,char *,char *,char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = l2_p("", 1, 1,i, "out", "i1", "l1", "i2", "l2")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
l2_p (l2, out, i1, i2, i3, i4)
     char *l2;
     char *out;
     char *i1, *i2, *i3, *i4;
{
  (void) delphfig (l2);
  DEF_PHFIG (l2);
  DEF_AB (5, 3, 47, 45);
  PHCON (ALU1, 8, "vss", EAST, 47, 5);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU1, 8, "vdd", EAST, 47, 43);
  PHCON (ALU2, 2, i3, SOUTH, 44, 3);
  PHCON (ALU2, 2, i4, SOUTH, 38, 3);
  PHCON (ALU2, 2, i2, SOUTH, 32, 3);
  PHCON (ALU2, 2, i1, SOUTH, 26, 3);
  PHCON (ALU2, 2, out, SOUTH, 8, 3);
  PHCON (ALU2, 2, out, NORTH, 8, 45);
  PHCON (ALU2, 2, i1, NORTH, 26, 45);
  PHCON (ALU2, 2, i2, NORTH, 32, 45);
  PHCON (ALU2, 2, i4, NORTH, 38, 45);
  PHCON (ALU2, 2, i3, NORTH, 44, 45);
  PHSEG (ALU1, 2, "", 8, 13, 8, 17);
  PHSEG (ALU1, 1, "", 8, 17, 8, 28);
  PHSEG (PTRANS, 1, "", 11, 25, 11, 51);
  PHSEG (PTRANS, 1, "", 17, 25, 17, 33);
  PHSEG (PTRANS, 3, "", 23, 36, 28, 36);
  PHSEG (NTRANS, 1, "", 11, 5, 11, 20);
  PHSEG (NTRANS, 1, "", 17, 12, 17, 20);
  PHSEG (NTRANS, 1, "", 29, 11, 29, 20);
  PHSEG (NTRANS, 1, "", 35, 11, 35, 20);
  PHSEG (ALU2, 2, "", 44, 3, 44, 45);
  PHSEG (ALU2, 2, "", 38, 3, 38, 45);
  PHSEG (ALU2, 2, "", 32, 3, 32, 45);
  PHSEG (ALU2, 2, "", 26, 3, 26, 45);
  PHSEG (ALU2, 2, "", 8, 3, 8, 45);
  PHSEG (PDIF, 3, "", 14, 27, 14, 49);
  PHSEG (PDIF, 3, "", 8, 27, 8, 49);
  PHSEG (PDIF, 3, "", 20, 27, 20, 31);
  PHSEG (NDIF, 3, "", 38, 13, 38, 18);
  PHSEG (NDIF, 3, "", 20, 14, 20, 18);
  PHSEG (ALU1, 2, "vdd", 14, 33, 14, 43);
  PHSEG (ALU1, 1, "vdd", 14, 43, 14, 45);
  PHSEG (NTIE, 2, "", 32, 45, 44, 45);
  PHSEG (ALU1, 1, "", 44, 17, 44, 25);
  PHSEG (ALU1, 1, "", 38, 17, 44, 17);
  PHSEG (NWELL, 26, "", 5, 39, 47, 39);
  PHSEG (POLY, 1, "", 11, 20, 11, 25);
  PHSEG (POLY, 2, "", 11, 22, 13, 22);
  PHSEG (NDIF, 3, "", 26, 12, 26, 18);
  PHSEG (PDIF, 3, "", 26, 40, 26, 42);
  PHSEG (PDIF, 3, "", 26, 30, 26, 33);
  PHSEG (ALU1, 2, "", 26, 13, 26, 17);
  PHSEG (NDIF, 3, "", 8, 7, 8, 18);
  PHSEG (NTRANS, 7, "", 26, 2, 26, 7);
  PHSEG (POLY, 2, "", 21, 34, 23, 34);
  PHSEG (NDIF, 2, "", 20, 4, 20, 6);
  PHSEG (ALU1, 1, "", 38, 24, 38, 34);
  PHSEG (ALU1, 2, "", 36, 24, 38, 24);
  PHSEG (ALU1, 1, "", 30, 25, 31, 25);
  PHSEG (ALU1, 1, "", 31, 25, 31, 34);
  PHSEG (ALU1, 1, "", 31, 34, 32, 34);
  PHSEG (NDIF, 3, "", 32, 4, 32, 18);
  PHSEG (NTIE, 3, "", 20, 40, 20, 43);
  PHSEG (NDIF, 3, "", 14, 7, 14, 18);
  PHSEG (TALU2, 2, "", 14, 3, 14, 45);
  PHSEG (TALU2, 2, "", 20, 3, 20, 45);
  PHSEG (PTIE, 2, "", 38, 3, 44, 3);
  PHSEG (POLY, 2, "", 35, 24, 36, 24);
  PHSEG (POLY, 1, "", 35, 20, 35, 24);
  PHSEG (POLY, 2, "", 29, 25, 30, 25);
  PHSEG (POLY, 1, "", 29, 20, 29, 25);
  PHSEG (ALU1, 1, "mpx_s", 31, 17, 32, 17);
  PHSEG (ALU1, 1, "mpx_s", 31, 17, 31, 21);
  PHSEG (ALU1, 1, "mpx_s", 26, 21, 31, 21);
  PHSEG (ALU1, 1, "mpx_s", 26, 21, 26, 31);
  PHSEG (ALU1, 1, "mpx_s", 18, 23, 26, 23);
  PHSEG (POLY, 1, "", 17, 20, 17, 25);
  PHSEG (POLY, 1, "", 17, 23, 18, 23);
  PHSEG (ALU1, 2, "vss", 14, 5, 14, 15);
  PHSEG (ALU1, 2, "", 8, 28, 8, 34);
  PHSEG (ALU1, 1, "", 14, 27, 20, 27);
  PHSEG (ALU1, 2, "", 20, 27, 20, 29);
  PHSEG (ALU1, 1, "", 20, 29, 21, 29);
  PHSEG (ALU1, 1, "", 21, 29, 21, 34);
  PHSEG (ALU1, 2, "", 20, 16, 20, 19);
  PHSEG (ALU1, 1, "", 14, 19, 20, 19);
  PHSEG (ALU1, 1, "", 14, 19, 14, 27);
  PHSEG (ALU1, 1, "", 13, 22, 14, 22);
  PHSEG (ALU1, 1, "vss", 38, 3, 38, 5);
  PHSEG (ALU1, 1, "vss", 38, 3, 44, 3);
  PHSEG (ALU1, 8, "vss", 5, 5, 47, 5);
  PHSEG (ALU1, 1, "vdd", 32, 45, 44, 45);
  PHSEG (ALU1, 1, "vdd", 44, 43, 44, 45);
  PHSEG (ALU1, 1, "vdd", 26, 41, 26, 43);
  PHSEG (ALU1, 8, "vdd", 5, 43, 47, 43);
  PHSEG (ALU1, 1, "vdd", 20, 40, 20, 45);
  PHSEG (POLY, 1, "", 23, 7, 23, 36);
  PHSEG (POLY, 1, "", 23, 7, 26, 7);
  PHVIA (CONT_BODY_P, 38, 3);
  PHVIA (CONT_BODY_N, 32, 45);
  PHVIA (CONT_BODY_N, 20, 40);
  PHVIA (CONT_BODY_N, 38, 45);
  PHVIA (CONT_DIF_P, 14, 45);
  PHVIA (CONT_VIA, 44, 25);
  PHVIA (CONT_VIA, 38, 34);
  PHVIA (CONT_VIA, 32, 34);
  PHVIA (CONT_VIA, 8, 31);
  PHVIA (CONT_VIA, 26, 13);
  PHVIA (CONT_POLY, 36, 24);
  PHVIA (CONT_POLY, 30, 25);
  PHVIA (CONT_POLY, 21, 34);
  PHVIA (CONT_POLY, 18, 23);
  PHVIA (CONT_POLY, 13, 22);
  PHVIA (CONT_DIF_P, 26, 41);
  PHVIA (CONT_DIF_P, 26, 31);
  PHVIA (CONT_DIF_P, 20, 29);
  PHVIA (CONT_DIF_P, 14, 33);
  PHVIA (CONT_DIF_P, 14, 37);
  PHVIA (CONT_DIF_P, 14, 41);
  PHVIA (CONT_DIF_P, 8, 28);
  PHVIA (CONT_DIF_P, 8, 34);
  PHVIA (CONT_DIF_N, 38, 17);
  PHVIA (CONT_DIF_N, 32, 17);
  PHVIA (CONT_DIF_N, 26, 17);
  PHVIA (CONT_DIF_N, 20, 16);
  PHVIA (CONT_DIF_N, 20, 5);
  PHVIA (CONT_DIF_N, 14, 9);
  PHVIA (CONT_DIF_N, 14, 15);
  PHVIA (CONT_DIF_N, 8, 13);
  PHVIA (CONT_DIF_N, 8, 17);
  PHVIA (CONT_BODY_P, 44, 3);
  PHVIA (CONT_BODY_N, 44, 45);
  PHVIA (CONT_BODY_N, 20, 45);
  SAVE_PHFIG ();
  return l2;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *l2n_p(char *, int, int, char *, char *, char *, char *, char*)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = l2n_p("", 1, 1, "out", "i1", "i2", "i3", "i4")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
l2n_p (l2n, out, i1, i2, i3, i4)
     char *l2n;
     char *out;
     char *i1, *i2, *i3, *i4;
{
  (void) delphfig (l2n);
  DEF_PHFIG (l2n);
  DEF_AB (5, 11, 47, 53);
  PHCON (ALU2, 2, i3, NORTH, 44, 53);
  PHCON (ALU2, 2, i4, NORTH, 38, 53);
  PHCON (ALU2, 2, i2, NORTH, 32, 53);
  PHCON (ALU2, 2, i1, NORTH, 26, 53);
  PHCON (ALU2, 2, out, NORTH, 8, 53);
  PHCON (ALU2, 2, out, SOUTH, 8, 11);
  PHCON (ALU2, 2, i1, SOUTH, 26, 11);
  PHCON (ALU2, 2, i2, SOUTH, 32, 11);
  PHCON (ALU2, 2, i4, SOUTH, 38, 11);
  PHCON (ALU2, 2, i3, SOUTH, 44, 11);
  PHCON (ALU1, 8, "vdd", EAST, 47, 51);
  PHCON (ALU1, 8, "vdd", WEST, 5, 51);
  PHCON (ALU1, 8, "vss", WEST, 5, 13);
  PHCON (ALU1, 8, "vss", EAST, 47, 13);
  PHSEG (POLY, 1, "", 23, 15, 26, 15);
  PHSEG (POLY, 1, "", 23, 15, 23, 44);
  PHSEG (ALU1, 1, "", 36, 32, 37, 32);
  PHSEG (ALU1, 1, "", 37, 32, 37, 42);
  PHSEG (ALU1, 1, "", 37, 42, 38, 42);
  PHSEG (ALU1, 1, "", 38, 25, 38, 26);
  PHSEG (ALU1, 1, "", 38, 26, 43, 26);
  PHSEG (ALU1, 1, "", 43, 26, 43, 33);
  PHSEG (ALU1, 1, "", 43, 33, 44, 33);
  PHSEG (NDIF, 3, "", 14, 4, 14, 26);
  PHSEG (NDIF, 3, "", 8, 4, 8, 26);
  PHSEG (ALU1, 2, "", 8, 36, 8, 42);
  PHSEG (ALU1, 1, "", 8, 25, 8, 36);
  PHSEG (ALU1, 1, "", 19, 25, 20, 25);
  PHSEG (ALU1, 1, "", 19, 25, 19, 27);
  PHSEG (ALU1, 1, "", 14, 27, 19, 27);
  PHSEG (ALU1, 1, "", 14, 27, 14, 35);
  PHSEG (ALU1, 1, "", 21, 36, 21, 42);
  PHSEG (ALU1, 1, "", 19, 36, 21, 36);
  PHSEG (ALU1, 1, "", 19, 35, 19, 36);
  PHSEG (ALU1, 1, "", 14, 35, 19, 35);
  PHSEG (ALU1, 1, "mpx_s", 18, 31, 25, 31);
  PHSEG (ALU1, 1, "mpx_s", 31, 25, 32, 25);
  PHSEG (ALU1, 1, "mpx_s", 31, 25, 31, 29);
  PHSEG (ALU1, 1, "mpx_s", 25, 29, 31, 29);
  PHSEG (ALU1, 1, "mpx_s", 25, 29, 25, 39);
  PHSEG (ALU1, 1, "mpx_s", 25, 39, 26, 39);
  PHSEG (POLY, 1, "", 35, 28, 35, 32);
  PHSEG (POLY, 1, "", 35, 32, 36, 32);
  PHSEG (POLY, 1, "", 29, 28, 29, 33);
  PHSEG (POLY, 1, "", 29, 33, 30, 33);
  PHSEG (TALU2, 2, "", 20, 11, 20, 53);
  PHSEG (TALU2, 2, "", 14, 10, 14, 53);
  PHSEG (POLY, 1, "", 17, 28, 17, 33);
  PHSEG (POLY, 1, "", 11, 31, 18, 31);
  PHSEG (POLY, 1, "", 11, 28, 11, 33);
  PHSEG (ALU1, 2, "", 26, 22, 26, 25);
  PHSEG (ALU2, 2, i4, 38, 11, 38, 53);
  PHSEG (ALU2, 2, i3, 44, 11, 44, 53);
  PHSEG (PDIF, 3, "", 19, 36, 21, 36);
  PHSEG (NDIF, 3, "", 20, 11, 20, 13);
  PHSEG (NDIF, 3, "", 32, 12, 32, 26);
  PHSEG (POLY, 2, "", 21, 42, 23, 42);
  PHSEG (NTRANS, 7, "", 26, 10, 26, 15);
  PHSEG (PDIF, 3, "", 26, 48, 26, 50);
  PHSEG (PDIF, 3, "", 26, 38, 26, 40);
  PHSEG (PTIE, 2, "", 38, 11, 44, 11);
  PHSEG (NDIF, 3, "", 19, 25, 21, 25);
  PHSEG (ALU1, 1, "", 30, 33, 31, 33);
  PHSEG (ALU1, 1, "", 31, 33, 31, 42);
  PHSEG (ALU1, 1, "", 31, 42, 32, 42);
  PHSEG (NTIE, 3, "", 20, 48, 20, 53);
  PHSEG (PDIF, 3, "", 14, 35, 14, 57);
  PHSEG (PDIF, 3, "", 8, 35, 8, 57);
  PHSEG (NDIF, 3, "", 38, 21, 38, 26);
  PHSEG (NDIF, 3, "", 26, 21, 26, 26);
  PHSEG (ALU2, 2, out, 8, 11, 8, 53);
  PHSEG (ALU2, 2, i1, 26, 11, 26, 53);
  PHSEG (ALU2, 2, i2, 32, 11, 32, 53);
  PHSEG (NWELL, 26, "", 5, 47, 47, 47);
  PHSEG (NTRANS, 1, "", 35, 19, 35, 28);
  PHSEG (NTRANS, 1, "", 29, 19, 29, 28);
  PHSEG (NTRANS, 1, "", 17, 22, 17, 28);
  PHSEG (NTRANS, 1, "", 11, 2, 11, 28);
  PHSEG (PTRANS, 4, "", 23, 44, 28, 44);
  PHSEG (PTRANS, 1, "", 17, 33, 17, 39);
  PHSEG (PTRANS, 1, "", 11, 33, 11, 59);
  PHSEG (NTIE, 2, "", 32, 53, 44, 53);
  PHSEG (ALU1, 1, "vss", 38, 11, 38, 13);
  PHSEG (ALU1, 1, "vss", 38, 11, 44, 11);
  PHSEG (ALU1, 8, "vss", 5, 13, 47, 13);
  PHSEG (ALU1, 8, "vss", 20, 12, 20, 13);
  PHSEG (ALU1, 2, "vss", 14, 11, 14, 23);
  PHSEG (ALU1, 2, "", 8, 21, 8, 25);
  PHSEG (ALU1, 1, "vdd", 14, 51, 14, 53);
  PHSEG (ALU1, 2, "vdd", 14, 41, 14, 51);
  PHSEG (ALU1, 1, "vdd", 32, 53, 44, 53);
  PHSEG (ALU1, 1, "vdd", 44, 51, 44, 53);
  PHSEG (ALU1, 8, "vdd", 20, 51, 20, 53);
  PHSEG (ALU1, 8, "vdd", 5, 51, 47, 51);
  PHSEG (ALU1, 1, "vdd", 20, 48, 20, 51);
  PHSEG (ALU1, 1, "vdd", 26, 49, 26, 51);
  PHVIA (CONT_BODY_N, 32, 53);
  PHVIA (CONT_BODY_N, 20, 53);
  PHVIA (CONT_BODY_N, 44, 53);
  PHVIA (CONT_BODY_P, 44, 11);
  PHVIA (CONT_DIF_N, 8, 25);
  PHVIA (CONT_DIF_N, 8, 21);
  PHVIA (CONT_DIF_N, 14, 23);
  PHVIA (CONT_DIF_N, 14, 19);
  PHVIA (CONT_DIF_N, 20, 12);
  PHVIA (CONT_DIF_N, 20, 25);
  PHVIA (CONT_DIF_N, 26, 25);
  PHVIA (CONT_DIF_N, 32, 25);
  PHVIA (CONT_DIF_N, 38, 25);
  PHVIA (CONT_DIF_P, 8, 42);
  PHVIA (CONT_DIF_P, 8, 36);
  PHVIA (CONT_DIF_P, 14, 45);
  PHVIA (CONT_DIF_P, 14, 41);
  PHVIA (CONT_DIF_P, 20, 36);
  PHVIA (CONT_DIF_P, 26, 39);
  PHVIA (CONT_DIF_P, 26, 49);
  PHVIA (CONT_POLY, 18, 31);
  PHVIA (CONT_POLY, 21, 42);
  PHVIA (CONT_POLY, 30, 33);
  PHVIA (CONT_POLY, 36, 32);
  PHVIA (CONT_VIA, 26, 22);
  PHVIA (CONT_VIA, 8, 39);
  PHVIA (CONT_VIA, 32, 42);
  PHVIA (CONT_VIA, 38, 42);
  PHVIA (CONT_VIA, 44, 33);
  PHVIA (CONT_BODY_P, 38, 11);
  PHVIA (CONT_BODY_N, 38, 53);
  PHVIA (CONT_BODY_N, 20, 48);
  PHVIA (CONT_DIF_P, 14, 49);
  PHVIA (CONT_DIF_P, 14, 53);
  PHVIA (CONT_DIF_N, 14, 15);
  PHVIA (CONT_DIF_N, 14, 11);
  SAVE_PHFIG ();
  return l2n;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *tie_p(char *, int, int)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = tie_p("", 1, 1)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
tie_p (tie)
     char *tie;
{
  (void) delphfig (tie);
  DEF_PHFIG (tie);
  DEF_AB (5, 3, 11, 45);
  PHCON (ALU1, 8, "vdd", EAST, 11, 43);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU1, 8, "vss", EAST, 11, 5);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHSEG (TALU2, 2, "", 8, 3, 8, 45);
  PHSEG (PTIE, 3, "", 8, 3, 8, 16);
  PHSEG (NTIE, 3, "", 8, 29, 8, 45);
  PHSEG (ALU1, 8, "vdd", 5, 43, 11, 43);
  PHSEG (ALU1, 8, "vss", 5, 5, 11, 5);
  PHSEG (NWELL, 26, "", 5, 39, 11, 39);
  PHSEG (ALU1, 2, "vdd", 8, 29, 8, 45);
  PHSEG (ALU1, 2, "vss", 8, 3, 8, 16);
  PHVIA (CONT_BODY_P, 8, 7);
  PHVIA (CONT_BODY_N, 8, 45);
  PHVIA (CONT_BODY_N, 8, 41);
  PHVIA (CONT_BODY_N, 8, 37);
  PHVIA (CONT_BODY_N, 8, 33);
  PHVIA (CONT_BODY_N, 8, 29);
  PHVIA (CONT_BODY_P, 8, 3);
  PHVIA (CONT_BODY_P, 8, 11);
  PHVIA (CONT_BODY_P, 8, 16);
  SAVE_PHFIG ();
  return tie;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *low_p(char *, int, int, char *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = low_p("", 1, 1, "s")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
low_p (low, out)
     char *low;
     char *out;
{
  (void) delphfig (low);
  DEF_PHFIG (low);
  DEF_AB (5, 3, 17, 45);
  PHCON (ALU2, 2, out, SOUTH, 14, 3);
  PHCON (ALU2, 2, out, NORTH, 14, 45);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU1, 8, "vss", EAST, 17, 5);
  PHCON (ALU1, 8, "vdd", EAST, 17, 43);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHSEG (NTIE, 3, "", 11, 29, 11, 45);
  PHSEG (NTRANS, 1, "", 11, 5, 11, 20);
  PHSEG (PTIE, 2, "", 8, 2, 14, 2);
  PHSEG (ALU1, 8, "vss", 5, 5, 17, 5);
  PHSEG (ALU1, 1, "vss", 8, 3, 8, 5);
  PHSEG (ALU1, 2, "vss", 8, 5, 8, 17);
  PHSEG (ALU2, 2, out, 14, 3, 14, 45);
  PHSEG (NDIF, 2, "", 8, 7, 8, 18);
  PHSEG (NDIF, 2, "", 14, 7, 14, 18);
  PHSEG (ALU1, 1, "", 14, 16, 14, 21);
  PHSEG (NWELL, 26, "", 5, 39, 17, 39);
  PHSEG (TALU2, 2, "", 8, 2, 8, 45);
  PHSEG (ALU1, 2, "vdd", 11, 29, 11, 45);
  PHSEG (ALU1, 2, "vdd", 9, 29, 11, 29);
  PHSEG (ALU1, 1, "vdd", 9, 23, 9, 29);
  PHSEG (ALU1, 8, "vdd", 5, 43, 17, 43);
  PHSEG (POLY, 1, "", 11, 20, 11, 23);
  PHSEG (POLY, 1, "", 9, 23, 11, 23);
  PHVIA (CONT_DIF_N, 8, 16);
  PHVIA (CONT_DIF_N, 14, 16);
  PHVIA (CONT_VIA, 14, 21);
  PHVIA (CONT_POLY, 9, 23);
  PHVIA (CONT_DIF_N, 8, 8);
  PHVIA (CONT_BODY_P, 8, 2);
  PHVIA (CONT_BODY_P, 14, 2);
  PHVIA (CONT_BODY_N, 11, 39);
  PHVIA (CONT_BODY_N, 11, 34);
  PHVIA (CONT_BODY_N, 11, 29);
  PHVIA (CONT_BODY_N, 11, 45);
  SAVE_PHFIG ();
  return low;
}

/*----------------------------------------------------------------------------*
  -------- very low-level func -------------------------------------------[]--
  ----------------------------------------------------------------------------
  SYNTAX : char *high_p(char *, cahr *)
  ----------------------------------------------------------------------------
  EXEMPLE : nameFig = high_p("", "t")
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
 *----------------------------------------------------------------------------*/

char *
high_p (high, out)
     char *high;
     char *out;
{
  (void) delphfig (high);
  DEF_PHFIG (high);
  DEF_AB (5, 3, 17, 45);
  PHCON (ALU2, 2, out, SOUTH, 14, 3);
  PHCON (ALU1, 8, "vdd", EAST, 17, 43);
  PHCON (ALU1, 8, "vdd", WEST, 5, 43);
  PHCON (ALU2, 2, out, NORTH, 14, 45);
  PHCON (ALU1, 8, "vss", EAST, 17, 5);
  PHCON (ALU1, 8, "vss", WEST, 5, 5);
  PHSEG (NTIE, 2, "", 8, 46, 14, 46);
  PHSEG (NWELL, 26, "", 5, 39, 17, 39);
  PHSEG (PTRANS, 1, "", 11, 25, 11, 43);
  PHSEG (ALU1, 1, "", 14, 29, 14, 35);
  PHSEG (PTIE, 2, "", 14, 3, 14, 3);
  PHSEG (PTIE, 2, "", 8, 3, 14, 3);
  PHSEG (PTIE, 3, "", 14, 3, 14, 16);
  PHSEG (PDIF, 3, "", 8, 27, 8, 40);
  PHSEG (PDIF, 3, "", 14, 27, 14, 41);
  PHSEG (ALU1, 2, "vss", 9, 4, 14, 4);
  PHSEG (ALU1, 2, "vss", 8, 4, 9, 4);
  PHSEG (ALU1, 2, "vss", 9, 4, 9, 5);
  PHSEG (ALU1, 8, "vss", 5, 5, 9, 5);
  PHSEG (ALU1, 8, "vss", 9, 5, 14, 5);
  PHSEG (ALU1, 8, "vss", 14, 5, 17, 5);
  PHSEG (ALU1, 1, "vss", 14, 4, 14, 5);
  PHSEG (ALU1, 2, "vss", 14, 5, 14, 15);
  PHSEG (ALU1, 2, "vss", 9, 5, 9, 24);
  PHSEG (ALU2, 2, "", 14, 3, 14, 45);
  PHSEG (ALU1, 8, "vdd", 8, 43, 17, 43);
  PHSEG (ALU1, 8, "vdd", 5, 43, 8, 43);
  PHSEG (ALU1, 1, "vdd", 8, 43, 8, 46);
  PHSEG (ALU1, 2, "vdd", 8, 29, 8, 43);
  PHSEG (TALU2, 2, "", 8, 3, 8, 46);
  PHSEG (POLY, 1, "", 11, 23, 11, 25);
  PHSEG (POLY, 1, "", 9, 23, 11, 23);
  PHVIA (CONT_DIF_P, 8, 40);
  PHVIA (CONT_BODY_P, 14, 15);
  PHVIA (CONT_BODY_P, 14, 10);
  PHVIA (CONT_DIF_P, 14, 35);
  PHVIA (CONT_DIF_P, 8, 29);
  PHVIA (CONT_DIF_P, 8, 35);
  PHVIA (CONT_VIA, 14, 29);
  PHVIA (CONT_POLY, 9, 23);
  PHVIA (CONT_BODY_P, 14, 3);
  PHVIA (CONT_BODY_N, 8, 46);
  PHVIA (CONT_BODY_N, 14, 46);
  PHVIA (CONT_BODY_P, 8, 3);
  SAVE_PHFIG ();
  return high;
}

/*:::::::::::::::::::::::::::: start of genFiles ::::::::::::::::::::::::::::: */

/*----------------------------------------------------------------------------
  -------- very low-level func --------------------------[genFiles/genLogic]--
  ----------------------------------------------------------------------------
  SYNTAX : char *noEq2nameEq(short, char, char)
  ----------------------------------------------------------------------------
  EXEMPLE : eqName = noEq2nameEq(noEq, grTyp, polar)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
  ----------------------------------------------------------------------------*/

char *
noEq2nameEq (noEq, graph, polarity)
     short noEq;
     char graph, polarity;
{
  if (noEq == ALIM)
    if (graph == P_GRAPH)
      return namealloc (VDD_SYMB);
    else
      return namealloc (VSS_SYMB);
  else if (noEq == OUTPUT)
    if (polarity == POS)
      return namealloc (NAME ("%s%s", INT_EQ_SYMB, "out"));
    else
      return namealloc (N_OUT_SYMB);
  else if (graph == P_GRAPH)
    return namealloc (NAME ("p%s%d", INT_EQ_SYMB, noEq));
  else
    return namealloc (NAME ("n%s%d", INT_EQ_SYMB, noEq));
}

/*----------------------------------------------------------------------------
  -------- very low-level func -----------------------------------[genFiles]--
  ----------------------------------------------------------------------------
  SYNTAX : void genLogic(char *, TrGraph[MAX_H_PITCH] *, char, short[2])
  ----------------------------------------------------------------------------
  EXEMPLE : genLogic(fName, tGr, polar, nbCh)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
  ----------------------------------------------------------------------------*/

void
genLogic (name, tGraph, polarity, nbCh)
     char *name;
     TrGraph *tGraph[];
     char polarity;
     short nbCh[];
{
  register short ind = 0, i = 0;
  short dn, dp;
  char *inName;

  (void) dellofig (name);
  dn = nbCh[N_GRAPH] - 2;
  dp = nbCh[P_GRAPH] - 2;
  DEF_LOFIG (name);
  while (tGraph[ind])
    {
      if (tGraph[ind]->trName)
	{
	  LOCON (NAME ("%s%d", IN_SYMB, i), IN, NAME ("%s%d", IN_SYMB, i));
	  i++;
	}
      ind++;
    }
  if (polarity == NEG)
    LOCON (N_OUT_SYMB, OUT, N_OUT_SYMB);
  else
    LOCON (OUT_SYMB, OUT, OUT_SYMB);
  LOCON (VDD_SYMB, UNKNOWN, VDD_SYMB);
  LOCON (VSS_SYMB, UNKNOWN, VSS_SYMB);
  ind = i = 0;
  while (tGraph[ind])
    {
      if (tGraph[ind]->trName)
	{
	  inName = NAME ("%s%d", IN_SYMB, i++);
	  LOTRS (TRANSP, 14 + 4 * dp, 1,
		 inName,
		 noEq2nameEq (tGraph[ind]->hiPEq, P_GRAPH, polarity),
		 noEq2nameEq (tGraph[ind]->loPEq, P_GRAPH, polarity));
	  LOTRS (TRANSN, 12 + 4 * dn, 1,
		 inName,
		 noEq2nameEq (tGraph[ind]->hiNEq, N_GRAPH, polarity),
		 noEq2nameEq (tGraph[ind]->loNEq, N_GRAPH, polarity));
	}
      else if (tGraph[ind]->blkType == INV_BLK)
	{
	  LOTRS (TRANSP, 14 + 4 * dp, 1, noEq2nameEq (OUTPUT, P_GRAPH, polarity),
		 VDD_SYMB, OUT_SYMB);
	  LOTRS (TRANSN, 12 + 4 * dn, 1, noEq2nameEq (OUTPUT, P_GRAPH, polarity),
		 VSS_SYMB, OUT_SYMB);
	}
      ind++;
    }

  SAVE_LOFIG ();
}

/*----------------------------------------------------------------------------
  -------- very low-level func -------------------------[genFiles/genPhysic]--
  ----------------------------------------------------------------------------
  SYNTAX : void genLCellIn(short, short)
  ----------------------------------------------------------------------------
  EXEMPLE : genLCellIn(nbNCh, nbPCh)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
  ----------------------------------------------------------------------------*/
void
genLCellIn (dn, dp)
     short dn, dp;
{
  dn *= 4;
  dp *= 4;
  /* cut lines are y=14 and y=38 */
  DEF_PHFIG (L_CELL_IN);
  DEF_AB (6, 6, 12, 48 + dn + dp);
  /* doesn't move */
  /* PHSEG(ALU1, 8, "", 6, 8, 12, 8); */
  PHVIA (CONT_BODY_P, 9, 5);
  /* cutted thru by first cut line */
  PHSEG (NTRANS, 1, "", 12, 8, 12, 23 + dn);
  PHSEG (NDIF, 2, "", 9, 10, 9, 21 + dn);
  /* cutted thru by both cut lines */
  PHSEG (ALU2, 2, "", 9, 6, 9, 48 + dn + dp);
  /* up the second cut line */
  /* special case for nwell */
  /*PHSEG(NWELL, 26 + dp, "", 6, 42 + dn + dp / 2, 17, 42 + dn + dp / 2); */
  /*PHSEG(ALU1, 8, "", 6, 46 + dn + dp, 12, 46 + dn + dp); */
  PHVIA (CONT_BODY_N, 9, 49 + dn + dp);
  /* thru up */
  PHSEG (PTRANS, 1, "", 12, 29 + dn, 12, 46 + dn + dp);
  PHSEG (PDIF, 2, "", 9, 31 + dn, 9, 44 + dn + dp);
  /* middle session */
  PHSEG (POLY, 2, "", 10, 25 + dn, 12, 25 + dn);
  PHSEG (POLY, 1, "", 12, 23 + dn, 12, 29 + dn);
  PHSEG (ALU1, 2, "", 10, 25 + dn, 10, 29 + dn);
  PHSEG (ALU1, 1, "", 9, 29 + dn, 10, 29 + dn);
  PHVIA (CONT_POLY, 10, 25 + dn);
  PHVIA (CONT_VIA, 9, 29 + dn);
}

/*----------------------------------------------------------------------------
  -------- very low-level func -------------------------[genFiles/genPhysic]--
  ----------------------------------------------------------------------------
  SYNTAX : void genLCellOut(short, short)
  ----------------------------------------------------------------------------
  EXEMPLE : genLCellOut(nbNCh, nbPCh)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
  ----------------------------------------------------------------------------*/
void
genLCellOut (dn, dp)
     short dn, dp;
{
  dn *= 4;
  dp *= 4;
  /* cut lines are y=14 and y=38 */
  DEF_PHFIG (L_CELL_OUT);
  DEF_AB (6, 6, 12, 48 + dn + dp);
  /* doesn't move */
  /*PHSEG(ALU1, 8, "", 6, 8, 12, 8); */
  PHVIA (CONT_BODY_P, 9, 5);
  /* cutted thru by first cut line */
  PHSEG (NDIF, 2, "", 9, 10, 9, 21 + dn);
  /* cutted thru by both cut lines */
  PHSEG (ALU2, 2, "", 9, 6, 9, 48 + dn + dp);
  /* up the second cut line */
  /* special case for nwell */
  /*PHSEG(NWELL, 26 + dp, "", 6, 42 + dn + dp / 2, 12, 42 + dn + dp / 2); */
  /*PHSEG(ALU1, 8, "", 6, 46 + dn + dp, 12, 46 + dn + dp); */
  PHVIA (CONT_BODY_N, 9, 49 + dn + dp);
  /* thru up */
  PHSEG (PDIF, 2, "", 9, 31 + dn, 9, 44 + dn + dp);
  /* middle session */
  PHSEG (ALU1, 1, "", 9, 20 + dn, 9, 34 + dn);
  PHVIA (CONT_VIA, 9, 28 + dn);
}

	/*----------------------------------------------------------------------------
	  -------- very low-level func -------------------------[genFiles/genPhysic]--
	  ----------------------------------------------------------------------------
	  SYNTAX : void genLCellInv(short, short)
  ----------------------------------------------------------------------------
  EXEMPLE : genLCellInv(nbNCh, nbPCh)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
  ----------------------------------------------------------------------------*/
void
genLCellInv (dn, dp)
     short dn, dp;
{
  dn *= 4;
  dp *= 4;
  /* cut lines are y=14 and y=38 */
  DEF_PHFIG (L_CELL_INV);
  DEF_AB (6, 6, 12, 48 + dn + dp);
  /* doesn't move */
  /*PHSEG(ALU1, 8, "", 6, 8, 12, 8); */
  PHVIA (CONT_BODY_P, 9, 5);
  PHVIA (CONT_DIF_N, 9, 11);
  /* cutted thru by first cut line */
  PHSEG (NTRANS, 1, "", 12, 8, 12, 23 + dn);
  PHSEG (NDIF, 2, "", 9, 10, 9, 21 + dn);
  /* cutted thru by both cut lines */
  PHSEG (TALU2, 2, "", 9, 6, 9, 48 + dn + dp);
  /* up the second cut line */
  /* special case for nwell */
  /*PHSEG(NWELL, 26 + dp, "", 6, 42 + dn + dp / 2, 17, 42 + dn + dp / 2); */
  /*PHSEG(ALU1, 8, "", 6, 46 + dn + dp, 12, 46 + dn + dp); */
  PHVIA (CONT_BODY_N, 9, 49 + dn + dp);
  PHVIA (CONT_DIF_P, 9, 43 + dn + dp);
  /* thru up */
  PHSEG (PTRANS, 1, "", 12, 29 + dn, 12, 46 + dn + dp);
  PHSEG (PDIF, 2, "", 9, 31 + dn, 9, 44 + dn + dp);
  /* middle session */
  PHSEG (POLY, 1, "", 12, 23 + dn, 12, 29 + dn);
  PHVIA (CONT_POLY, 10, 25 + dn);
  PHSEG (POLY, 2, "", 10, 25 + dn, 12, 25 + dn);
  PHSEG (ALU1, 1, "", 9, 25 + dn, 10, 25 + dn);
/*  PHSEG(ALU1, 1, "", 9, 20 + dn, 9, 34 + dn); */
  PHVIA (CONT_DIF_P, 15, 34 + dn);
  PHVIA (CONT_DIF_N, 15, 20 + dn);
}

/*----------------------------------------------------------------------------
  -------- very low-level func -------------------------[genFiles/genPhysic]--
  ----------------------------------------------------------------------------
  SYNTAX : void genLCellTrsp(short, short)
  ----------------------------------------------------------------------------
  EXEMPLE : genLCellTrsp(nbNCh, nbPCh)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
  ----------------------------------------------------------------------------*/
void
genLCellTrsp (dn, dp)
     short dn, dp;
{
  dn *= 4;
  dp *= 4;
  /* cut lines are y=14 and y=38 */
  DEF_PHFIG (L_CELL_TRSP);
  DEF_AB (6, 6, 12, 48 + dn + dp);
  /* doesn't move */
  /*PHSEG(ALU1, 8, "", 6, 8, 12, 8); */
  PHVIA (CONT_BODY_P, 9, 5);
  /* cutted thru by first cut line */
  PHSEG (NDIF, 2, "", 9, 10, 9, 21 + dn);
  /* cutted thru by both cut lines */
  PHSEG (TALU2, 2, "", 9, 6, 9, 48 + dn + dp);
  /* up the second cut line */
  /* special case for nwell */
  /*PHSEG(NWELL, 26 + dp, "", 6, 42 + dn + dp / 2, 12, 42 + dn + dp / 2); */
  /*PHSEG(ALU1, 8, "", 6, 46 + dn + dp, 12, 46 + dn + dp); */
  PHVIA (CONT_BODY_N, 9, 49 + dn + dp);
  /* thru up */
  PHSEG (PDIF, 2, "", 9, 31 + dn, 9, 44 + dn + dp);
}

/*----------------------------------------------------------------------------
  -------- very low-level func -----------------------------------[genFiles]--
  ----------------------------------------------------------------------------
  SYNTAX : void genPhysic(char *, TrGraph[MAX_H_PITCH] *, MetalEq[2][MAX_EQ] *,
                    VertSeg *, VertSeg *, short[2], char)
  ----------------------------------------------------------------------------
  EXEMPLE : genPhysic(fName, tGr, mRou, segInv, segTrsp, nbCh, polar)
  ----------------------------------------------------------------------------
  FONCTION :
  ----------------------------------------------------------------------------
  ERROR : none
  ----------------------------------------------------------------------------*/

void
genPhysic (name, tGr, mRou, sInv, sTrsp, nbCh, polarity)
     char *name;
     TrGraph *tGr[];
     MetalEq *mRou[][MAX_EQ];
     VertSeg sInv, sTrsp;
     short nbCh[];
     char polarity;
{
  register short ind, i = 0;
  char *bloc;
  char sym = NOSYM;
  static short dltCh[2] =
  {-1, -1};
  short cp0ind, cplind, y;

/*
   printf("genPhysic\n");
 */

/* MODIF du 22/01/96 : sinon c4 plante ...
   if ((dltCh[P_GRAPH] != (nbCh[P_GRAPH] - 2))
   && (dltCh[N_GRAPH] != (nbCh[N_GRAPH] - 2)))
 */
  {
    dltCh[P_GRAPH] = nbCh[P_GRAPH] - 2;
    dltCh[N_GRAPH] = nbCh[N_GRAPH] - 2;
    (void) delphfig (L_CELL_IN);
    genLCellIn (dltCh[N_GRAPH], dltCh[P_GRAPH]);
    (void) delphfig (L_CELL_OUT);
    genLCellOut (dltCh[N_GRAPH], dltCh[P_GRAPH]);
    (void) delphfig (L_CELL_INV);
    genLCellInv (dltCh[N_GRAPH], dltCh[P_GRAPH]);
    (void) delphfig (L_CELL_TRSP);
    genLCellTrsp (dltCh[N_GRAPH], dltCh[P_GRAPH]);
  }
  DEF_PHFIG (name);

  ind = 0;
  while (tGr[ind])
    {
      if (tGr[ind]->trName == NULL)
	switch (tGr[ind]->blkType)
	  {
	  case TRSP_BLK:
	    bloc = L_CELL_TRSP;
	    break;
	  case OUT_BLK:
	    bloc = L_CELL_OUT;
	    sym = SYM_X;
	    break;
	  case INV_BLK:
	    bloc = L_CELL_INV;
	    break;
	  }
      else
	bloc = L_CELL_IN;
      if (ind == 0)
	PLACE (bloc, NAME ("%s%d", L_CELL_SYMB, ind), sym, 0, 0);
      else
	PLACE_RIGHT (bloc, NAME ("%s%d", L_CELL_SYMB, ind), sym);
      ind++;
    }
  DEF_AB (0, 0, 0, 0);
  ind = 0;
  while (tGr[ind])
    {
      if ((tGr[ind]->trName == NULL) && (tGr[ind]->blkType == OUT_BLK))
	if (polarity == NEG)
	  {
	    PHCON (ALU2, 2, N_OUT_SYMB, NORTH, 3 + 6 * ind, HEIGHT (name));
	    PHCON (ALU2, 2, N_OUT_SYMB, SOUTH, 3 + 6 * ind, 0);
	  }
	else
	  {
	    PHCON (ALU2, 2, OUT_SYMB, NORTH, 3 + 6 * ind, HEIGHT (name));
	    PHCON (ALU2, 2, OUT_SYMB, SOUTH, 3 + 6 * ind, 0);
	  }
      if (tGr[ind]->trName)
	{
	  PHCON (ALU2, 2, NAME ("%s%d", IN_SYMB, i), NORTH,
		 3 + 6 * ind, HEIGHT (name));
	  PHCON (ALU2, 2, NAME ("%s%d", IN_SYMB, i), SOUTH, 3 + 6 * ind, 0);
	  i++;
	}
      ind++;
    }

  PHCON (ALU1, 8, "vdd", WEST, 0, HEIGHT (name) - 2);
  PHCON (ALU1, 8, "vdd", EAST, 6 * ind, HEIGHT (name) - 2);
  PHCON (ALU1, 8, "vss", WEST, 0, 2);
  PHCON (ALU1, 8, "vss", EAST, 6 * ind, 2);

  PHSEG (ALU1, 8, "", 0, 2, 6 * ind, 2);
  PHSEG (ALU1, 8, "", 0, HEIGHT (name) - 2, 6 * ind, HEIGHT (name) - 2);
  PHSEG (NWELL, 26 + 4 * dltCh[P_GRAPH], "", 0,
	 36 + 4 * dltCh[N_GRAPH] + 4 * dltCh[P_GRAPH] / 2, 6 * ind,
	 36 + 4 * dltCh[N_GRAPH] + (4 * dltCh[P_GRAPH]) / 2);

  for (ind = --ind; ind >= 0; ind--)
    FLATTEN_PHFIG (NAME ("%s%d", L_CELL_SYMB, ind), NO);
  ind = 0;
  while (mRou[N_GRAPH][ind])
    {
      cp0ind = mRou[N_GRAPH][ind]->contPos[0];
      cplind = mRou[N_GRAPH][ind]->contPos[mRou[N_GRAPH][ind]->nbCont - 1];
      if (mRou[N_GRAPH][ind]->noCh == ALIM)
	for (i = 0; i < mRou[N_GRAPH][ind]->nbCont; i++)
	  PHVIA (CONT_DIF_N, 3 + 6 * mRou[N_GRAPH][ind]->contPos[i], 5);
      else if (mRou[N_GRAPH][ind]->noCh != -1)
	{
	  y = 6 + 4 * mRou[N_GRAPH][ind]->noCh;
	  PHSEG (ALU1, 1, "",
		 3 + 6 * (cp0ind < 0 ? -cp0ind - 1 : cp0ind), y,
		 3 + 6 * (cplind < 0 ? -cplind - 1 : cplind), y);
	  for (i = 0; i < mRou[N_GRAPH][ind]->nbCont; i++)
	    if (mRou[N_GRAPH][ind]->contPos[i] >= 0)
	      PHVIA (CONT_DIF_N, 3 + 6 * mRou[N_GRAPH][ind]->contPos[i], y);
	}
      ind++;
    }

  ind = 0;
  while (mRou[P_GRAPH][ind])
    {
      cp0ind = mRou[P_GRAPH][ind]->contPos[0];
      cplind = mRou[P_GRAPH][ind]->contPos[mRou[P_GRAPH][ind]->nbCont - 1];
      if (mRou[P_GRAPH][ind]->noCh == ALIM)
	{
	  y = 37 + 4 * (dltCh[P_GRAPH] + dltCh[N_GRAPH]);
	  for (i = 0; i < mRou[P_GRAPH][ind]->nbCont; i++)
	    PHVIA (CONT_DIF_P, 3 + 6 * mRou[P_GRAPH][ind]->contPos[i], y);
	}
      else if (mRou[P_GRAPH][ind]->noCh != -1)
	{
	  y = 36 + 4 * (dltCh[P_GRAPH] + dltCh[N_GRAPH])
	    - 4 * mRou[P_GRAPH][ind]->noCh;
	  PHSEG (ALU1, 1, "",
		 3 + 6 * (cp0ind < 0 ? -cp0ind - 1 : cp0ind), y,
		 3 + 6 * (cplind < 0 ? -cplind - 1 : cplind), y);
	  for (i = 0; i < mRou[P_GRAPH][ind]->nbCont; i++)
	    if (mRou[P_GRAPH][ind]->contPos[i] >= 0)
	      PHVIA (CONT_DIF_P, 3 + 6 * mRou[P_GRAPH][ind]->contPos[i], y);
	}
      ind++;
    }
  if (sTrsp.xPos != -1)
    PHSEG (ALU1, 1, "", 3 + 6 * sTrsp.xPos, 6 + 4 * sTrsp.y1, 3 + 6 * sTrsp.xPos,
	   36 + 4 * (dltCh[P_GRAPH] + dltCh[N_GRAPH]) - 4 * sTrsp.y2);
  if (sInv.xPos != -1)
    PHSEG (ALU1, 1, "", 3 + 6 * sInv.xPos,
	   (sInv.y1 == -1 ? 19 + 4 * dltCh[N_GRAPH] : 6 + 4 * sInv.y1),
	   3 + 6 * sInv.xPos,
	   (sInv.y2 == -1 ? 19 + 4 * dltCh[N_GRAPH] :
	    36 + 4 * (dltCh[P_GRAPH] + dltCh[N_GRAPH]) - 4 * sInv.y2));
  SAVE_PHFIG ();
}


/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*
  =-=-=-=- low-level func =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-[]=-
  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
  SYNTAX : void genFiles(MemFig *, char, char, char)
  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
  EXEMPLE : genFiles(cell, 1, 1, 1)
  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
  FONCTION : 
  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
  ERROR :
          if cell = NULL.						cont
 *=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

void
genFiles (cell, bFlag, lFlag, pFlag, iFlag)
     MemFig *cell;
     char bFlag, lFlag, pFlag, iFlag;
{
  if (cell == NULL)
    {
      (void) fprintf (stderr, "\nc4_Warning : Input param of genFiles is ");
      (void) fprintf (stderr, "NULL. [genFiles]\n\n");
      return;
    }
  else if (!(cell->status.routeTransOK))
    {
      (void) fprintf (stderr, "\nc4_Warning : routeTrans hasn't ");
      (void) fprintf (stderr, "successfully achieved. [genFiles]\n\n");
      return;
    }

  if (lFlag)
    genLogic (cell->fName, cell->tGraph, cell->result->polarity, cell->nbCh);

  if (pFlag)
    genPhysic (cell->fName, cell->tGraph, cell->mRout, cell->segInv,
	       cell->segTrsp, cell->nbCh, cell->result->polarity);

  if (bFlag)
    {
      cell->beh = genBehave (cell->fName, expr2Model (cell->trExprABL),
			     cell->result->polarity, C4_NBPITCH (cell));
      if (iFlag)
	delicongate ((char *) ICONGATE_MODELNAME (genIcon (cell->beh, 1)));
    }
  else
    cell->beh = NULL;
/*::::::::::::::::::::::::::::: end of genFiles :::::::::::::::::::::::::::::: */
}
