/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 *
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 *
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 *
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Tool    : Logic Synthesis - CMOS Cells Compiler
 * Date    : 1991,92
 * Author  : Nathalie Dictus
 * Modified by Czo <Olivier.Sirol@lip6.fr> 1996,97
 */




#ident  "$Id: c4_icon.c,v 1.1 1997/09/19 15:18:02 sirol Exp sirol $"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include MUT_H
#include ICN_H
#include IAC_H
#include ICU_H

/********************************************************************/
/* not1.c                                                           */
/* generated by icon                                                */
/* on Thu Feb 17 16:57:20 1994                                      */
/* for luc                                                          */
/********************************************************************/

struct IconGate *
not1icon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   360, 0,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   500, -200,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   510, 200,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL);

  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "f",
	      900, 0, SAX_EAST, OUT,
	      SAX_UP, SAX_RIGHT, SAX_HORIZONTAL, 900, -50);
  addiconcon (gate_icon, "i",
	      0, 0, SAX_WEST, IN,
	      SAX_DOWN, SAX_RIGHT, SAX_HORIZONTAL, 0, -50);
  addiconline (gate_icon, 700, 0, 900, 0);
  addiconline (gate_icon, 200, 0, 0, 0);
  addiconline (gate_icon, 200, -200, 600, 0);
  addiconline (gate_icon, 200, 200, 600, 0);
  addiconline (gate_icon, 200, -200, 200, 200);
  addiconcircle (gate_icon, 600, -50, 100, 100);
  update_icon (gate_icon);
  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* np1_y.c                                                          */
/* generated by i2c                                                 */
/* from np1_y                                                       */
/* on Wed Feb  1 12:34:23 1995                                      */
/* for luc                                                          */
/********************************************************************/
struct IconGate *
not1Picon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   360, 0,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   500, -200,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   510, 200,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL);
  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "f",
	      1000, 0, SAX_EAST, OUT,
	      SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL, 1000, -50);
  addiconcon (gate_icon, "i",
	      0, 0, SAX_WEST, IN,
	      SAX_RIGHT, SAX_DOWN, SAX_HORIZONTAL, 0, -50);
  addiconline (gate_icon, 300, 200, 200, 200);
  addiconline (gate_icon, 700, 0, 300, 200);
  addiconline (gate_icon, 300, -200, 700, 0);
  addiconline (gate_icon, 200, -200, 300, -200);
  addiconline (gate_icon, 200, 200, 600, 0);
  addiconline (gate_icon, 800, 0, 1000, 0);
  addiconline (gate_icon, 200, 0, 0, 0);
  addiconline (gate_icon, 200, -200, 600, 0);
  addiconline (gate_icon, 200, -200, 200, 200);
  addiconcircle (gate_icon, 700, -50, 100, 100);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* b1_y.c                                                           */
/* generated by i2c                                                 */
/* from b1_y                                                        */
/* on Wed Feb  1 12:38:29 1995                                      */
/* for luc                                                          */
/********************************************************************/
struct IconGate *
buficon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   360, 0,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   500, -200,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   510, 200,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL);

  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "t",
	      1100, 0, SAX_EAST, OUT,
	      SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL, 1100, -50);
  addiconcon (gate_icon, "i",
	      0, 0, SAX_WEST, IN,
	      SAX_RIGHT, SAX_DOWN, SAX_HORIZONTAL, 0, -50);
  addiconline (gate_icon, 200, 200, 400, 200);
  addiconline (gate_icon, 200, -200, 400, -200);
  addiconline (gate_icon, 800, 0, 1100, 0);
  addiconline (gate_icon, 400, 200, 800, 0);
  addiconline (gate_icon, 300, 200, 700, 0);
  addiconline (gate_icon, 400, -200, 800, 0);
  addiconline (gate_icon, 300, -200, 700, 0);
  addiconline (gate_icon, 200, 0, 0, 0);
  addiconline (gate_icon, 200, -200, 600, 0);
  addiconline (gate_icon, 200, 200, 600, 0);
  addiconline (gate_icon, 200, -200, 200, 200);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* ts_y.c                                                           */
/* generated by i2c                                                 */
/* from ts_y                                                        */
/* on Wed Feb  1 12:42:57 1995                                      */
/* for luc                                                          */
/********************************************************************/
struct IconGate *
bus1icon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   4420, -3950,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL,
			   4200, -5660,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL,
			   4410, -4820,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL);

  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "v",
	      5000, -6000, SAX_NORTH, IN,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, 5000, -6050);
  addiconcon (gate_icon, "t",
	      7200, -4900, SAX_EAST, TRISTATE,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, 7200, -4950);
  addiconcon (gate_icon, "i",
	      2900, -4900, SAX_NORTH, IN,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, 2900, -4950);
  addiconline (gate_icon, 5000, -5470, 5000, -6000);
  addiconline (gate_icon, 6400, -4900, 7200, -4900);
  addiconline (gate_icon, 3700, -4900, 2900, -4900);
  addiconline (gate_icon, 6400, -4900, 3700, -3800);
  addiconline (gate_icon, 3700, -6000, 6400, -4900);
  addiconline (gate_icon, 3700, -6000, 3700, -3800);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* high1.c                                                          */
/* generated by icon                                                */
/* on Thu Feb 17 16:57:14 1994                                      */
/* for luc                                                          */
/********************************************************************/

struct IconGate *
high1icon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   440, 20,
			   SAX_UP, SAX_RIGHT, SAX_HORIZONTAL,
			   -60, -880,
			   SAX_UP, SAX_RIGHT, SAX_HORIZONTAL,
			   260, -60,
			   SAX_UP, SAX_RIGHT, SAX_HORIZONTAL);

  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "t",
	      400, -500, SAX_EAST, OUT,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 400, -550);
  addiconline (gate_icon, 200, -500, 400, -500);
  addiconline (gate_icon, 200, -700, -200, -700);
  addiconline (gate_icon, 200, -300, 200, -700);
  addiconline (gate_icon, -200, -300, 200, -300);
  addiconline (gate_icon, -200, -700, -200, -300);
  addiconline (gate_icon, -100, -400, 100, -400);
  addiconline (gate_icon, 0, -600, -100, -500);
  addiconline (gate_icon, 0, -600, 0, -400);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* low1.c                                                           */
/* generated by icon                                                */
/* on Thu Feb 17 16:57:13 1994                                      */
/* for luc                                                          */
/********************************************************************/

struct IconGate *
low1icon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   290, 210,
			   SAX_UP, SAX_RIGHT, SAX_HORIZONTAL,
			   -120, -280,
			   SAX_UP, SAX_RIGHT, SAX_HORIZONTAL,
			   -30, 320,
			   SAX_UP, SAX_RIGHT, SAX_HORIZONTAL);
  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "f",
	      400, 0, SAX_EAST, OUT,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 400, -50);
  addiconline (gate_icon, 100, -100, -100, 100);
  addiconline (gate_icon, 200, 0, 400, 0);
  addiconline (gate_icon, 200, -200, -200, -200);
  addiconline (gate_icon, 200, 200, 200, -200);
  addiconline (gate_icon, -200, 200, 200, 200);
  addiconline (gate_icon, -200, -200, -200, 200);
  addiconcircle (gate_icon, -100, -100, 200, 200);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* tie.c                                                            */
/* generated by icon                                                */
/* on Thu Feb 17 17:00:51 1994                                      */
/* for luc                                                          */
/********************************************************************/

struct IconGate *
tieicon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   0, 0,
			   SAX_UP, SAX_LEFT, SAX_HORIZONTAL,
			   200, -1000,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   200, -800,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL);
  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "vss",
	      200, 100, SAX_SOUTH, UNKNOWN,
	      SAX_CENTER, SAX_RIGHT, SAX_VERTICAL, 200, 0);
  addiconcon (gate_icon, "vdd",
	      200, -1800, SAX_NORTH, UNKNOWN,
	      SAX_CENTER, SAX_LEFT, SAX_VERTICAL, 200, -1730);
  addiconline (gate_icon, 200, -50, 200, 100);
  addiconline (gate_icon, 200, -1650, 200, -1800);
  addiconline (gate_icon, 400, 0, 0, 0);
  addiconline (gate_icon, 400, -1700, 400, 0);
  addiconline (gate_icon, 0, -1700, 400, -1700);
  addiconline (gate_icon, 0, 0, 0, -1700);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* latch1.c                                                         */
/* generated by icon                                                */
/* on Thu Feb 17 16:57:18 1994                                      */
/* for luc                                                          */
/********************************************************************/

struct IconGate *
latch1icon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   300, -100,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   150, -700,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   300, 200,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL);
  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "i",
	      -200, -300, SAX_WEST, IN,
	      SAX_DOWN, SAX_RIGHT, SAX_HORIZONTAL, -200, -350);
  addiconcon (gate_icon, "l",
	      300, -800, SAX_NORTH, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 300, -850);
  addiconcon (gate_icon, "t",
	      800, -300, SAX_EAST, OUT,
	      SAX_UP, SAX_RIGHT, SAX_HORIZONTAL, 800, -350);
  addiconline (gate_icon, 300, -800, 300, -600);
  addiconline (gate_icon, 0, -300, -200, -300);
  addiconline (gate_icon, 300, -300, 600, -600);
  addiconline (gate_icon, 0, -600, 300, -300);
  addiconline (gate_icon, 800, -300, 600, -300);
  {
    IconComp_list *components;

    components = NULL;
    components = addiconcomp (components, COMP_ISLINE, 0, 0);
    components = addiconcomp (components, COMP_ISLINE, 600, 0);
    components = addiconcomp (components, COMP_ISLINE, 600, -600);
    components = addiconcomp (components, COMP_ISLINE, 0, -600);
    addiconshape (gate_icon, components);
  }
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* latch1n.c                                                        */
/* generated by icon                                                */
/* on Thu Feb 17 16:57:17 1994                                      */
/* for luc                                                          */
/********************************************************************/

struct IconGate *
latch1nicon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   300, -100,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   150, -700,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   300, 200,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL);

  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "f",
	      850, -300, SAX_EAST, OUT,
	      SAX_UP, SAX_RIGHT, SAX_HORIZONTAL, 850, -350);
  addiconcon (gate_icon, "i",
	      -200, -300, SAX_WEST, IN,
	      SAX_DOWN, SAX_RIGHT, SAX_HORIZONTAL, -200, -350);
  addiconcon (gate_icon, "l",
	      300, -800, SAX_NORTH, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 300, -850);
  addiconline (gate_icon, 700, -300, 850, -300);
  addiconline (gate_icon, 300, -800, 300, -600);
  addiconline (gate_icon, 0, -300, -200, -300);
  addiconline (gate_icon, 300, -300, 600, -600);
  addiconline (gate_icon, 0, -600, 300, -300);
  {
    IconComp_list *components;

    components = NULL;
    components = addiconcomp (components, COMP_ISLINE, 0, 0);
    components = addiconcomp (components, COMP_ISLINE, 600, 0);
    components = addiconcomp (components, COMP_ISLINE, 600, -600);
    components = addiconcomp (components, COMP_ISLINE, 0, -600);
    addiconshape (gate_icon, components);
  }
  addiconcircle (gate_icon, 600, -350, 100, 100);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* latch2.c                                                         */
/* generated by icon                                                */
/* on Thu Feb 17 16:57:16 1994                                      */
/* for luc                                                          */
/********************************************************************/

struct IconGate *
latch2icon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   300, -100,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   140, -710,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   320, 90,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL);

  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "t",
	      800, -500, SAX_EAST, OUT,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 800, -550);
  addiconcon (gate_icon, "l1",
	      400, -800, SAX_NORTH, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 400, -850);
  addiconcon (gate_icon, "i1",
	      -200, -100, SAX_WEST, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, -200, -150);
  addiconcon (gate_icon, "l0",
	      200, -800, SAX_NORTH, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 200, -850);
  addiconcon (gate_icon, "i0",
	      -200, -500, SAX_WEST, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, -200, -550);
  addiconline (gate_icon, 800, -500, 600, -500);
  addiconline (gate_icon, 200, -800, 200, -600);
  addiconline (gate_icon, 300, -300, 600, -600);
  addiconline (gate_icon, 0, -600, 300, -300);
  addiconline (gate_icon, -200, -100, 0, -100);
  addiconline (gate_icon, 400, -600, 400, -800);
  addiconline (gate_icon, 0, -500, -200, -500);
  {
    IconComp_list *components;

    components = NULL;
    components = addiconcomp (components, COMP_ISLINE, 0, 0);
    components = addiconcomp (components, COMP_ISLINE, 600, 0);
    components = addiconcomp (components, COMP_ISLINE, 600, -600);
    components = addiconcomp (components, COMP_ISLINE, 0, -600);
    addiconshape (gate_icon, components);
  }
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* latch2n.c                                                        */
/* generated by icon                                                */
/* on Thu Feb 17 16:57:15 1994                                      */
/* for luc                                                          */
/********************************************************************/

struct IconGate *
latch2nicon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   300, -100,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   140, -710,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL,
			   320, 90,
			   SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL);
  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "f",
	      950, -500, SAX_EAST, OUT,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 950, -550);
  addiconcon (gate_icon, "l1",
	      400, -800, SAX_NORTH, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 400, -850);
  addiconcon (gate_icon, "i1",
	      -200, -100, SAX_WEST, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, -200, -150);
  addiconcon (gate_icon, "l0",
	      200, -800, SAX_NORTH, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, 200, -850);
  addiconcon (gate_icon, "i0",
	      -200, -500, SAX_WEST, IN,
	      SAX_CENTER, SAX_RIGHT, SAX_HORIZONTAL, -200, -550);
  addiconline (gate_icon, 700, -500, 910, -500);
  addiconline (gate_icon, 200, -800, 200, -600);
  addiconline (gate_icon, 300, -300, 600, -600);
  addiconline (gate_icon, 0, -600, 300, -300);
  addiconline (gate_icon, -200, -100, 0, -100);
  addiconline (gate_icon, 400, -600, 400, -800);
  addiconline (gate_icon, 0, -500, -200, -500);
  {
    IconComp_list *components;

    components = NULL;
    components = addiconcomp (components, COMP_ISLINE, 0, 0);
    components = addiconcomp (components, COMP_ISLINE, 600, 0);
    components = addiconcomp (components, COMP_ISLINE, 600, -600);
    components = addiconcomp (components, COMP_ISLINE, 0, -600);
    addiconshape (gate_icon, components);
  }
  addiconcircle (gate_icon, 600, -550, 100, 100);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* ms_y.c                                                           */
/* generated by i2c                                                 */
/* from ms_y                                                        */
/* on Wed Feb  1 12:52:35 1995                                      */
/* for luc                                                          */
/********************************************************************/
struct IconGate *
bd1icon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   380, -380,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL,
			   370, -970,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL,
			   280, 110,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL);

  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "l",
	      300, -1100, SAX_NORTH, IN,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, 300, -1150);
  addiconcon (gate_icon, "i",
	      -200, -500, SAX_WEST, IN,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, -200, -550);
  addiconcon (gate_icon, "t",
	      800, -500, SAX_EAST, OUT,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, 800, -550);
  addiconline (gate_icon, -200, -500, 0, -500);
  addiconline (gate_icon, 300, -200, 400, -300);
  addiconline (gate_icon, 200, -300, 300, -200);
  addiconline (gate_icon, 300, -100, 400, -100);
  addiconline (gate_icon, 300, -400, 300, -100);
  addiconline (gate_icon, 0, -900, 0, 0);
  addiconline (gate_icon, 600, 0, 600, -900);
  addiconline (gate_icon, 0, 0, 600, 0);
  addiconline (gate_icon, 300, -900, 300, -1100);
  addiconline (gate_icon, 600, -500, 800, -500);
  addiconline (gate_icon, 200, -400, 300, -400);
  addiconline (gate_icon, 300, -500, 600, -900);
  addiconline (gate_icon, 0, -900, 300, -500);
  addiconline (gate_icon, 300, -700, 0, -900);
  addiconline (gate_icon, 300, -700, 600, -900);
  addiconline (gate_icon, 0, -900, 600, -900);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}

/********************************************************************/
/* msn_y.c                                                          */
/* generated by i2c                                                 */
/* from msn_y                                                       */
/* on Wed Feb  1 12:52:47 1995                                      */
/* for luc                                                          */
/********************************************************************/
struct IconGate *
bd1nicon (name, store_it)
     char *name;
     int store_it;		/* 1 if the gate's icon have to be stored, 0 else */
{
  struct IconGate *gate_icon;

  gate_icon = addicongate (name,
			   380, -380,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL,
			   370, -970,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL,
			   280, 110,
			   SAX_LEFT, SAX_DOWN, SAX_HORIZONTAL);

  if (!gate_icon)
    return geticongate (name);

  addiconcon (gate_icon, "f",
	      800, -500, SAX_EAST, OUT,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, 800, -550);
  addiconcon (gate_icon, "l",
	      300, -1100, SAX_NORTH, IN,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, 300, -1150);
  addiconcon (gate_icon, "i",
	      -200, -500, SAX_WEST, IN,
	      SAX_CENTER, SAX_DOWN, SAX_HORIZONTAL, -200, -550);
  addiconline (gate_icon, 700, -500, 800, -500);
  addiconline (gate_icon, -200, -500, 0, -500);
  addiconline (gate_icon, 300, -200, 400, -300);
  addiconline (gate_icon, 200, -300, 300, -200);
  addiconline (gate_icon, 300, -100, 400, -100);
  addiconline (gate_icon, 300, -400, 300, -100);
  addiconline (gate_icon, 0, -900, 0, 0);
  addiconline (gate_icon, 600, 0, 600, -900);
  addiconline (gate_icon, 0, 0, 600, 0);
  addiconline (gate_icon, 300, -900, 300, -1100);
  addiconline (gate_icon, 200, -400, 300, -400);
  addiconline (gate_icon, 300, -500, 600, -900);
  addiconline (gate_icon, 0, -900, 300, -500);
  addiconline (gate_icon, 300, -700, 0, -900);
  addiconline (gate_icon, 300, -700, 600, -900);
  addiconline (gate_icon, 0, -900, 600, -900);
  addiconcircle (gate_icon, 600, -550, 100, 100);
  update_icon (gate_icon);

  if (store_it)
    saveicon (gate_icon);

  return gate_icon;
}
