/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 *
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 *
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 *
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Tool    : Logic Synthesis - parameter file
 * Date    : 1991,92
 * Author  : Luc Burgun
 * Modified by Czo <Olivier.Sirol@lip6.fr> 1996,97
 */



/* $Id: lax_param.h,v 1.1 1997/09/19 15:18:02 sirol Exp sirol $ */

#ifndef LAX_PARAM_H
#define LAX_PARAM_H

typedef struct toto_param
  {
    int mode;
    int level;
    chain_list *intermediate;
    ptype_list *delayPI;
    chain_list *earlyPO;
    int numTransN, numTransP;
    long maxSlopeTime;
    ptype_list *impedancePI;
    ptype_list *capaPO;
    ptype_list *capaPI;
    ptype_list *buffPI;
    int aux;
  }
param;

#ifndef __P
# ifdef __STDC__ || __GNUC__
#  define __P(x) x
# else
#  define __P(x) ()
# endif
#endif

extern char *parseName __P ((char *VHDL_name));
extern char *driveName __P ((char *IO_name));
extern param *loadParam __P ((char *FileName));
extern void saveParam __P ((param * saveparam, char *FileName));
extern void resetParam __P ((param * par));

#endif
