/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 *
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 *
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 *
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Tool    : Logic Synthesis - Netlist Optimisation
 * Date    : 1991,92
 * Author  : Nathalie Dictus
 * Modified by Czo <Olivier.Sirol@lip6.fr> 1996,97
 */



#ident  "$Id: netop_main.c,v 1.3 1997/10/06 16:57:40 sirol Exp sirol $"

#include <stdio.h>
#include <stdlib.h>
#include MUT_H
#include BEH_H
#include MLO_H
#include MPH_H
#include LOG_H

#include "lax_param.h"
#include "sl_local.h"
#include "mapping_local.h"
#include "netop_local.h"


/*
 * y en a qui vont rigoler en voyant ce source.
 * j'ai fait de mon mieux pour essayer de debugger
 * tout ca, mais il faudrait des annees!
 * le mieux serait sans doute de tout reecrire.
 * 
 *                                            Czo.
 */



char *GLOB_ABL_DC;
char *GLOB_ABL_ONE;
char *GLOB_ABL_ZERO;

no_system *no_sys;


/*----------------------------------------------------------------------------*/
int
main (argc, argv)
     int argc;
     char *argv[];
{
  /* initialisation des variables d'evironnement */
  mbkenv ();
  alliancebanner ("GlOp", NETOP_VERSION, "Gate Level OPtimizer", "1990", ALLIANCE_VERSION);

  GLOB_ABL_DC = namealloc ("'d'");
  GLOB_ABL_ONE = namealloc ("'1'");
  GLOB_ABL_ZERO = namealloc ("'0'");

  /* verification de la validite des arguments */
  if (!net_verifArgs (argc, argv))
    exit (-1); 

  /* initialisation selon le mode (batch ou non) */
  if (!strcmp (argv[1], "-f") || !strcmp (argv[1], "-t") ||
      !strcmp (argv[1], "-g") || !strcmp (argv[1], "-i"))
    {
      /* Mode BATCH */
      /* initialisation du systeme */
      char *nameNETO = mbkalloc (30 + strlen (NETOP_VERSION));
      sprintf (nameNETO, "Netlist Optimization - V %s", NETOP_VERSION);

      no_sys = initializeNOSystem ();
      majNOSystem (no_sys, 1, argc, argv, nameNETO);

      net_displaySystem (no_sys);

      NOT1 = namealloc ("not1");

      /* chargement du systeme : netlist + cellules */
      no_sys->log = initializeNet ();
      if (!no_sys->log)
	exit (1);

      if (NO_OPTION == 'g')
	OPTIMISATION_GLOBALE ();
      else if (NO_OPTION == 'f')
	OPTIMISATION_LOCALE ();
      else if (NO_OPTION == 't')
	INFORMATION ('t');
      else if (NO_OPTION == 'i')
	INFORMATION ('f');

    }
  else
    {
	printf ("\nUsage :\n");
	printf ("\tglop -option <file_entity> <file_output> [<file_par>]\n\n");
	printf ("\toption    : -f   local optimization with max fanout\n");
	printf ("\t            -g   global optimization with timing analysis\n");
	printf ("\t            -a   local optimization for AsGa\n");
	printf ("\t            -t   timing informations\n");
	printf ("\t            -i   fanout informations\n");
	exit (-1);
    }

/* cellEnd(); */
  exit (0);
}
